      PROGRAM REGRES
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER  FIN*40,FOUT*40,HEAD*80
C
C  THIS PROGRAM IS CAPABLE OF MULTIPLE RUNS.  LEAVE NO BLANK LINES BETWEEN
C  DATA SETS SINCE THE FIRST LINE FOLLOWING THE LAST DATA ENTRY MAY BE
C  READ AS A BLANK PROBLEM HEAD FOR THE NEXT DATA SET.  THIS PROGRAM ALSO
C  OBTAINS THE LOWER QUARTILE, MEDIAN AND UPPER QUARTILE RESIDUAL VALUES
C  OF EACH GROUP.
C
      WRITE(*,1000) '*** PROGRAM REGRES ***'
 1000 FORMAT(/,T18,A)
      WRITE(*,1100) 'PROGRAM REGRES COMPUTES MRPP ANALYSES ',
     +              'OF LAD RESIDUAL DATA','OF AN ',
     +              'EXISTING DATA SET, USING THE ACM ALGORITHM ',
     +              'NUMBER 478.','PRESENT MAXIMUMS FOR M AND N ARE:',
     +              'M = 200 OBSERVATIONS,',
     +              'N = 20 INDEPENDENT VARIABLES.',
     +              'RESULTS OF PROGRAM ARE IN NAMED OUTPUT FILE.',
     +              'NOTE THAT THE DEPENDENT VARIABLE (Y) MUST BE ',
     +              'THE LAST VARIABLE','(THAT IS THE RIGHT-MOST ',
     +              'VARIABLE) IN THE DATA SET.'
 1100 FORMAT(1(/),T2,A,A,/,T2,A,A,A,/,T2,A,/,T10,A,/,
     +   T10,A,/,T2,A,/,T2,A,A,/,T2,A,A,/)
 1200 FORMAT(A)
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA'
      READ(*,1200) FIN
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS'
      READ(*,1200) FOUT
      TOLER = 1.0D-9
      WRITE(*,1300) 'TOLERANCE = ', TOLER
 1300 FORMAT(T10,A,E10.4)
      OPEN(4,FILE=FIN)
      OPEN(7,FILE=FOUT,STATUS='NEW')
 1500 READ(4,1200,END=1600) HEAD
      GO TO 1800
 1600 GO TO 2000
 1800 CALL LEAST(TOLER,HEAD)
      GO TO 1500
 2000 CLOSE(4)
      CLOSE(7)
      END
C
C
      SUBROUTINE LEAST(TOLER,HEAD)
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER  HEAD*80
      INTEGER    CFORM
      DIMENSION  X(20),E(200),B(200),LS(200),ITHGRP(60),W(200),
     +           Y(60,3),A(202,22),DATA(200,2)
C
      READ(4,*) M,N,NGRPS,(ITHGRP(I),I = 1,NGRPS)
      IF(M.LT.6) STOP 'TOTAL NUMBER OF CASES < 6'
      READ(4,*) ((A(I,J),J = 1,N+1),I = 1,M)
      DO 1000 I = 1,M
         B(I) = A(I,N+1)
 1000 CONTINUE
      WRITE(7,1100) HEAD
 1100 FORMAT(A)
      WRITE(7,1400)
 1400 FORMAT(T20,'*** OUTPUT OF REGRES ANALYSIS ***',/)
      IF(N.EQ.0) THEN
         SUMRE = 0.0D0
         DO 1500 I = 1,M
            E(I) = A(I,1)
            SUMRE = SUMRE+DABS(E(I))
 1500    CONTINUE
         GO TO 1950
      END IF
C
      CALL L1(M,N,A,B,TOLER,X,E,LS)
C
      DO 1700 I = 1,N
         WRITE(7,1600) 'LAD REGRESSION COEFFICIENT',I,' = ',X(I)
 1600    FORMAT(T5,A,I2,A,G15.8)
 1700 CONTINUE
      IRANK = A(M+1,N+2)
      ITER = A(M+2,N+2)
      IEXCODE = A(M+2,N+1)
      SUMRE = A(M+1,N+1)
      WRITE(7,1800) IRANK,ITER,IEXCODE
 1800 FORMAT(/,T5,'MATRIX RANK = ',I3,/,T5,'ITERATIONS =  ',I3,/,T5,
     +   'EXIT CODE =   ',I3)
      WRITE(7,1900) 'NOTE: EXIT CODE 0 INDICATES A NON-UNIQUE ',
     +   'SOLUTION.','NOTE: EXIT CODE 1 INDICATES A SUCCESSFUL ',
     +   'SOLUTION.','NOTE: EXIT CODE 2 INDICATES ROUNDING ERRORS.'
 1900 FORMAT(/,T5,A,A,/,T5,A,A,/,T5,A)
 1950 WRITE(7,2000) M,N,SUMRE
 2000 FORMAT(/,T5,'TOTAL OBSERVATIONS = ',I3,/,T5,'INDEPENDENT',
     +   ' VARIABLES = ',I2,/,T5,'SUM OF ABSOLUTE VALUES OF THE',
     +   ' RESIDUALS = ',G15.8,/)
C
      DO 2100 I = 1,M
         DATA(I,1) = E(I)
 2100 CONTINUE
C
      DO 2200 J = 1,ITHGRP(1)
         W(J) = E(J)
 2200 CONTINUE
      CALL MED(ITHGRP(1),Y(1,1),Y(1,2),Y(1,3),W)
      KC = ITHGRP(1)
      DO 2400 I = 2,NGRPS
         DO 2300 J = KC+1,KC+ITHGRP(I)
            W(J-KC) = E(J)
 2300    CONTINUE
         CALL MED(ITHGRP(I),Y(I,1),Y(I,2),Y(I,3),W)
         KC = KC+ITHGRP(I)
 2400 CONTINUE
C
      ID = 1
      V = 1.0D0
      SUP = 1.0D50
      CFORM = 1
      CALL MRPP3(M,ID,V,SUP,CFORM,NGRPS,ITHGRP,Y,DATA)
C
      RETURN
      END
C
C
      SUBROUTINE L1(M,N,A,B,TOLER,X,E,LS)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  A(202,22),X(20),E(200),B(200),LS(200)
      LOGICAL  STAGE,TEST
      DATA  BIG/1.0D200/
C
      ZERO = 0.0D0
      ONE = 1.0D0
      TWO = 2.0D0
      M1 = M+1
      N1 = N+1
      M2 = M+2
      N2 = N+2
      DO 10 J = 1,N
         A(M2,J) = J
         X(J) = ZERO
 10   CONTINUE
      DO 40 I = 1,M
         A(I,N2) = N+I
         A(I,N1) = B(I)
         IF(B(I).GE.ZERO) GO TO 30
         DO 20 J = 1,N2
            A(I,J) = -A(I,J)
 20      CONTINUE
 30      E(I) = ZERO
 40   CONTINUE
C
      DO 60 J = 1,N1
         SUM = ZERO
         DO 50 I = 1,M
            SUM = SUM+A(I,J)
 50      CONTINUE
         A(M1,J) = SUM
 60   CONTINUE
C
      STAGE = .TRUE.
      KOUNT = 0
      KR = 1
      KL = 1
 70   AMAX = -ONE
      DO 80 J = KR,N
         IF(DABS(A(M2,J)).GT.N) GO TO 80
         D = DABS(A(M1,J))
         IF(D.LE.AMAX) GO TO 80
         AMAX = D
         IN = J
 80   CONTINUE
      IF(A(M1,IN).GE.ZERO) GO TO 100
      DO 90 I = 1,M2
         A(I,IN) = -A(I,IN)
 90   CONTINUE
C
 100  K = 0
      DO 110 I = KL,M
         D = A(I,IN)
         IF(D.LE.TOLER) GO TO 110
         K = K+1
         B(K) = A(I,N1)/D
         LS(K) = I
         TEST = .TRUE.
 110  CONTINUE
 120  IF(K.GT.0) GO TO 130
      TEST = .FALSE.
      GO TO 150
 130  AMIN = BIG
      DO 140 I = 1,K
         IF(B(I).GE.AMIN) GO TO 140
         J = I
         AMIN = B(I)
         IOUT = LS(I)
 140  CONTINUE
      B(J) = B(K)
      LS(J) = LS(K)
      K = K-1
C
 150  IF(TEST.OR..NOT.STAGE) GO TO 170
      DO 160 I = 1,M2
         D = A(I,KR)
         A(I,KR) = A(I,IN)
         A(I,IN) = D
 160  CONTINUE
      KR = KR+1
      GO TO 260
 170  IF(TEST) GO TO 180
      A(M2,N1) = TWO
      GO TO 350
 180  PIVOT = A(IOUT,IN)
      IF(A(M1,IN)-PIVOT-PIVOT.LE.TOLER) GO TO 200
      DO 190 J = KR,N1
         D = A(IOUT,J)
         A(M1,J) = A(M1,J)-D-D
         A(IOUT,J) = -D
 190  CONTINUE
      A(IOUT,N2) = -A(IOUT,N2)
      GO TO 120
C
 200  DO 210 J = KR,N1
         IF(J.EQ.IN) GO TO 210
         A(IOUT,J) = A(IOUT,J)/PIVOT
 210  CONTINUE
      DO 220 J = KR,N1
         IF(J.EQ.IN) GO TO 220
         CALL COL(A(1,J),A(1,IN),A(IOUT,J),M1,IOUT)
 220  CONTINUE
      DO 240 I = 1,M1
         IF(I.EQ.IOUT) GO TO 240
         A(I,IN) = -A(I,IN)/PIVOT
 240  CONTINUE
      A(IOUT,IN) = ONE/PIVOT
      D = A(IOUT,N2)
      A(IOUT,N2) = A(M2,IN)
      A(M2,IN) = D
      KOUNT = KOUNT+1
      IF(.NOT.STAGE) GO TO 270
C
      KL = KL+1
      DO 250 J = KR,N2
         D = A(IOUT,J)
         A(IOUT,J) = A(KOUNT,J)
         A(KOUNT,J) = D
 250  CONTINUE
 260  IF(KOUNT+KR.NE.N1) GO TO 70
C
      STAGE = .FALSE.
C
 270  AMAX = -BIG
      DO 290 J = KR,N
         D = A(M1,J)
         IF(D.GE.ZERO) GO TO 280
         IF(D.GT.-TWO) GO TO 290
         D = -D-TWO
 280  IF(D.LE.AMAX) GO TO 290
      AMAX = D
      IN = J
 290  CONTINUE
      IF(AMAX.LE.TOLER) GO TO 310
      IF(A(M1,IN).GT.ZERO) GO TO 100
      DO 300 I = 1,M2
         A(I,IN) = -A(I,IN)
 300  CONTINUE
      A(M1,IN) = A(M1,IN)-TWO
      GO TO 100
C
 310  L = KL-1
      DO 330 I = 1,L
         IF(A(I,N1).GE.ZERO) GO TO 330
         DO 320 J = KR,N2
            A(I,J) = -A(I,J)
 320     CONTINUE
 330  CONTINUE
      A(M2,N1) = ZERO
      IF(KR.NE.1) GO TO 350
      DO 340 J = 1,N
         D = DABS(A(M1,J))
         IF(D.LE.TOLER.OR.TWO-D.LE.TOLER) GO TO 350
 340  CONTINUE
      A(M2,N1) = ONE
 350  DO 380 I = 1,M
         K = A(I,N2)
         D = A(I,N1)
         IF(K.GT.0) GO TO 360
         K = -K
         D = -D
 360  IF(I.GE.KL) GO TO 370
      X(K) = D
      GO TO 380
 370  K = K-N
      E(K) = D
 380  CONTINUE
      A(M2,N2) = KOUNT
      A(M1,N2) = N1-KR
      SUM = ZERO
      DO 390 I = KL,M
         SUM = SUM+A(I,N1)
 390  CONTINUE
      A(M1,N1) = SUM
      RETURN
      END
C
C
      SUBROUTINE COL(V1,V2,AMLT,M1,IOUT)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  V1(M1),V2(M1)
C
      DO 10 I = 1,M1
         IF(I.EQ.IOUT) GO TO 10
         V1(I) = V1(I)-V2(I)*AMLT
  10  CONTINUE
      RETURN
      END
C
C
      SUBROUTINE MED(N,Y1,Y2,Y3,X)
      IMPLICIT REAL*8(A-H,O-Z)
C
C  THIS SUBROUTINE OBTAINS THE LOWER QUARTILE, MEDIAN AND UPPER QUARTILE
C  VALUES FOR UNIVARIATE DATA WHERE THE DATA SET'S SIZE IS AT LEAST TWO.
C
      DIMENSION  X(200)
C
      J = N
      K = J/2+1
   10 K = K-1
      W = X(K)
      GO TO 30
   20 W = X(J)
      X(J) = X(1)
      J = J-1
   30 II = K
   40 L = 2*II
      IF(L-J) 50,60,70
   50 IF(X(L+1).GE.X(L)) L = L+1
   60 IF(W.GE.X(L)) GO TO 70
      X(II) = X(L)
      II = L
      GO TO 40
   70 X(II) = W
      IF(K.GT.1) GO TO 10
      IF(J.GE.2) GO TO 20
      K1 = IDINT(0.25D0*N+0.5D0)
      Y1 = X(K1)
      K2 = IDINT(0.5D0*N+0.51D0)
      Y2= X(K2)
      L2= N/2
      IF(K2.EQ.L2) Y2 = (X(K2)+X(K2+1))/2
      K3 = IDINT(0.75D0*N+0.5D0)
      Y3 = X(K3)
      RETURN
      END
C
C
      SUBROUTINE MRPP3(NCASES,ID,V,SUP,CFORM,NGRPS,ITHGRP,Y,DATA)
      IMPLICIT REAL*8(A-H,O-Z)
C
C         THE TEST STATISTIC ASSOCIATED WITH MULTI-RESPONSE PERMUTATION
C         PROCEDURES (MRPP3) IS CALCULATED IN THIS FORTRAN-77 PROGRAM.
C         THIS TEST IS DESIGNED TO ANALYZE MULTI-RESPONSE DATA AT
C         THE ORDINAL (OR HIGHER) LEVELS AND IS BASED ON THE AVERAGE
C         EUCLIDEAN DISTANCE BETWEEN OBJECT POSITIONS WITHIN A PRIORI
C         DISJOINT GROUPS OF OBJECTS IN A FINITE POPULATION WHERE
C         EACH POSITION IS A POINT IN AN R-DIMENSIONAL SPACE (THUS
C         THE ARGUMENTS OF EACH R-DIMENSIONAL POINT CORRESPOND TO
C         THE R MEASURED RESPONSES OF EACH OBJECT IN THE FINITE POPULATION
C         OF OBJECTS).  THIS PROGRAM ALSO CONTAINS THE TRUNCATED DISTANCE
C         OPTION (THE UPPER TRUNCATION CONSTANT IS TERMED SUP).  THE
C         PRESENT MAXIMUM VALUES OF G, N AND R IN THIS PROGRAM ARE
C         RESPECTIVELY 60, 200 AND 1.
C
C         PROGRAM MODIFIED 8/29/97
C
C       EITHER OF THE FOUR FOLLOWING WEIGHTING FORMS MAY BE CHOSEN.
C            CFORM = 1:  C(I) = n(I)/sum(n(I))
C            CFORM = 2:  C(I) = (n(I)-1)/sum(n(I)-1)
C            CFORM = 3:  C(I) = 1/sum(1)
C            CFORM = 4:  C(I) = n(I)*(n(I)-1)/sum(n(I)*(n(I)-1))
C       CFORM IS PASSED AS THE FOURTH PARAMETER ON THE SECOND RECORD
C       IN THE DATA FILE.  WEIGHTS FOR EACH GROUP ARE CALCULATED IN
C       SUBROUTINE DIST, AND STORED IN ARRAY C(I).
C
      DIMENSION  C(60),ITHGRP(60),XI(60),DATA(200,2),Y(60,3)
      INTEGER  CFORM
C
      ONE = 1.0D0
  100 FORMAT(A)
      L = 1
      M = ITHGRP(L)
      DO 160 I = 1,NCASES
  140    IF(I.LE.M) GO TO 150
         L = L+1
         IF(L.LE.NGRPS) THEN
            M = M+ITHGRP(L)
         ELSE
            M = NCASES
         END IF
         GO TO 140
  150    DATA(I,ID+1) = ONE*L
  160 CONTINUE
      CALL DIST(NCASES,ID,V,SUP,CFORM,NGRPS,ITHGRP,DATA,C,XI,
     +   DBAR,D1,VAR,T,GAM1,PROB)
      RHO = 1.0D0-DBAR/D1
      WRITE(7,1100) 'MRPP ANALYSES FOR REGRESSION RESIDUAL DATA'
 1100 FORMAT(/,T16,A,/)
      WRITE(7,1200) 'INPUT HAS ', NCASES,' OBSERVATIONS'
 1200 FORMAT(T10,A,I3,A)
      WRITE(7,1200) 'THERE WERE', ID, ' DIMENSION(S)'
      WRITE(7,1300) 'IN: ', NGRPS, ' GROUPS OF SIZES ',
     +              (ITHGRP(I),I = 1,NGRPS)
 1300 FORMAT(T10,A,I5,A,10I5)
      GO TO (1410,1420,1430,1440) CFORM
 1410 WRITE(7,1450) 'C(I) = n(I)/sum(n(I))'
      GO TO 1500
 1420 WRITE(7,1450) 'C(I) = (n(I)-1)/sum(n(I)-1)'
      GO TO 1500
 1430 WRITE(7,1450) 'C(I) = 1/sum(1)'
      GO TO 1500
 1440 WRITE(7,1450) 'C(I) = n(I)*(n(I)-1)/sum(n(I)*(n(I)-1))'
 1450 FORMAT(T10,A)
 1500 WRITE(7,100) ' '
      DO 1700 I = 1,NGRPS
         WRITE(7,1600) 'GROUP NUMBER ', I, ' OF SIZE ', ITHGRP(I),
     +                 ' HAS AN AVERAGE DISTANCE = ',XI(I)
 1600    FORMAT(T10,A,I2,A,I3,A,G16.8)
 1700 CONTINUE
      WRITE(7,100) ' '
 1800 FORMAT(T10,A,G16.8)
      WRITE(7,1800) 'THE TEST STATISTIC IS =', T
      WRITE(7,1800) 'THE DISTANCE EXPONENT =', V
      WRITE(7,1800) 'THE UPPER BOUND VALUE =', SUP
      WRITE(7,1800) 'THE OBSERVED DELTA IS =', DBAR
      WRITE(7,1800) 'THE EXPECTED DELTA IS =', D1
      WRITE(7,1800) 'THE VARIANCE OF DELTA =', VAR
      WRITE(7,1800) 'THE SKEWNESS OF DELTA =', GAM1
      WRITE(7,1800) 'THE AGREEMENT MEASURE =', RHO
      WRITE(7,1800) 'P-VALUE OF A SMALLER OR EQUAL DELTA =', PROB
      WRITE(7,1900) 'LOWER, MIDDLE AND UPPER QUARTILE VALUES:'
 1900 FORMAT(T5,A)
      DO 2100 I = 1,NGRPS
         WRITE(7,2000) 'LOWER QUARTILE OF GROUP',I,' = ',Y(I,1)
         WRITE(7,2000) 'MEDIAN VALUE OF GROUP  ',I,' = ',Y(I,2)
         WRITE(7,2000) 'UPPER QUARTILE OF GROUP',I,' = ',Y(I,3)
 2000    FORMAT(T10,A,I3,A,G16.8)
 2100 CONTINUE
      WRITE(7,2200)
 2200 FORMAT('********************************************************')
      RETURN
      END
C
C
      SUBROUTINE DIST(NCASES,ID,V,SUP,CFORM,NGRPS,ITHGRP,DATA,C,XI,
     +   DBAR,D1,VAR,T,GAM1,PROB)
      IMPLICIT REAL*8(A-H,O-Z)
C
C         SUBROUTINE DIST CALCULATES THE DISTANCES BETWEEN THE DATA
C         POINTS, PLUS THE PARAMETERS WHICH ARE DIRECTLY DEPENDENT
C         ON THE DISTANCES.
C
      DIMENSION  B(12),C(60),DATA(200,2),DC(3,200),DEL(200,200),
     +   ITHGRP(60),Q(6),R(60,6),S(11),XI(60)
      INTEGER  CFORM
C
      ZERO = 0.0D0
      ONE = 1.0D0
      DBAR = ZERO
      DO 1000 I = 1,NGRPS
         XI(I) = ZERO
 1000 CONTINUE
      DO 1400 I = 1,NCASES
         DO 1300 J = 1,NCASES
            DEL(I,J) = ZERO
            DO 1200 K = 1,ID
               DEL(I,J) = DEL(I,J)+(DATA(I,K)-DATA(J,K))**2
 1200       CONTINUE
            DEL(I,J) = DEL(I,J)**(V/2)
            IF(DEL(I,J).GT.SUP) DEL(I,J) = SUP
            IS = IDNINT(DATA(I,ID+1))
            JS = IDNINT(DATA(J,ID+1))
            IF(IS.LE.NGRPS.AND.IS.EQ.JS) XI(IS) = XI(IS)+DEL(I,J)
 1300    CONTINUE
 1400 CONTINUE
      GO TO (1410,1430,1450,1470) CFORM
 1410 FK = ZERO
      DO 1415 I = 1,NGRPS
         FK = FK+ITHGRP(I)
 1415 CONTINUE
      DO 1420 I = 1,NGRPS
         C(I) = ONE*ITHGRP(I)/FK
 1420 CONTINUE
      GO TO 1490
 1430 FK = ZERO
      DO 1435 I = 1,NGRPS
         FK = FK+ITHGRP(I)
 1435 CONTINUE
      DO 1440 I = 1,NGRPS
         C(I) = ONE*(ITHGRP(I)-1)/(FK-NGRPS)
 1440 CONTINUE
      GO TO 1490
 1450 DO 1460 I = 1,NGRPS
         C(I) = ONE/NGRPS
 1460 CONTINUE
      GO TO 1490
 1470 Y = ZERO
      DO 1475 I = 1,NGRPS
         Y = Y+ONE*ITHGRP(I)*(ITHGRP(I)-1)
 1475 CONTINUE
      DO 1480 I = 1,NGRPS
         C(I) = ONE*ITHGRP(I)*(ITHGRP(I)-1)/Y
 1480 CONTINUE
 1490 DO 1500 I = 1,NGRPS
         XI(I) = XI(I)/(ITHGRP(I)*(ITHGRP(I)-1))
         DBAR = DBAR+C(I)*XI(I)
 1500 CONTINUE
      DO 2150 I = 1,NCASES
         DO 2140 K = 1,3
            DC(K,I) = ZERO
            DO 2130 J = 1,NCASES
               DC(K,I) = DC(K,I)+DEL(I,J)**K
 2130       CONTINUE
 2140    CONTINUE
 2150 CONTINUE
      DO 2160 I = 1,12
         B(I) = ZERO
 2160 CONTINUE
      DO 2170 I = 1,NCASES
         B(1) = B(1)+DC(1,I)
         B(2) = B(2)+DC(2,I)
         B(3) = B(3)+DC(1,I)**2
         B(5) = B(5)+DC(3,I)
         B(6) = B(6)+DC(1,I)*DC(2,I)
         B(10) = B(10)+DC(1,I)**3
 2170 CONTINUE
      DO 2190 I = 1,NCASES-1
         DO 2180 J = I+1,NCASES
            B(9) = B(9)+DC(1,I)*DC(1,J)*DEL(I,J)
 2180    CONTINUE
 2190 CONTINUE
      B(9) = B(9)*2
      DO 2240 I = 1,NCASES-2
         DO 2230 J = I+1,NCASES-1
            DO 2220 K = J+1,NCASES
               SUM = DEL(I,J)*DEL(I,K)*DEL(J,K)
               B(7) = B(7)+SUM
 2220       CONTINUE
 2230    CONTINUE
 2240 CONTINUE
      B(7) = B(7)*6
      B(4) = B(1)**2
      B(8) = B(1)*B(2)
      B(11) = B(1)*B(3)
      B(12) = B(1)**3
      A1 = B(1)
      A2 = B(2)
      A3 = B(3)-B(2)
      A4 = B(4)-A2*2-A3*4
      A5 = B(5)
      A6 = B(6)-B(5)
      A7 = B(7)
      A8 = B(8)+(B(5)-B(6)*2)*2
      A9 = B(9)+B(5)-B(6)*2-B(7)
      A10 = B(10)+B(5)*2-B(6)*3
      A11 = B(11)-(B(10)-B(7)+(B(5)+B(9))*2)*2+B(6)*10-B(8)
      A12 = B(12)-(A5+(A7+A10+(A6+A9)*3)*2)*4-(A8+A11*2)*6
      Q(1) = NCASES
      DO 2280 I = 2,6
         Q(I) = Q(I-1)*(NCASES-I+1)
 2280 CONTINUE
      D1 = A1/Q(2)
      D2 = A2/Q(2)
      D3 = A3/Q(3)
      D4 = A4/Q(4)
      D5 = A5/Q(2)
      D6 = A6/Q(3)
      D7 = A7/Q(3)
      D8 = A8/Q(4)
      D9 = A9/Q(4)
      D10 = A10/Q(4)
      D11 = A11/Q(5)
      D12 = A12/Q(6)
      DO 2300 I = 1,NGRPS
         R(I,1) = ITHGRP(I)
         DO 2290 J = 2,6
            R(I,J) = R(I,J-1)*(ITHGRP(I)-J+1)
 2290    CONTINUE
 2300 CONTINUE
      DO 2310 I = 1,11
         S(I) = ZERO
 2310 CONTINUE
      DO 2340 I = 1,NGRPS
         S(4) = S(4)+C(I)**2/R(I,2)
         S(5) = S(5)+C(I)**2/R(I,1)
         S(6) = S(6)+C(I)**3/R(I,2)**2
         S(7) = S(7)+C(I)**3*R(I,3)/R(I,2)**3
         S(8) = S(8)+C(I)**2*((ONE-C(I))/R(I,2)+C(I)*R(I,4)/R(I,2)**3)
         S(9) = S(9)+C(I)**3*R(I,4)/R(I,2)**3
         S(10) = S(10)+C(I)**2*((ONE-C(I))*R(I,3)/R(I,2)**2+
     1           C(I)*R(I,5)/R(I,2)**3)
         S(11) = S(11)+C(I)*((ONE-C(I))*(ONE-C(I)*2)+C(I)*(ONE-C(I))*
     1           R(I,4)*3/R(I,2)**2+C(I)**2*R(I,6)/R(I,2)**3)
 2340 CONTINUE
      VAR = (S(4)-ONE/Q(2))*(D2-D3*2+D4)*2+(S(5)-ONE/Q(1))*(D3-D4)*4
      STDEV = DSQRT(VAR)
      T = (DBAR-D1)/STDEV
      EDELT3 = S(6)*D5*4+S(7)*(D6*3+D7)*8+S(8)*D8*6+
     1         S(9)*(D9*3+D10)*8+S(10)*D11*12+S(11)*D12
      CUM3 = EDELT3-D1*VAR*3-D1**3
      GAM1 = CUM3/STDEV**3
      CALL PVALUE(T,GAM1,PROB)
      RETURN
      END
C
C
      SUBROUTINE PVALUE(T,GAM,PROB)
C
C         SUBROUTINE PVALUE CALCULATES THE PROBABILITY THAT A VALUE OF
C         T IS LESS THAN OR EQUAL TO THE OBSERVED VALUE OF T.
C
      DOUBLE PRECISION  T,GAM,PROB,ZERO,ONE,PI,A,B,C,D,E,F,G,H,R,
     +   U,W,X,Y,E1,E2,E3,E4,E5,G1,G2,G3,H0,H1,H1N,H2,H3
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      IF(DABS(GAM).LT.0.01D0) GO TO 50
      R = ONE*2/DABS(GAM)
      D = R*R
      F = R*R+10
      DO 10 I = 1,9
         D = D*(R*R+I)
   10 CONTINUE
      U = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)
     +        -ONE/(F*F*F*360)
      A = R*R-1
      B = R*R*(DLOG(R)-1)-U
      G1 = 0.0375D0
      G2 = 0.075D0
      G3 = 0.0125D0
      H1 = ZERO
      H2 = ZERO
      W = -1.99D0/GAM
      IF(GAM.LT.ZERO) GO TO 30
      IF(T.LT.W) THEN
         PROB = ZERO
         RETURN
      END IF
      X = T
      Y = T+15
      DO 20 I = 1,199
         G = A*DLOG(R+X+G1*(2*I-1))-R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R+X+G2*I)-R*(X+G2*I)+B
         H2 = H2+E(G)
   20 CONTINUE
      G = A*DLOG(R+X+G1*399)-R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R+X)-R*X+B
      H0 = E(G)
      G = A*DLOG(R+Y)-R*Y+B
      H3 = E(G)
      PROB = ONE-G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   30 IF(T.GT.W) THEN
         PROB = ONE
         RETURN
      END IF
      X = T-15
      Y = T
      DO 40 I = 1,199
         G = A*DLOG(R-X-G1*(2*I-1))+R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R-X-G2*I)+R*(X+G2*I)+B
         H2 = H2+E(G)
   40 CONTINUE
      G = A*DLOG(R-X-G1*399)+R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R-X)+R*X+B
      H0 = E(G)
      G = A*DLOG(R-Y)+R*Y+B
      H3 = E(G)
      PROB = G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   50 PROB = ZERO
      G = -T*T/2
      IF(G.LT.-709.1D0) GO TO 70
      A = 4.2D0
      U = DABS(T)
      IF(U.GT.A) GO TO 60
      E1 = 0.31938153D0
      E2 = -0.356563782D0
      E3 = 1.781477937D0
      E4 = -1.821255978D0
      E5 = 1.330274429D0
      H = 0.2316419D0
      W = ONE/(H*U+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*E(G)/DSQRT(PI*2)
      GO TO 70
   60 B = 2.2D0
      C = 4.9D0
      PROB = E(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   70 IF(T.GT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION E(G)
C
      DOUBLE PRECISION G
C
      E = 0.0D0
      IF(G.GE.-709.1D0) E = DEXP(G)
      RETURN
      END
