      PROGRAM SMREG
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
C
      CHARACTER HEAD*70,FIN*40,FOUT*40
      DIMENSION F(250,28),Y(250,15),YP(250,15),DATA(250,16),COEF(15,28),
     *          IDZ(3),ITHGRP(20),U(17)
      INTEGER CFORM
C
C THIS PROGRAM IS THE MULTIVARIATE EXTENSION OF SREGRES, THAT IS,
C RMRPP REGRESSION ANALYSIS WITH MULTIVARIATE RESPONSE VARIABLES.
C
C Kaufman, E.H., G.D. Taylor, P.W. Mielke and K.J. Berry (2002).
C    An algorithm and FORTRAN program for multivariate (l/1 of l/2)
C    regression.  COMPUTING, 68, 275-287.
C
C THE ONLY PROGRAM AND SUBROUTINES REQUIRING DIMENSION STATEMENT
C MODIFICATIONS ARE SMREG(ABOVE), LAD, FNSET, L1, CONGRD, RMRPP,
C DIST, AND SAMPWOR.
C
C IDZ(1), IDZ(2) AND IDZ(3) THE DIMENSIONS CORRESPONDING TO N,
C IR AND IP, RESPECTIVELY.
C
      IDZ(1) = 250
      IDZ(2) =  15
      IDZ(3) =  28
C
C THIS IS A DRIVER PROGRAM FOR MULTIVARIATE LAD REGRESSION.  FOR
C MORE INFORMATION, SEE THE INITIAL COMMENTS OF SUBROUTINE LAD.
C
      WRITE(*,*) 'ENTER: FILE NAME OF INPUT DATA'
      READ(*,100) FIN
  100 FORMAT(A)
      WRITE(*,*) 'ENTER: FILE NAME FOR OUTPUT RESULTS'
      READ(*,100) FOUT
      WRITE(*,*) 'ENTER RANDOM # SEED & # OF SIMULATIONS:'
      READ(*,*) ISEED,MS
      KR = 24
      I1 = MOD(IABS(ISEED),177)+1
      J1 = MOD(IABS(ISEED),167)+1
      K1 = MOD(IABS(ISEED),157)+1
      L1 = MOD(IABS(ISEED),147)+1
      DO 104 II = 1,17
         S = 0.0D0
         T = 0.5D0
         DO 102 JJ = 1,KR
            M1 = MOD(MOD(I1*J1,179)*K1,179)
            I1 = J1
            J1 = K1
            K1 = M1
            L1 = MOD(53*L1+1,169)
            IF(MOD(L1*M1,64).GE.32) S = S+T
            T = T/2
  102    CONTINUE
         U(II) = S
  104 CONTINUE
      OPEN(1,FILE=FIN)
      OPEN(2,FILE=FOUT, STATUS='NEW')
C FIRST LINE OF INPUT DATA DESCRIBES DATA (AT MOST 70 SPACES)
      READ(1,100) HEAD
      WRITE(2,100) HEAD
C READ AND WRITE N, IP, IR AND NGRPS.
      READ(1,*) N,IP,IR,NGRPS
      READ(1,*) (ITHGRP(I),I = 1,NGRPS)
      WRITE(2,200) N,IP,IR
  200 FORMAT(26H THE NUMBER N OF EVENTS IS,I5/14H THE NUMBER IP,
     *43H OF MODEL PREDICTIVE FUNCTIONS PER EVENT IS,I5/4H THE,
     *51H NUMBER IR OF OBSERVED RESPONSE VALUES PER EVENT IS,I5)
C
C READ AND WRITE THE MATRIX F WHOSE ITH ROW GIVES THE IP MODEL
C PREDICTIVE FUNCTION VALUES FOR THE ITH EVENT.
C NOTE THAT THE TRANSPOSE OF THE ITH ROW OF F IS THE VECTOR F(XI) OF
C PAGE 1 OF THE PAPER.
C      WRITE(2,250)
C  250 FORMAT(/50H THE MATRIX F WHOSE ROWS GIVE THE MODEL PREDICTIVE,
C     *13H FUNCTIONS IS/)
      DO 400 I=1,N
        READ(1,*,END=700)(F(I,L),L=1,IP)
C        WRITE(2,300)(F(I,L),L=1,IP)
C  300   FORMAT(6F8.2)
  400 CONTINUE
C
C READ AND WRITE THE MATRIX Y WHOSE ITH ROW GIVES THE IR OBSERVED
C RESPONSE VALUES FOR THE ITH EVENT.
C NOTE THAT THE TRANSPOSE OF THE ITH ROW OF I IS THE VECTOR YI OF
C PAGE 1 OF THE PAPER.
C      WRITE(2,450)
C  450 FORMAT(/51H THE MATRIX Y WHOSE ROWS GIVE THE OBSERVED RESPONSE,
C     *10H VALUES IS/)
      DO 600 I=1,N
        READ(1,*,END=700)(Y(I,J),J=1,IR)
C        WRITE(2,500)(Y(I,J),J=1,IR)
C  500   FORMAT(6F8.2,F9.2)
  600 CONTINUE
      GO TO 900
  700 WRITE(*,800) 'ERROR: END-OF-FILE ENCOUNTERED'
  800 FORMAT(/,T3,A)
      STOP
C
C CALL LAD.
  900 CALL LAD(N,IR,IP,IDZ,F,Y,COEF,ANORM,ANORMI,ITER)
C
C WRITE THE RESULTS AND STOP.
      WRITE(2,1600)ITER,ANORMI,ANORM
 1600 FORMAT(/37H *****WE ARE FINISHED.  THE NUMBER OF,
     *14H ITERATIONS IS,I5/35H THE LAD ERROR NORM FOR THE INITIAL,
     *16H COEFFICIENTS IS,E22.14/27H THE LAD ERROR NORM FOR THE,
     *22H FINAL COEFFICIENTS IS,E22.14)
C      DO 2200 J=1,IR
C        WRITE(2,1900)
C 1900   FORMAT(2H  )
C        DO 2100 L=1,IP
C          WRITE(2,2000)L,J,COEF(J,L)
C 2000     FORMAT(27H LAD REGRESSION COEFFICIENT,I3,14H  FOR RESPONSE,
C     *    I3,3H  =,E22.14)
C 2100   CONTINUE
C 2200 CONTINUE
      DO 2500 I = 1,N
         DO 2400 J = 1,IR
            YP(I,J) = 0.0D0
            DO 2300 K = 1,IP
               YP(I,J) = YP(I,J)+F(I,K)*COEF(J,K)
 2300       CONTINUE
            DATA(I,J) = Y(I,J)-YP(I,J)
 2400    CONTINUE
 2500 CONTINUE
      V = 1.0D0
      SUP = 1.0D50
      CFORM = 1
      CALL RMRPP(N,IR,V,SUP,CFORM,NGRPS,ISEED,MS,U,ITHGRP,DATA)
      CLOSE(1)
      CLOSE(2)
      END
C
C
      SUBROUTINE LAD(N,IR,IP,IDZ,F,Y,COEF,ANORM,ANORMI,ITER)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
C
      DIMENSION F(250,28),Y(250,15),COEF(15,28),IDZ(3),PTTBL(250,43),
     *PARAM(420),WORK(365844),IWORK(2950),SCL(28),X(28),A(252,30),
     *B(250),IZ(3)
C
C NOTE: CONSTANT DIMENSION DECLARATIONS FOR ARRAYS ARE DESCRIBED IN
C       THE FOLLOWING COMMENTS.
C
C THE USER NEED NOT CHANGE THE FOLLOWING DIMENSIONS.
      DIMENSION FUN(1),ERROR(4)
C
C THIS IS THE MAIN SUBROUTINE FOR THE LAD REGRESSION PROBLEM.
C ITS GOAL IS TO CHOOSE THE ENTRIES OF THE IR X IP MATRIX COEF TO MINIMIZE
C
C (SUM FROM I = 1 TO N) SQRT((SUM FROM J = 1 TO IR) (Y(I,J) -
C    (SUM FROM L = 1 TO IP) COEF(J,L)*F(I,L))**2),
C
C WHERE F IS A GIVEN N X IP MATRIX AND Y IS A GIVEN N X IR MATRIX.
C
C THE PATTERN FOR CONSTANT DIMENSION DECLARATIONS WHICH WILL SET ASIDE
C SUFFICIENT SPACE TO SOLVE ANY PROBLEM WITH UP TO NDIM EVENTS
C (N .LE. NDIM), UP TO IRDIM OBSERVED RESPONSE VALUES PER EVENT
C (IR .LE. IRDIM), AND UP TO IPDIM MODEL PREDICTIVE FUNCTIONS PER EVENT
C (IP .LE. IPDIM) IS GIVEN IN THE TABLE BELOW.  FIRST, SET THE FOLLOWING
C FOUR DIMENSION PARAMETERS FOLLOWING THE TABLE:
C
C     IPTB  = NDIM
C     INDM  = IRDIM + IPDIM
C     LIWRK = 7*IRDIM*IPDIM + 10
C     LWRK  = 2*(IRDIM*IPDIM)**2 + 31*IRDIM*IPDIM + 24
C
C    ARRAY     WHERE TO SET     CONSTANT DIMENSION
C
C    F         DRIVER, LAD      (NDIM,IPDIM)
C    Y         DRIVER, LAD      (NDIM,IRDIM)
C    COEF      DRIVER, LAD      (IRDIM,IPDIM)
C    PTTBL     LAD              (IPTB,INDM)
C    PARAM     LAD              IRDIM*IPDIM
C    IWORK     LAD              LIWRK
C    WORK      LAD              LWRK
C    SCL       LAD              IPDIM
C    X         LAD, L1          IPDIM
C    A         LAD, L1          (NDIM+2,IPDIM+2)
C    B         LAD, L1          NDIM
C    E         L1               NDIM
C    IWS       L1               NDIM
C    DERI      FNSET            IRDIM*IPDIM
C    G         CONGRD           IRDIM*IPDIM
C    H         CONGRD           IRDIM*IPDIM
C    XI        CONGRD           IRDIM*IPDIM
C    PARSER    CONGRD           IRDIM*IPDIM
C    CONFUN    CONGRD           (1,IRDIM*IPDIM+1)
C
      NDIM  = IDZ(1)
      IRDIM = IDZ(2)
      IPDIM = IDZ(3)
C
C***THE FOUR DIMENSION PARAMETERS BASED ON N, IR AND IP FOLLOW:
C
      IPTB  = NDIM
      INDM  = IRDIM + IPDIM
      LIWRK = 7*IRDIM*IPDIM + 10
      LWRK  = 2*(IRDIM*IPDIM)**2 + 31*IRDIM*IPDIM + 24
C
C NOTE: LIWRK AND LWRK MUST BE LESS THAN OR EQUAL TO THE DIMENSIONS
C       SET FOR IWORK AND WORK IN THE ABOVE DIMENSION STATEMENT.
C
C IF THE CONJUGATE GRADIENTS METHOD IS TO BE USED INSTEAD OF CONMAX,
C THEN IN SUBROUTINE CONGRD ALSO SET THE DIMENSION OF G, H, X1, AND
C PARSER TO BE IRDIM*IPDIM AND SET THE DIMENSION OF CONFUN TO BE
C (1,IRDIM*IPDIM+1)
C
C SET MACHINE AND PRECISION DEPENDENT CONSTANTS.
      ONE=1.0D0
      ZERO=ONE-ONE
      TWO=ONE+ONE
      FOUR=TWO+TWO
      TEN=FOUR+FOUR+TWO
      SPCMN=D1MACH(3)
      TOL=TEN*SPCMN
      TOLER=SPCMN**(TWO/(ONE+TWO))
      CTOLR=TEN**(-6)
C
      IZ(1)=N
      IZ(2)=IR
      IZ(3)=IP
C
C NOW INITIALIZE COEF BY SOLVING THE L1 OF L1 PROBLEM, WHICH IS
C EQUIVALENT TO SOLVING THE IR SEPARATE L1 PROBLEMS OF CHOOSING
C COEF(J,1),...,COEF(J,IP) TO MINIMIZE
C (SUM FROM I = 1 TO N) ABS(Y(I,J) - PJ(FI)),
C WHERE PJ(FI) = (SUM FROM L = 1 TO IP) COEF(J,L)*F(I,L).
C THUS THIS JTH L1 PROBLEM IS EQUIVALENT TO FINDING THE L1 SOLUTION
C TO THE OVERDETERMINED SYSTEM OF EQUATIONS F*COEF(J,.) = Y(.,J)
C WHERE F IS AN N X IP MATRIX, COEF(J,.) IS THE IP X 1 MATRIX CONSISTING
C OF THE TRANSPOSE OF THE JTH ROW OF COEF, AND Y(.,J) IS THE N X 1
C MATRIX CONSISTING OF THE JTH COLUMN OF Y.
      DO 400 J=1,IR
C
C SET UP A AND B FOR THE BARRODALE-ROBERTS CODE.  NOTE THAT THESE
C MATRICES MUST BE RESET FOR EACH CALL SINCE THE BARRODALE-ROBERTS
C CODE DESTROYS THEM.
        DO 200 I=1,N
          DO 100 L=1,IP
            A(I,L)=F(I,L)
  100     CONTINUE
          B(I)=Y(I,J)
  200   CONTINUE
C
C CALL THE BARRODALE-ROBERTS L1 CODE.  NOTE THAT N IN THAT ROUTINE IS
C IP (NOT N) IN THIS ROUTINE.
        CALL L1(N,IP,TOLER,X,A,B)
C
C PUT THE SOLUTION X INTO ROW J OF COEF.
        DO 300 L=1,IP
          COEF(J,L)=X(L)
  300   CONTINUE
  400 CONTINUE
C END OF INITIALIZATION.
C
C COMPUTE THE SCALE FACTORS FOR THE COLUMNS OF F.
      DO 900 L=1,IP
        SCALE=ZERO
        DO 600 I=1,N
          AA=ABS(F(I,L))
          IF(AA-SCALE)600,600,500
  500     SCALE=AA
  600   CONTINUE
        IF(SCALE-TOL)700,800,800
  700   SCL(L)=ONE
        GO TO 900
  800   SCL(L)=SCALE
  900 CONTINUE
C
C DIVIDE EACH COLUMN OF F BY ITS SCALE FACTOR AND MULTIPLY THE
C CORRESPONDING INITIAL PARAMETERS BY THE SCALE FACTOR.
      DO 1200 L=1,IP
        DO 1000 I=1,N
          F(I,L)=F(I,L)/SCL(L)
 1000   CONTINUE
        DO 1100 J=1,IR
          COEF(J,L)=COEF(J,L)*SCL(L)
 1100   CONTINUE
 1200 CONTINUE
C
C PUT F INTO THE FIRST IP COLUMNS OF PTTBL, AND PUT Y INTO THE NEXT
C IR COLUMNS OF PTTBL, SO THESE VALUES CAN BE PASSED TO SUBROUTINE
C FNSET.
      DO 1500 I=1,N
        DO 1300 L=1,IP
          PTTBL(I,L)=F(I,L)
 1300   CONTINUE
        DO 1400 J=1,IR
          JSUB=IP+J
          PTTBL(I,JSUB)=Y(I,J)
 1400   CONTINUE
 1500 CONTINUE
C
C PUT COEF(J,L) INTO PARAM((J-1)*IP+L) FOR J=1,...,IR AND L=1,...,IP.
      DO 1700 J=1,IR
        JMIP=(J-1)*IP
        DO 1600 L=1,IP
          JLSUB=JMIP+L
          PARAM(JLSUB)=COEF(J,L)
 1600   CONTINUE
 1700 CONTINUE
C
C COMPUTE THE LAD ERROR NORM WITH THE INITIAL COEFFICIENTS, TAKE CTOL
C = THIS ERROR NORM TIMES CTOLR, AND TELL CONMAX TO TERMINATE IF THREE
C CONSECUTIVE ITERATIONS EACH FAIL TO REDUCE THE LAD ERROR NORM BY AN
C AMOUNT CTOL.
C IF IT IS DESIRED TO DELETE THIS TERMINATION CRITERION, ONE ONLY
C NEEDS TO CHANGE IOPTN=110 (A FEW STATEMENTS FROM HERE) TO IOPTN=100.
      ANORMI=ZERO
      DO 2000 I=1,N
        SUMI=ZERO
        DO 1900 J=1,IR
          POLY=ZERO
          DO 1800 L=1,IP
            POLY=POLY+COEF(J,L)*F(I,L)
 1800     CONTINUE
          SUMI=SUMI+(Y(I,J)-POLY)**2
 1900   CONTINUE
        ANORMI=ANORMI+SQRT(SUMI)
 2000 CONTINUE
      CTOL=CTOLR*ANORMI
C
C SET PARAMETERS FOR CONMAX.
      IOPTN=110
C
C SET IWORK(2)=NSTEP.
C ONE CAN CHOOSE A DIFFERENT POSITIVE INTEGER VALUE FOR NSTEP INSTEAD
C OF THE 16 SUGGESTED BELOW.  LARGER VALUES MAY IMPROVE ACCURACY A
C LITTLE AT THE EXPENSE OF COMPUTER TIME.
      IWORK(2)=16
      IFUN=1
C SET THE ITERATION LIMIT.
      ITLIM=500
      NPARM=IP*IR
      NUMGR=1
      IWORK(1)=3
      WORK(1)=CTOL
C
C CALL CONMAX.
C     CALL CONMAX(IOPTN,NPARM,NUMGR,ITLIM,FUN,IFUN,PTTBL,IPTB,INDM,
C    *IWORK,LIWRK,WORK,LWRK,ITER,PARAM,ERROR,IZ)
C     ANORM=ERROR(2)
C*****CONGRD INSERT.  TO USE CONJUGATE GRADIENTS INSTEAD OF CONMAX,
C COMMENT OUT THE STATEMENT CALL CONMAX(... AND THE FOLLOWING
C STATEMENT ABOVE AND REMOVE THE CS FROM THE NEXT 2 STATEMENTS AND FROM
C THE NON-COMMENT STATEMENTS IN SUBROUTINE CONGRD.
      FTOL=TEN**(-10)
      CALL CONGRD(PARAM,NPARM,PTTBL,IPTB,INDM,ITLIM,FTOL,IWORK,
     *LIWRK,WORK,LWRK,ITER,ANORM,IZ)
C*****END CONGRD INSERT
C
C PUT PARAM((J-1)*IP+L) INTO COEF(J,L) FOR J=1,...,IR AND
C L=1,...,IP.
      DO 2200 J=1,IR
        JMIP=(J-1)*IP
        DO 2100 L=1,IP
          JLSUB=JMIP+L
          COEF(J,L)=PARAM(JLSUB)
 2100   CONTINUE
 2200 CONTINUE
C
C UNSCALE THE COMPUTED COEFFICIENTS AND RETURN.
      DO 2500 L=1,IP
        DO 2300 I=1,N
          F(I,L)=F(I,L)*SCL(L)
 2300   CONTINUE
        DO 2400 J=1,IR
          COEF(J,L)=COEF(J,L)/SCL(L)
 2400   CONTINUE
 2500 CONTINUE
      RETURN
      END
C
C
      SUBROUTINE FNSET(NPARM,NUMGR,PTTBL,IPTB,INDM,PARAM,IPT,
     *INDFN,ICNTYP,CONFUN,IZ)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
C
      DIMENSION DERI(420),IZ(3)
C
C THE USER NEED NOT CHANGE THE FOLLOWING DIMENSIONS.
      DIMENSION PTTBL(IPTB,INDM),PARAM(NPARM),ICNTYP(NUMGR),
     *CONFUN(NUMGR,NPARM+1)
C
      N=IZ(1)
      IR=IZ(2)
      IP=IZ(3)
C
C THIS SUBROUTINE IS CALLED BY CONMAX TO GET FUNCTION INFORMATION.
C THE USER NEED NOT CHANGE IT, EXCEPT POSSIBLY FOR THE DIMENSION OF
C DERI ABOVE.
C
C SET PRECISION AND PRECISION DEPENDENT CONSTANTS.
      ONE=1.0D0
      ZERO=ONE-ONE
      TWO=ONE+ONE
      FOUR=TWO+TWO
      TEN=FOUR+FOUR+TWO
      SPCMN=D1MACH(3)
      TOL=TEN*SPCMN
C
      ICNTYP(IPT)=1
C
C IF INDFN=1, ZERO OUT THE DERIVATIVE POSITIONS IN CONFUN.
      IF(INDFN)80,80,60
   60 DO 70 J=1,NPARM
        CONFUN(IPT,J+1)=ZERO
   70 CONTINUE
   80 SUM=ZERO
      DO 900 I=1,N
        SUMI=ZERO
        DO 500 J=1,IR
          JMIP=(J-1)*IP
          POLY=ZERO
          DO 100 L=1,IP
            JLSUB=JMIP+L
            POLY=POLY+PARAM(JLSUB)*PTTBL(I,L)
  100     CONTINUE
          DIFF=PTTBL(I,IP+J)-POLY
          IF(INDFN)400,400,200
  200     DO 300 L=1,IP
            JLSUB=JMIP+L
            DERI(JLSUB)=DIFF*PTTBL(I,L)
  300     CONTINUE
  400     SUMI=SUMI+DIFF*DIFF
  500   CONTINUE
        SQR=SQRT(SUMI)
        SUM=SUM+SQR
        IF(INDFN)900,900,600
  600   IF(SQR-TOL)900,700,700
  700   DO 800 J=1,NPARM
          CONFUN(IPT,J+1)=CONFUN(IPT,J+1)-DERI(J)/SQR
  800   CONTINUE
  900 CONTINUE
      CONFUN(IPT,1)=SUM
      RETURN
      END
C
C
      SUBROUTINE L1(M,N,TOLER,X,A,B)
C
C  ***************************************************************
C  *  COMMUNICATIONS OF THE ASSOCIATION FOR COMPUTING MACHINERY  *
C  *  ALGORITHM 478                                              *
C  *  SOLUTION OF AN OVERDETERMINED SYSTEM OF EQUATIONS IN THE   *
C  *  L1 NORM -- I. BARRODALE AND F.D.K. ROBERTS                 *
C  ***************************************************************
C
C  ****************************************************************
C  * THIS SUBROUTINE USES A MODIFICATION OF THE SIMPLEX METHOD OF *
C  * LINEAR PROGRAMMING TO CALCULATE AN L1 SOLUTION TO THE OVER-  *
C  * DETERMINED SYSTEM OF LINEAR EQUATIONS, A*X = B.
C  *                                                              *
C  *                         PARAMETERS                           *
C  *                                                              *
C  * M     - NUMBER OF EQUATIONS.  NOTE THAT THIS IS THE N IN     *
C  *         SUBROUTINE LAD.                                      *
C  * N     - NUMBER OF UNKNOWNS (M.GE.N).                         *
C  * TOLER - A SMALL POSITIVE TOLERANCE. THE ROUTINE REGARDS ANY  *
C  *         QUANTITY AS ZERO UNLES ITS MAGNITUDE EXCEEDS TOLER.  *
C  *         EMPIRICAL EVIDENCE SUGGESTS TOLER = 10**(-D*2/3)     *
C  *         WHERE D REPRESENTS THE NUMBER OF DECIMAL DIGITS OF   *
C  *         ACCURACY AVAILABLE.                                  *
C  * X     - ONE DIMENSIONAL REAL ARRAY.  ON EXIT, THIS ARRAY     *
C  *         CONTAINS A SOLUTION TO THE L1 PROBLEM.               *
C  *                                                              *
C  * THE ORIGINAL CONTENTS OF THE ARRAYS A AND B ARE DESTROYED BY *
C  * THIS ROUTINE.                                                *
C  *                                                              *
C  * ON EXIT FROM THE SUBROUTINE, THE ARRAY A CONTAINS THE        *
C  * FOLLOWING INFORMATION.                                       *
C  *                                                              *
C  * A(M+1,N+1)  THE MINIMUM SUM OF THE ABSOLUTE VALUES OF THE    *
C  *             RESIDUALS.                                       *
C  * A(M+1,N+2)  THE RANK OF THE MATRIX OF COEFFICIENTS.          *
C  * A(M+2,N+1)  EXIT CODE WITH VALUES                            *
C  *             0 - OPTIMAL SOLUTION - PROBABLY NON-UNIQUE       *
C  *             1 - UNIQUE OPTIMAL SOLUTION                      *
C  *             2 - PREMATURE TERMINATION DUE TO ROUNDING ERRORS *
C  * A(M+2,N+2)  NUMBER OF SIMPLEX ITERATIONS PERFORMED.          *
C  *                                                              *
C  ****************************************************************
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
C
      DIMENSION X(28),A(252,30),B(250),E(250),IWS(250)
C
      LOGICAL STAGE,TEST
      DATA BIG/1.D25/
C
C SET PRECISION DEPENDENT CONSTANTS.
      ONE=1.0D0
      ZERO=ONE-ONE
      TWO=ONE+ONE
C
C  BEGINNING OF ALGORITHM -- INITIALIZATION.
C
      M1=M+1
      M2=M+2
      N1=N+1
      N2=N+2
      DO 10 J=1,N
         A(M2,J)=J
         X(J)=ZERO
   10 CONTINUE
      DO 40 I=1,M
         A(I,N2)=N+I
         A(I,N1)=B(I)
         IF(B(I).GE.ZERO)GO TO 30
         DO 20 J=1,N2
            A(I,J)=-A(I,J)
   20    CONTINUE
   30    E(I)=ZERO
   40 CONTINUE
C
C  COMPUTE THE MARGINAL COSTS.
C
      DO 60 J=1,N1
         SUM=ZERO
         DO 50 I=1,M
            SUM=SUM+A(I,J)
   50    CONTINUE
         A(M1,J)=SUM
   60 CONTINUE
C
C  STAGE I.
C  DETERMINE THE VECTOR TO ENTER THE BASIS.
C
      STAGE=.TRUE.
      KOUNT=0
      KR=1
      KL=1
   70 AMAX=-ONE
      DO 80 J=KR,N
         IF(ABS(A(M2,J)).GT.FLOAT(N))GO TO 80
         D=ABS(A(M1,J))
         IF(D.LE.AMAX)GO TO 80
         AMAX=D
         IN=J
   80 CONTINUE
      IF(A(M1,IN).GE.ZERO)GO TO 100
      DO 90 I=1,M2
         A(I,IN)=-A(I,IN)
   90 CONTINUE
C
C  DETERMINE THE VECTOR TO LEAVE THE BASIS.
C
  100 K=0
      DO 110 I=KL,M
         D=A(I,IN)
         IF(D.LE.TOLER)GO TO 110
         K=K+1
         B(K)=A(I,N1)/D
         IWS(K)=I
         TEST=.TRUE.
  110 CONTINUE
  120 IF(K.GT.0)GO TO 130
      TEST=.FALSE.
      GO TO 150
  130 AMIN=BIG
      DO 140 I=1,K
         IF(B(I).GE.AMIN)GO TO 140
         J=I
         AMIN=B(I)
         IOUT=IWS(I)
  140 CONTINUE
      B(J)=B(K)
      IWS(J)=IWS(K)
      K=K-1
C
C  CHECK FOR LINEAR DEPENDENCE IN STAGE I.
C
  150 IF(TEST.OR..NOT.STAGE)GO TO 170
      DO 160 I=1,M2
         D=A(I,KR)
         A(I,KR)=A(I,IN)
         A(I,IN)=D
  160 CONTINUE
      KR=KR+1
      GO TO 260
  170 IF(TEST)GO TO 180
      A(M2,N1)=TWO
      GO TO 350
  180 PIVOT=A(IOUT,IN)
      IF(A(M1,IN)-PIVOT-PIVOT.LE.TOLER)GO TO 200
      DO 190 J=KR,N1
         D=A(IOUT,J)
         A(M1,J)=A(M1,J)-D-D
         A(IOUT,J)=-D
  190 CONTINUE
      A(IOUT,N2)=-A(IOUT,N2)
      GO TO 120
C
C  PIVOT ON A(IOUT,IN).
C
  200 DO 210 J=KR,N1
         IF(J.EQ.IN)GO TO 210
         A(IOUT,J)=A(IOUT,J)/PIVOT
  210 CONTINUE
      DO 230 I=1,M1
         IF(I.EQ.IOUT)GO TO 230
         D=A(I,IN)
         DO 220 J=KR,N1
            IF(J.EQ.IN)GO TO 220
            A(I,J)=A(I,J)-D*A(IOUT,J)
  220    CONTINUE
  230 CONTINUE
      DO 240 I=1,M1
         IF(I.EQ.IOUT)GO TO 240
         A(I,IN)=-A(I,IN)/PIVOT
  240 CONTINUE
      A(IOUT,IN)=ONE/PIVOT
      D=A(IOUT,N2)
      A(IOUT,N2)=A(M2,IN)
      A(M2,IN)=D
      KOUNT=KOUNT+1
C
C  INTERCHANGE ROWS IN STAGE I.
C
      IF(.NOT.STAGE)GO TO 270
      KL=KL+1
      DO 250 J=KR,N2
         D=A(IOUT,J)
         A(IOUT,J)=A(KOUNT,J)
         A(KOUNT,J)=D
  250 CONTINUE
  260 IF(KOUNT+KR.NE.N1)GO TO 70
C
C  STAGE II.
C  DETERMINE THE VECTOR TO ENTER THE BASIS.
C
      STAGE=.FALSE.
  270 AMAX=-BIG
      DO 290 J=KR,N
         D=A(M1,J)
         IF(D.GE.ZERO)GO TO 280
         IF(D.GT.(-TWO))GO TO 290
         D=-D-TWO
  280    IF(D.LE.AMAX)GO TO 290
         AMAX=D
         IN=J
  290 CONTINUE
      IF(AMAX.LE.TOLER)GO TO 310
      IF(A(M1,IN).GT.ZERO)GO TO 100
      DO 300 I=1,M2
         A(I,IN)=-A(I,IN)
  300 CONTINUE
      A(M1,IN)=A(M1,IN)-TWO
      GO TO 100
C
C  PREPARE OUTPUT.
C
  310 L=KL-1
      DO 330 I=1,L
         IF(A(I,N1).GE.ZERO)GO TO 330
         DO 320 J=KR,N2
            A(I,J)=-A(I,J)
  320    CONTINUE
  330 CONTINUE
      A(M2,N1)=ZERO
      IF(KR.NE.1)GO TO 350
      DO 340 J=1,N
         D=ABS(A(M1,J))
         IF(D.LE.TOLER.OR.TWO-D.LE.TOLER)GO TO 350
  340 CONTINUE
      A(M2,N1)=ONE
  350 DO 380 I=1,M
         K=A(I,N2)
         D=A(I,N1)
         IF(K.GT.0)GO TO 360
         K=-K
         D=-D
  360    IF(I.GE.KL)GO TO 370
         X(K)=D
         GO TO 380
  370    K=K-N
         E(K)=D
  380 CONTINUE
      A(M2,N2)=KOUNT
      A(M1,N2)=N1-KR
      SUM=ZERO
      DO 390 I=KL,M
         SUM=SUM+A(I,N1)
  390 CONTINUE
      A(M1,N1)=SUM
      RETURN
      END
C
C
      SUBROUTINE CONGRD(PARAM,NPARM,PTTBL,IPTB,INDM,ITLIM,
     *FTOL,IWORK,LIWRK,WORK,LWRK,ITER,FRET,IZ)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
C
      DIMENSION G(420),H(420),XI(420),PARSER(420),CONFUN(1,421),IZ(3)
C
C THE USER NEED NOT CHANGE THE FOLLOWING DIMENSIONS.
      DIMENSION PARAM(NPARM),PTTBL(IPTB,INDM),KCNTYP(1),FUN(1),
     *ERROR(4),ERR1(4),IWORK(LIWRK),WORK(LWRK),IACT(1)
C
C SET PARAMETERS FOR DERST AND SEARSL, WHICH ARE IN THE CONMAX PACKAGE.
C IF THE STATEMENTS  CALL CORRCT(...  AND  CALL RCHMOD(...  IN SUBROUTNE
C SEARSL ARE COMMENTED OUT (AND REPLACED BY  CONTINUE  STATEMENTS WITH
C THE APPROPRIATE STATEMENT NUMBERS), THEN THE ONLY SUBROUTINES FROM THE
C CONMAX PACKAGE WHICH WILL BE NEEDED ARE  D1MACH, ILOC, DERST, SEARSL,
C AND ERCMP1.
      NWRIT=I1MACH(2)
      SPCMN=D1MACH(3)
      TOL1=100.0D0*SPCMN
      PRJLIM=10000.0D0
      IFUN=1
      RCHDWN=2.0D0
      RCHIN=2.0D0
      UNIT=2.0D0
      IACT(1)=1
      TOLCON=SQRT(SPCMN)
      EPS=1.0D-10
      IPT=1
      ILC17=2*NPARM+5
      ILC24=5*NPARM+9
      ILC25=6*NPARM+9
      ILC35=14*NPARM+14
      IWORK(ILC17)=1
      CALL DERST(0,NPARM,1,PTTBL,IPTB,INDM,PARAM,IPT,WORK(ILC24),
     *WORK(ILC35),KCNTYP,CONFUN,IZ)
      FP=CONFUN(1,1)
      AXIMX=0.0D0
      DO 100 J=1,NPARM
        XI(J)=CONFUN(1,J+1)
        AXIJ=ABS(XI(J))
        IF(AXIJ-AXIMX)90,90,80
   80   AXIMX=AXIJ
   90   G(J)=-XI(J)
        H(J)=G(J)
        XI(J)=H(J)
  100 CONTINUE
      DO 1000 ITS=1,ITLIM
        ITER=ITS
        PROJCT=1.0D0
        CALL SEARSL(0,1,NPARM,PRJLIM,TOL1,XI,FUN,IFUN,PTTBL,
     *  IPTB,INDM,PARAM,ERROR,RCHDWN,1,IACT,0,UNIT,TOLCON,RCHIN,
     *  0,0,IWORK,LIWRK,WORK,LWRK,ERR1,WORK(ILC25),PROJCT,FRET,
     *  EMIN1,PARSER,NSRCH,IZ)
C IF FP WAS NOT DECREASED WE RETURN WITH THE PREVIOUS RESULT.
        IF(FRET-FP)130,120,120
  120   FRET=FP
        ITER=ITER-1
        RETURN
  130   DO 200 J=1,NPARM
          PARAM(J)=PARSER(J)
  200   CONTINUE
        FDIFF=FRET-FP
        WRITE(NWRIT,300)ITER,FRET,FDIFF,AXIMX
  300   FORMAT(I5,E22.14,E10.2,E11.2)
        IF(-2.0D0*FDIFF-FTOL*(ABS(FRET)+ABS(FP)+EPS))400,400,500
  400   RETURN
  500   CALL DERST(0,NPARM,1,PTTBL,IPTB,INDM,PARAM,IPT,WORK(ILC24),
     *  WORK(ILC35),KCNTYP,CONFUN,IZ)
        FP=CONFUN(1,1)
        AXIMX=0.0D0
        DO 600 J=1,NPARM
          XI(J)=CONFUN(1,J+1)
          AXIJ=ABS(XI(J))
          IF(AXIJ-AXIMX)600,600,520
  520     AXIMX=AXIJ
  600   CONTINUE
        GG=0.0D0
        DGG=0.0D0
        DO 700 J=1,NPARM
          GG=GG+G(J)*G(J)
          DGG=DGG+(XI(J)+G(J))*XI(J)
  700   CONTINUE
        IF(GG-SPCMN)400,800,800
  800   GAM=DGG/GG
        DO 900 J=1,NPARM
          G(J)=-XI(J)
          H(J)=G(J)+GAM*H(J)
          XI(J)=H(J)
  900   CONTINUE
 1000 CONTINUE
      WRITE(NWRIT,1100)
 1100 FORMAT(/25H ITERATION LIMIT EXCEEDED)
      RETURN
      END
C
C
C NOW FOLLOW THE 25 CONMAX SUBPROGRAMS NEEDED FOR THE LAD PACKAGE, NAMELY
C I1MACH, D1MACH, CONMAX, I1MACH, ILOC, DERST, SLPCON, BNDSET, SETU1, SLNPRO,
C SJELIM, SEARSL, ERCMP1, RKCON, RKSACT, PMTST, RKPAR, CORRCT, SEARCR,
C MULLER, RCHMOD, WOLFE, CONENR, HOUSE, DOTPRD, AND REFWL.
C
C THE USER DOES NOT NEED TO CHANGE ANY OF THESE SUBPROGAMS.
C
C THE COMPLETE CONMAX PACKAGE CAN BE FOUND IN THE OPT SUBLIBRARY OF
C NETLIB UNDER THE NAME CONMAX.F;  THIS INCLUDES AN EXTENSIVE USER'S
C GUIDE.
C
C THE NEXT FUNCTION SUBPROGRAM IS I1MACH FROM THE BLAS SUBLIBRARY
C OF NETLIB, WHICH SETS INTEGER MACHINE CONSTANTS.
C FOR MOST COMPUTER SYSTEMS, THIS SUBPROGRAM WORKS AUTOMATICALLY, AND
C DOES NOT NEED TO BE CHANGED BY THE USER.
C THE LAD PACKAGE NEEDS ONLY TWO CONSTANTS FROM THIS SUBPROGRAM, SO
C IF NECESSARY THE USER CAN COMMENT OUT OR DELETE ALL STATEMENTS BETWEEN
C THE SECOND AND LAST STATEMENTS IN THIS SUBPROGRAM AND REPLACE THEM WITH
C THE STATEMENTS
C     I1MACH(1) = (YOUR INPUT UNIT NUMBER)
C     I1MACH(2) = (YOUR OUTPUT UNIT NUMBER)
C (WITH THE WORDS ON THE RIGHT OF THESE STATEMENTS REPLACED BY THE
C SPECIFIED INTEGERS).  THE FOLLOWING IS A SPECIAL PURPOSE EXCEEDINGLY
C SIMPLIFIED VERSION OF I1MACH.
C
C
      INTEGER FUNCTION I1MACH(I)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
C
      DIMENSION IMACH(2)
C
C    I1MACH( 1) = THE STANDARD INPUT UNIT.
C    I1MACH( 2) = THE STANDARD OUTPUT UNIT.
C
      IMACH(1) = 1
      IMACH(2) = 2
C
      I1MACH = IMACH(I)
      RETURN
      END
C
C
C THE NEXT FUNCTION SUBPROGRAM IS D1MACH FROM THE BLAS SUBLIBRARY
C OF NETLIB, WHICH SETS DOUBLE PRECISION MACHINE CONSTANTS.
C FOR MOST COMPUTER SYSTEMS, THIS SUBPROGRAM WORKS AUTOMATICALLY, AND
C DOES NOT NEED TO BE CHANGED BY THE USER.
C THE LAD PACKAGE NEEDS ONLY ONE CONSTANT FROM THIS SUBPROGRAM, SO
C IF NECESSARY THE USER CAN COMMENT OUT OR DELETE ALL STATEMENTS BETWEEN
C THE SECOND AND LAST STATEMENTS IN THIS SUBPROGRAM AND REPLACE THEM WITH
C THE STATEMENT
C     D1MACH(3) = (THE VALUE OF B**(-T), WHERE B IS THE BASE FOR DOUBLE
C                 PRECISION NUMBERS AND T IS THE NUMBER OF BASE B DIGITS
C                 IN THE DOUBLE PRECISION MANTISSA)
C (WITH THE WORDS ON THE RIGHT OF THIS STATEMENT REPLACED BY THE
C SPECIFIED DOUBLE PRECISION NUMBER).
C THE INTEGERS B AND T ARE MACHINE DEPENDENT VALUES (B = 2 AND T = 53 IN
C MANY RECENT SUN, IBM, APPLE, AND INTEL BASED MACHINES).  THE FOLLOWING
C IS ALSO A SPECIAL PURPOSE EXCEEDINGLY SIMPLIFIED VERSION OF FUNCTION D1MACH.
C
C
      DOUBLE PRECISION FUNCTION D1MACH(I)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
C
      DIMENSION DMACH(5)
C
C  DOUBLE-PRECISION MACHINE CONSTANTS
C  D1MACH( 1) = B**(EMIN-1), THE SMALLEST POSITIVE MAGNITUDE.
C  D1MACH( 2) = B**EMAX*(1 - B**(-T)), THE LARGEST MAGNITUDE.
C  D1MACH( 3) = B**(-T), THE SMALLEST RELATIVE SPACING.
C  D1MACH( 4) = B**(1-T), THE LARGEST RELATIVE SPACING.
C  D1MACH( 5) = LOG10(B)
C
      IB = 2
      IT = 53
C
      DMACH(1) = 0.0D0
      DMACH(2) = 0.0D0
      DMACH(3) = 1.0D0/((1.0D0*IB)**IT)
      DMACH(4) = 1.0D0/((1.0D0*IB)**(IT-1))
      DMACH(5) = DLOG10(1.0D0*IB)
C
      D1MACH = DMACH(I)
      RETURN
      END
C
C
      INTEGER FUNCTION ILOC(IARR,NPARM,NUMGR)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
C
C THIS FUNCTION SUBPROGRAM RETURNS THE SUBSCRIPT OF THE FIRST ELEMENT OF
C ARRAY IARR RELATIVE TO IWORK (IF THE ARRAY IS INTEGER, I.E. 13 .LE.
C IARR .LE. 23) OR RELATIVE TO WORK (IF THE ARRAY IS FLOATING POINT, I.E.
C 1 .LE. IARR .LE. 12 OR 24 .LE. IARR .LE. 48).
C
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     *170,180,190,200,210,220,230,240,250,260,270,280,290,300,310,320,
     *330,340,350,360,370,380,390,400,410,420,430,440,450,460,470,
     *480),IARR
C
C   1  AA(NPARM+1,NPARM+1)  (OPPOSITE V, Y; STARTS AT V STARTING POINT)
   10 ILOC=3*NUMGR*NPARM+6*NUMGR+11*NPARM+8
      RETURN
C
C   2  ACTDIF(NUMGR)
   20 ILOC=1
      RETURN
C
C   3  B(NPARM+1)  (OPPOSITE V, Y;  FOLLOWS AA)
   30 ILOC=NPARM**2+3*NUMGR*NPARM+6*NUMGR+13*NPARM+9
      RETURN
C
C   4  BETA(NPARM+1)  (OPPOSITE V, Y;  FOLLOWS B)
   40 ILOC=NPARM**2+3*NUMGR*NPARM+6*NUMGR+14*NPARM+10
      RETURN
C
C   5  BNDKP(NPARM) (FOLLOWS ACTDIF)
   50 ILOC=NUMGR+1
      RETURN
C
C   6  COEF(NUMGR)
   60 ILOC=NUMGR+NPARM+1
      RETURN
C
C   7  COFBND(NPARM)
   70 ILOC=2*NUMGR+NPARM+1
      RETURN
C
C   8  CONFUN(NUMGR,NPARM+1)  (OPPOSITE PMAT1)
   80 ILOC=2*NUMGR+2*NPARM+1
      RETURN
C
C   9  D(NPARM+1)  (OPPOSITE V, Y;  FOLLOWS BETA)
   90 ILOC=NPARM**2+3*NUMGR*NPARM+6*NUMGR+15*NPARM+11
      RETURN
C
C  10  DVEC(NPARM) (FOLLOWS CONFUN)
  100 ILOC=NUMGR*NPARM+3*NUMGR+2*NPARM+1
      RETURN
C
C  11  ERR1(NUMGR+3)
  110 ILOC=NUMGR*NPARM+3*NUMGR+3*NPARM+1
      RETURN
C
C  12  FUNTBL(NUMGR,NPARM+1)
  120 ILOC=NUMGR*NPARM+4*NUMGR+3*NPARM+4
      RETURN
C
C  13  IACT(NUMGR)
  130 ILOC=1
      RETURN
C
C  14  IACT1(NUMGR)
  140 ILOC=NUMGR+1
      RETURN
C
C  15  ICOR(NPARM+1)
  150 ILOC=2*NUMGR+1
      RETURN
C
C  16  ICOR1(NPARM+1)  (DOES NOT APPEAR IN PROGRAM BY NAME)
  160 ILOC=2*NUMGR+NPARM+2
      RETURN
C
C  17  ICNTYP(NUMGR)
  170 ILOC=2*NUMGR+2*NPARM+3
      RETURN
C
C  18  IXRCT(NUMGR+2*NPARM)
  180 ILOC=3*NUMGR+2*NPARM+3
      RETURN
C
C  19  IYCCT(NPARM+1) (OPPOSITE KPIVOT)
  190 ILOC=4*NUMGR+4*NPARM+3
      RETURN
C
C  20  IYRCT(NUMGR+2*NPARM)
  200 ILOC=4*NUMGR+5*NPARM+4
      RETURN
C
C  21  JCNTYP(NUMGR)
  210 ILOC=5*NUMGR+7*NPARM+4
      RETURN
C
C  22  KCNTYP(NUMGR)
  220 ILOC=6*NUMGR+7*NPARM+4
      RETURN
C
C  23  KPIVOT(NPARM+1)  (OPPOSITE IYCCT)
  230 ILOC=4*NUMGR+4*NPARM+3
      RETURN
C
C  24  PARAM1(NPARM) (FOLLOWS FUNTBL)
  240 ILOC=2*NUMGR*NPARM+5*NUMGR+3*NPARM+4
      RETURN
C
C  25  PARPRJ(NPARM)
  250 ILOC=2*NUMGR*NPARM+5*NUMGR+4*NPARM+4
      RETURN
C
C  26  PARSER(NPARM)
  260 ILOC=2*NUMGR*NPARM+5*NUMGR+5*NPARM+4
      RETURN
C
C  27  PARWRK(NPARM)
  270 ILOC=2*NUMGR*NPARM+5*NUMGR+6*NPARM+4
      RETURN
C
C  28  PICOR(NPARM+1,NPARM+1)  (OPPOSITE V, Y;  FOLLOWS D)
  280 ILOC=NPARM**2+3*NUMGR*NPARM+6*NUMGR+16*NPARM+12
      RETURN
C
C  29  PMAT(NPARM+1,NUMGR) (FOLLOWS PARWRK)
  290 ILOC=2*NUMGR*NPARM+5*NUMGR+7*NPARM+4
      RETURN
C
C  30  PMAT1(NPARM+1,NUMGR)  (OPPOSITE CONFUN)
  300 ILOC=2*NUMGR+2*NPARM+1
      RETURN
C
C  31  PTNR(NPARM+1) (FOLLOWS PMAT)
  310 ILOC=3*NUMGR*NPARM+6*NUMGR+7*NPARM+4
      RETURN
C
C  32  PTNRR(NPARM+1)
  320 ILOC=3*NUMGR*NPARM+6*NUMGR+8*NPARM+5
      RETURN
C
C  33  R(NPARM+1)
  330 ILOC=3*NUMGR*NPARM+6*NUMGR+9*NPARM+6
      RETURN
C
C  34  SAVE(NPARM+1)
  340 ILOC=3*NUMGR*NPARM+6*NUMGR+10*NPARM+7
      RETURN
C
C  35  V(NUMGR+2*NPARM+1,NPARM+2)  (WITH Y, OPPOSITE AA, B, BETA, D,
C      PICOR, ZWORK)
  350 ILOC=3*NUMGR*NPARM+6*NUMGR+11*NPARM+8
      RETURN
C
C  36  VDER(NPARM) (FOLLOWS Y)
  360 ILOC=2*NPARM**2+4*NUMGR*NPARM+9*NUMGR+18*NPARM+10
      RETURN
C
C  37  VDERN(NPARM)
  370 ILOC=2*NPARM**2+4*NUMGR*NPARM+9*NUMGR+19*NPARM+10
      RETURN
C
C  38  VDERS(NPARM)
  380 ILOC=2*NPARM**2+4*NUMGR*NPARM+9*NUMGR+20*NPARM+10
      RETURN
C
C  39  VEC(NPARM+1)
  390 ILOC=2*NPARM**2+4*NUMGR*NPARM+9*NUMGR+21*NPARM+10
      RETURN
C
C  40  WCOEF(NUMGR)
  400 ILOC=2*NPARM**2+4*NUMGR*NPARM+9*NUMGR+22*NPARM+11
      RETURN
C
C  41  WCOEF1(NUMGR)  (DOES NOT APPEAR IN THE PROGRAM BY NAME)
  410 ILOC=2*NPARM**2+4*NUMGR*NPARM+10*NUMGR+22*NPARM+11
      RETURN
C
C  42  WPT(NPARM)
  420 ILOC=2*NPARM**2+4*NUMGR*NPARM+11*NUMGR+22*NPARM+11
      RETURN
C
C  43  WVEC(NPARM)
  430 ILOC=2*NPARM**2+4*NUMGR*NPARM+11*NUMGR+23*NPARM+11
      RETURN
C
C  44  X(NPARM+1)
  440 ILOC=2*NPARM**2+4*NUMGR*NPARM+11*NUMGR+24*NPARM+11
      RETURN
C
C  45  XKEEP(NPARM+1)
  450 ILOC=2*NPARM**2+4*NUMGR*NPARM+11*NUMGR+25*NPARM+12
      RETURN
C
C  46  XRK(NPARM+1)
  460 ILOC=2*NPARM**2+4*NUMGR*NPARM+11*NUMGR+26*NPARM+13
      RETURN
C
C  47  Y(NUMGR+2*NPARM)  (WITH V, OPPOSITE AA, B, BETA, D, PICOR,
C      ZWORK;  FOLLOWS V)
  470 ILOC=2*NPARM**2+4*NUMGR*NPARM+8*NUMGR+16*NPARM+10
      RETURN
C
C  48  ZWORK(NPARM)  (OPPOSITE V, Y;  FOLLOWS PICOR)
  480 ILOC=2*NPARM**2+3*NUMGR*NPARM+6*NUMGR+18*NPARM+13
      RETURN
      END
C
C
      SUBROUTINE DERST(IOPTN,NPARM,NUMGR,PTTBL,IPTB,INDM,PARAM,
     *IPT,PARAM1,V,KCNTYP,CONFUN,IZ)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
C
      DIMENSION PTTBL(IPTB,INDM),PARAM(NPARM),PARAM1(NPARM),
     *V(NUMGR+2*NPARM+1,NPARM+2),KCNTYP(NUMGR),
     *CONFUN(NUMGR,NPARM+1),IZ(3)
C
C THIS SUBROUTINE USES FNSET TO COMPUTE CONFUN(I,1) AND THE PARTIAL
C DERIVATIVES OF THE FUNCTION WHOSE VALUE IS IN CONFUN(I,1) FOR
C CERTAIN VALUE(S) OF I.  NOTE THAT WE DO NOT WANT THE ICNTYP COMPUTED
C BY FNSET TO OVERRIDE THE ICNTYP (OR JCNTYP) CARRIED INTO THIS
C SUBROUTINE IN ICNTYP, SO WE USE KCNTYP WHEN WE CALL FNSET.  (THE
C ICNTYP COMPUTED BY FNSET WAS STORED EARLIER THROUGH A CALL TO ERCMP1
C FROM CONMAX.)
C
C IF THE ONES DIGIT OF IOPTN IS 0, WE CALL FNSET WITH INDFN=1 TO DO THE
C COMPUTATIONS DIRECTLY USING FORMULAS SUPPLIED BY THE USER.
      IOPONE=IOPTN-(IOPTN/10)*10
      IF(IOPONE)100,100,200
  100 CALL FNSET (NPARM,NUMGR,PTTBL,IPTB,INDM,PARAM,IPT,1,KCNTYP,
     *CONFUN,IZ)
      RETURN
C
C HERE THE ONES DIGIT OF IOPTN IS 1, AND WE APPROXIMATE THE PARTIAL
C DERIVATIVES USING CENTERED DIFFERENCE APPROXIMATIONS.
C
  200 IOPTTH=(IOPTN-(IOPTN/100000)*100000)/10000
C
C SET PRECISION DEPENDENT CONSTANTS.
      SPCMN=D1MACH(3)
      DELT=SQRT(SPCMN)
      DELT2=DELT+DELT
      IF(IOPTTH)300,300,700
C
C HERE IOPONE=1 AND IOPTTH=0, AND WE WORK ONLY WITH CONSTRAINT IPT,
C WHERE IPT WILL BE AN INTEGER BETWEEN 1 AND NUMGR.
C L WILL BE THE INDEX OF THE VARIABLE WITH RESPECT TO WHICH WE ARE
C COMPUTING THE PARTIAL DERIVATIVE.
  300 DO 500 L=1,NPARM
C
C SET PARAM1 EQUAL TO PARAM, ECXEPT WITH ITS LTH COMPONENT INCREASED
C BY DELT.
        DO 400 J=1,NPARM
          PARAM1(J)=PARAM(J)
  400   CONTINUE
        PARAM1(L)=PARAM(L)+DELT
C
C NOW CALL FNSET WITH INDFN=0 TO PLACE THE FUNCTION IN CONSTRAINT
C IPT EVALUATED AT POINT PARAM1 IN CONFUN(IPT,1).
        CALL FNSET(NPARM,NUMGR,PTTBL,IPTB,INDM,PARAM1,IPT,0,
     *  KCNTYP,CONFUN,IZ)
        UP=CONFUN(IPT,1)
C
C SET PARAM1 EQUAL TO PARAM, ECXEPT WITH ITS LTH COMOPONENT DECREASED
C BY DELT, AND CALL FNSET AGAIN.
        PARAM1(L)=PARAM(L)-DELT
        CALL FNSET(NPARM,NUMGR,PTTBL,IPTB,INDM,PARAM1,IPT,0,
     *  KCNTYP,CONFUN,IZ)
C
C NOW WE CAN COMPUTE THE CENTERED-DIFFERENCE APPROXIMATION TO THE PARTIAL
C DERIVATIVE OF THE FUNCTION IN CONSTRAINT IPT WITH RESPECT TO THE LTH
C VARIABLE AT THE POINT PARAM.  THIS BELONGS IN CONFUN(IPT,L+1), AND
C WE COULD PUT IT THERE NOW IF THE USER FOLLOWED DIRECTIONS AND DID NOT
C CHANGE CONFUN(IPT,L+1) (SINCE INDFN=0) IN LATER FNSET CALLS, BUT TO
C BE SAFE WE TEMPORARILY STORE IT IN V(L,1).
C NOTE THAT V IS USED ELSEWHERE IN THE PROGRAM, BUT HERE IT IS JUST A
C WORK ARRAY, WHILE THE WORK ARRAY PARAM1 IS NOT USED ELSEWHERE IN
C THE PROGRAM.
        V(L,1)=(UP-CONFUN(IPT,1))/DELT2
  500 CONTINUE
C
C NOW COMPUTE THE VALUE OF THE FUNCTION AT PARAM, AND THEN PUT THE
C EARLIER-COMPUTED PARTIAL DERIVATIVES INTO CONFUN.
      CALL FNSET(NPARM,NUMGR,PTTBL,IPTB,INDM,PARAM,IPT,0,
     *KCNTYP,CONFUN,IZ)
      DO 600 L=1,NPARM
        CONFUN(IPT,L+1)=V(L,1)
  600 CONTINUE
      RETURN
C
C HERE IOPONE=1 AND IOPTTH=1, AND EACH TIME FNSET IS CALLED IT WILL
C COMPUTE VALUES FOR THE FUNCTIONS IN THE LEFT SIDES OF ALL CONSTRAINTS
C (EXCEPT THOSE WHERE FNSET SETS ICNTYP(I)=0) IF IPT=0, AND WILL COMPUTE
C VALUES FOR THE FUNCTIONS IN THE LEFT SIDES OF ALL STANDARD (I.E. TYPE
C -1 OR -2) CONSTRAINTS IF IPT=-1.
C WE FIRST SAVE IPT IN CASE THE USER CHANGES IT IN A FNSET CALL;  WE WILL
C RESTORE IT AFTER EACH FNSET CALL.
  700 IPTKP=IPT
      NPAR1=NPARM+1
C
C WE WILL COMPUTE APPROXIMATIONS TO PARTIAL DERIVATIVES FOR THOSE
C CONSTRAINTS WHICH FNSET IS ASKED BY IPT TO COMPUTE.  TO DETERMINE WHICH
C THESE ARE WE ZERO OUT KCNTYP;  AFTER A FNSET CALL, THE DESIRED
C CONSTRAINTS WILL BE THE CONSTRAINTS K WITH KCNTYP(K) .NE. 0 IF IPT=0,
C OR THE CONSTRAINTS K WITH KCNTYP(K) .LT. 0 IF IPT=-1.
      DO 800 K=1,NUMGR
        KCNTYP(K)=0
  800   CONTINUE
C
C NOW FOLLOW BASICALLY THE SAME PROCEDURES AS IN THE IOPTTH=0 CASE DONE
C ABOVE.
      DO 1800 L=1,NPARM
        DO 900 J=1,NPARM
          PARAM1(J)=PARAM(J)
  900   CONTINUE
        PARAM1(L)=PARAM(L)+DELT
        CALL FNSET(NPARM,NUMGR,PTTBL,IPTB,INDM,PARAM1,IPT,0,
     *  KCNTYP,CONFUN,IZ)
        IPT=IPTKP
        DO 1300 K=1,NUMGR
          IF(IPT)1100,1000,1000
 1000     IF(KCNTYP(K))1200,1300,1200
 1100     IF(KCNTYP(K))1200,1300,1300
C
C SAVE THE UPPER NUMBERS IN COLUMN NPARM+1 OF V.
 1200     V(K,NPAR1)=CONFUN(K,1)
 1300   CONTINUE
C
C REVISE PARAM1 AND CALL FNSET AGAIN.
        PARAM1(L)=PARAM(L)-DELT
        CALL FNSET(NPARM,NUMGR,PTTBL,IPTB,INDM,PARAM1,IPT,0,
     *  KCNTYP,CONFUN,IZ)
        IPT=IPTKP
        DO 1700 K=1,NUMGR
          IF(IPT)1500,1400,1400
 1400     IF(KCNTYP(K))1600,1700,1600
 1500     IF(KCNTYP(K))1600,1700,1700
C
C STORE THE APPROXIMATE PARTIAL DERIVATIVES WITH RESPECT TO THE LTH
C VARIABLE IN THE LTH COLUMN OF V.
 1600     V(K,L)=(V(K,NPAR1)-CONFUN(K,1))/DELT2
 1700   CONTINUE
 1800 CONTINUE
C CALL FNSET AGAIN TO COMPUTE THE VALUES OF THE FUNCTIONS AT POINT
C PARAM, AND THEN PUT THE EARLIER-COMPUTED PARTIAL DERIVATIVES INTO
C CONFUN.
      CALL FNSET(NPARM,NUMGR,PTTBL,IPTB,INDM,PARAM,IPT,0,
     *KCNTYP,CONFUN,IZ)
      DO 2300 K=1,NUMGR
        IF(IPT)2000,1900,1900
 1900   IF(KCNTYP(K))2100,2300,2100
 2000   IF(KCNTYP(K))2100,2300,2300
 2100   DO 2200 L=1,NPARM
          CONFUN(K,L+1)=V(K,L)
 2200   CONTINUE
 2300 CONTINUE
      RETURN
      END
C
C
      SUBROUTINE SEARSL(IOPTN,NUMGR,NPARM,PRJLIM,TOL1,X,FUN,IFUN,
     *PTTBL,IPTB,INDM,PARAM,ERROR,RCHDWN,MACT,IACT,IPHSE,UNIT,
     *TOLCON,RCHIN,ITYPM1,ITYPM2,IWORK,LIWRK,WORK,LWRK,ERR1,PARPRJ,
     *PROJCT,EMIN,EMIN1,PARSER,NSRCH,IZ)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
C
      DIMENSION FUN(IFUN),PTTBL(IPTB,INDM),PARAM(NPARM),ERR1(NUMGR+3),
     *PARPRJ(NPARM),X(NPARM+1),ERROR(NUMGR+3),IZ(3),
     *IACT(NUMGR),PARSER(NPARM),IWORK(LIWRK),WORK(LWRK)
C
C THIS SUBROUTINE USES A MODIFIED QUADRATIC FITTING PROCESS TO
C SEARCH FOR THE MINIMUM OF A FUNCTION F.  IT REQURES AN INITIAL
C GUESS IN PROJCT, A TOLERANCE TOL1 ON THE SEARCH INTERVAL LENGTH,
C AN UPPER BOUND PRJLIM ON THE MINIMIZING POINT (WHICH SHOULD BE SET
C VERY LARGE IF NO UPPER BOUND IS DESIRED), AND A WAY TO COMPUTE F(X)
C FOR A GIVEN X.  THE SUBROUTINE WILL RETURN IF IT WOULD NEED TO COMPUTE
C F MORE THAN INITLM TIMES IN THE INITIALIZATION OR MORE THAN NADD
C ADDITIONAL TIMES IN THE MAIN PART OF THE PROGRAM.
C WHEN THE SUBROUTINE RETURNS, IT WILL HAVE PUT THE MINIMUM LOCATION IN
C PROJCT, THE MINIMUM F VALUE IN EMIN, THE F VALUE FOR THE INITIAL
C PROJCT IN EMIN1, AND THE NUMBER OF TIMES IT COMPUTED F IN NSRCH.
C
C SET MACHINE AND PRECISION DEPENDENT CONSTANTS FOR SEARSL.
      ONE=1.0D0
      TWO=ONE+ONE
      FOUR=TWO+TWO
      TEN=FOUR+FOUR+TWO
      SPCMN=D1MACH(3)
      BIG=ONE/SPCMN
      TOLDEN=TEN*SPCMN
      TOL4=TOL1/FOUR
      BALFCT=TEN
      BALADJ=(TEN-ONE)/TEN
      ILC08=ILOC(8,NPARM,NUMGR)
      ILC10=ILOC(10,NPARM,NUMGR)
      ILC17=ILOC(17,NPARM,NUMGR)
      ILC21=ILOC(21,NPARM,NUMGR)
      ILC27=ILOC(27,NPARM,NUMGR)
      ILC29=ILOC(29,NPARM,NUMGR)
      ILC48=ILOC(48,NPARM,NUMGR)
C
C THE INITIAL PROJCT CAN BE INCREASED (OR DECREASED) BY A FACTOR OF
C 2.0**((INITLM-1)*INITLM-2)/2) (ASSUMING WE TAKE INITLM .GE. 3, AS
C WE SHOULD).  WE TAKE INITLM=6 SINCE A FACTOR OF 1024 SEEMS SUFFICIENT.
      INITLM=6
C NADD=4 SEEMS TO BE SUFFICIENT SINCE THIS NUMBER OF ITERATIONS PAST THE
C INITIALIZATION SEEMS TO ONLY RARELY BE EXCEEDED.
      NADD=4
      NSRCH=0
      ILF=0
      IRT=0
      IUPBAR=0
      ISAVE=0
C INITIALLY PUT PARAM IN PARSER SO THERE WILL BE SOMETHING THERE IF
C WE NEVER GET A CORRECTIBLE PARPRJ.
      DO 55 J=1,NPARM
        PARSER(J)=PARAM(J)
   55 CONTINUE
C WE NOW TRY TO COMPUTE VALUES AT POINTS P2=PROJCT, P1=P2/2.0, AND
C P3=2.0*P2 (BUT P3 CANNOT EXCEED PRJLIM).
      P2=PROJCT
C SET LLL=2 AS THE THREAD THROUGH THE MINOTAURS CAVERN AND JUMP
C DOWN TO PUT F(P2) IN F2.  WE WILL JUMP BACK AFTER ALL SUCH JUMPS
      LLL=2
      PVAL=P2
      GO TO 3500
C
   77 F2=FVAL
C SET EMIN1 = THE VALUE OF F USING THE GIVEN PROJECTION FACTOR PROJCT.
      EMIN1=FVAL
      P1=P2/TWO
C SET LLL=1 AND PUT F(P1) IN F1.
      LLL=1
      PVAL=P1
      GO TO 3500
C
   97 F1=FVAL
      P3=TWO*P2
C IF P3 .GT. PRJLIM, SET IUPBAR=1 AS AN INDICATOR WE CANNOT LATER
C EXPAND THE INTERVAL TO THE RIGHT.  THEN IF PRJLIM .GE. P2+TOL4
C REPLACE P3 BY PRJLIM, AND OTHERWISE EXPAND THE INTERVAL TO THE
C LEFT TO GET THE DESIRED THIRD POINT.
      IF(P3-PRJLIM)160,160,120
  120 IUPBAR=1
      IF(PRJLIM-P2-TOL4)220,140,140
  140 P3=PRJLIM
C HERE SET LLL=3 AND PUT F(P3) IN F3.
  160 LLL=3
      PVAL=P3
      GO TO 3500
C
  187 F3=FVAL
      GO TO 280
C
C EXPAND LEFT TO GET THE INITIAL THIRD POINT SINCE THERE IS NO ROOM
C TO EXPAND RIGHT.
  220 P3=P2
      F3=F2
      P2=P1
      F2=F1
      P1=P1/TWO
C SET LLL=4 AND PUT F(P1) IN F1.
      LLL=4
      PVAL=P1
      GO TO 3500
C
  247 F1=FVAL
C
C WE NOW HAVE FOUND P1, P2, AND P3 WITH CORRESPONDING VALUES
C F1, F2, AND F3.  WE EXPAND THE INTERVAL IF NECESSARY TO TRY
C TO FIND NEW VALUES WITH F2 .LE. MIN(F1,F3).
  280 IF(F2-F1)500,500,300
  300 IF(F1-F3)320,320,520
C
C HERE WE WILL EXPAND THE INTERVAL TO THE LEFT, PROVIDING THAT
C NSRCH .LT. INITLM AND P1-P1/2.0**(NSRCH-1) .GE. TOL4.
  320 IF(NSRCH-INITLM)340,360,360
  340 IF(P1-P1/TWO**(NSRCH-1)-TOL4)360,380,380
C
C HERE WE CANNOT EXPAND LEFT AND WE RETURN WITH THE BEST VALUES
C FOUND SO FAR.
  360 PROJCT=P1
      EMIN=F1
      RETURN
C
C EXPAND LEFT.
  380 P3=P2
      F3=F2
      P2=P1
      F2=F1
      P1=P1/TWO**(NSRCH-1)
C SET LLL=5 AND PUT F(P1) IN F1.
      LLL=5
      PVAL=P1
      GO TO 3500
  407 F1=FVAL
C
C HERE F2 .LE. F3 AND WE HAVE JUST EXPANDED LEFT.  IF F2 .GT. F1 WE
C TRY TO EXPAND LEFT AGAIN, OTHERWISE WE CHECK TO SEE IF WE ARE DONE
C INITIALIZING.
      IF(F2-F1)440,440,320
C
C HERE WE CHECK TO SEE IF THE F COMPUTATION HAS FAILED EVERY TIME
C (INDICATED BY F1=F2=F3=BIG), AND IF SO WE TRY TO EXPAND LEFT.
C IF NOT, WE ARE DONE WITH THE INITIALIZATION.
  440 IF(F1-BIG)1100,460,460
  460 IF(F2-BIG)1100,480,480
  480 IF(F3-BIG)1100,320,320
C
C HERE F2 .LE. F1.  IF F2 .LE. F3 AND WE HAVE NOT HAD ALL FAILURES OF
C THE F COMPUTATION, WE ARE DONE INITIALIZING.
  500 IF(F2-F3)440,440,520
C
C HERE F3 .LT. MIN(F1,F2) AND WE EXPAND THE INTERVAL TO THE RIGHT IF
C NSRCH .LT. INITLM AND IUPBAR=0.
  520 IF(NSRCH-INITLM)540,560,560
  540 IF(IUPBAR)580,580,560
C
C HERE WE CANNOT EXPAND RIGHT AND WE RETURN WITH THE BEST VALUES
C FOUND SO FAR.
  560 PROJCT=P3
      EMIN=F3
      RETURN
C
C EXPAND RIGHT.
  580 P1=P2
      F1=F2
      P2=P3
      F2=F3
      P3=TWO**(NSRCH-1)*P2
C IF P3 .GT. PRJLIM, SET IUPBAR=1 AS AN INDICATOR WE CANNOT LATER
C EXPAND THE INTERVAL TO THE RIGHT.  THEN IF PRJLIM .GE. P2+TOL4
C REPLACE P3 BY PRJLIM, AND OTHERWISE RETURN WITH THE BEST VALUES
C FOUND SO FAR.
      IF(P3-PRJLIM)660,660,600
  600 IUPBAR=1
      IF(PRJLIM-P2-TOL4)620,640,640
  620 PROJCT=P2
      EMIN=F2
      RETURN
C
  640 P3=PRJLIM
C
C SET LLL=6 AND PUT F(P3) IN F3.
  660 LLL=6
      PVAL=P3
      GO TO 3500
  687 F3=FVAL
C
C HERE F2 .LT. F1 AND WE HAVE JUST EXPANDED RIGHT.  IF F2 .LE. F3
C WE ARE DONE INITIALIZING, OTHERWISE WE TRY TO EXPAND RIGHT AGAIN.
      IF(F2-F3)1100,1100,520
C END OF INITIALIZATION.
C
C ASSUMING THAT P3-P1 .GE. TOL1, WE NOW HAVE POINTS P1, P2, P3 WITH
C P1 .LE. P2-TOL4, P2 .LE. P3-TOL4, F1=F(P1) .GE. F2=F(P2), AND F3=F(P3)
C .GE. F2.  THESE CONDITIONS WILL BE MAINTAINED THROUGHOUT THE PROGRAM.
C SET LLL=7, WHERE IT WILL REMAIN FROM NOW ON.
 1100 LLL=7
C
C RESET LIMS1 SO THAT AT MOST NADD MORE COMPUTATIONS OF F WILL BE DONE.
      LIMS1=NSRCH+NADD
C
C IF WE HAVE COMPUTED F LIMS1 TIMES, WE PUT P2 IN PROJCT, PUT F2 IN
C EMIN, AND RETURN.
 1200 IF(NSRCH-LIMS1)1250,1300,1300
C
C IF THE SEARCH INTERVAL LENGTH IS LESS THAN TOL1 WE PUT P2 IN
C PROJCT, PUT F2 IN EMIN, AND RETURN.
 1250 IF(P3-P1-TOL1)1300,1400,1400
C
 1300 PROJCT=P2
      EMIN=F2
      RETURN
C
C COMPUTE S1 = THE ABSOLUTE VALUE OF THE SLOPE OF THE LINE THROUGH
C (P1,F1) AND (P2,F2), AND S2 = THE (ABSOLUTE VALUE OF THE) SLOPE
C OF THE LINE THROUGH (P2,F2) AND (P3,F3).
 1400 S1=(F1-F2)/(P2-P1)
      S2=(F3-F2)/(P3-P2)
C IF S1+S2 IS VERY SMALL WE RETURN WITH THE BEST VALUES FOUND SO FAR.
      IF(S1+S2-TOLDEN)1300,1600,1600
C
 1600 RLF=S2/(S1+S2)
      RRT=ONE-RLF
C THE MINIMUM OF THE QUADRATIC POLYNOMIAL PASSING THROUGH
C (P1,F1), (P2,F2), AND (P3,F3) WILL OCCUR AT (RLF*P1+
C RRT*P3+P2)/2.0.  NOTE THAT THE THREE POINTS CANNOT BE
C COLLNEAR, ELSE WE WOULD HAVE TERMINATED ABOVE.  SINCE THE
C MINIMUM OCCURS AT THE AVERAGE OF P2 AND A CONVEX COMBINATION
C OF P1 AND P3, IT WILL BE AT LEAST AS CLOSE TO P2 AS TO THE
C ENDPOINT ON THE SAME SIDE.
      IF(ILF-1)1800,1800,1700
C
C HERE THE LEFT ENDPOINT WAS DROPPED AT THE LAST ILF .GT. 1
C ITERATIONS, SO TO PREVENT A LONG STRING OF SUCH OCCURRENCES
C WITH LITTLE REDUCTION OF P3-P1 WE WILL SHIFT THE NEW POINT
C TO THE RIGHT BY DECREASING RLF RELATIVE TO RRT.
 1700 RLF=RLF/TWO**(ILF-1)
      RRT=ONE-RLF
      GO TO 2400
 1800 IF(IRT-1)2000,2000,1900
C
C HERE THE RIGHT ENDPOINT WAS DROPPED AT THE LAST IRT .GT. 1
C ITERATIONS, AND WE WILL SHIFT THE NEW POINT TO THE LEFT.
 1900 RRT=RRT/TWO**(IRT-1)
      RLF=ONE-RRT
      GO TO 2400
C
C HERE WE HAVE NOT JUST HAD A STRING OF TWO OR MORE MOVES IN
C THE SAME DIRECTION, BUT IF THE SUBINTERVALS ARE OUT OF
C BALANCE BY MORE THAN A FACTOR OF BALFCT, WE SHIFT THE NEW
C POINT SLIGHTLY IN THE DIRECTION OF THE LONGER INTERVAL.  THE
C IDEA HERE IS THAT THE TWO CLOSE POINTS ARE PROBABLY NEAR THE
C SOLUTION, AND IF WE CAN BRACKET THE SOLUTION WE MAY BE ABLE TO
C CUT OFF THE MAJOR PORTION OF THE LONGER SUBINTERVAL.
 2000 IF(P2-P1-BALFCT*(P3-P2))2200,2200,2100
C
C HERE THE LEFT SUBINTERVAL IS MORE THAN BALFCT TIMES LONGER THAN
C THE RIGHT SUBINTERVAL, SO WE DECREASE RRT RRELATIVE TO RLF.
 2100 RRT=BALADJ*RRT
      RLF=ONE-RRT
      GO TO 2400
 2200 IF(P3-P2-BALFCT*(P2-P1))2400,2400,2300
C
C HERE THE RIGHT SUBINTERVAL IS MORE THAN BALFCT TIMES LONGER
C THAN THE LEFT SUBINTERVAL, SO WE DECREASE RLF RELATIVE TO RRT.
 2300 RLF=BALADJ*RLF
      RRT=ONE-RLF
C
C COMPUTE THE (POSSIBLY MODIFIED) MINIMUM OF THE QUADRATIC FIT.
 2400 P4=(RLF*P1+RRT*P3+P2)/TWO
C
C THE NEXT SECTION (FROM HERE TO STATEMENT 2800) MODIFIES P4 IF NECESSARY
C TO GET P1+TOL4 .LE. P2,P4 .LE. P3-TOL4 AND ABS(P4-P2) .GE. TOL4.  IN
C THE UNLIKELY EVENT THIS IS NOT POSSIBLE WE SET PROJCT=P2, EMIN=F2
C AND RETURN.
C
C IF ABS(P4-P2) .LT. TOL4 WE REDEFINE P4 BY MOVING TOL4 FROM
C P2 INTO THE LONGER SUBINTERVAL.  NOTE THAT THE LENGTH OF THIS
C SUBINTERVAL MUST BE AT LEAST TOL1/2.0 = 2.0*TOL4, ELSE WE
C WOULD HAVE TERMINATED EARLIER.
      IF(ABS(P4-P2)-TOL4)2500,2710,2710
 2500 IF(P3-P2-(P2-P1))2700,2700,2600
 2600 P4=P2+TOL4
C IF TOL4 WAS SMALL ENOUGH RELATIVE TO P2 THAT THE MACHINE THINKS P4
C STILL EQUALS P2, WHICH IS MORE LIKELY IF P2 IS LARGE, THIS COULD RESULT
C IN A DIVIDE FAULT LATER.  TO AVOID THIS, WE REDEFINE P4 AS THE AVERAGE
C OF P2 AND P3 IF NECESSARY.  IF WE STILL DONT HAVE P4 STRICTLY BETWEEN
C P2 AND P3, WE TERMINATE THE SEARCH.
      IF(P4-P2)2620,2620,2640
 2620 P4=(P2+P3)/TWO
      IF(P4-P2)1300,1300,2640
 2640 IF(P4-P3)2800,1300,1300
 2700 P4=P2-TOL4
C IF TOL4 WAS SMALL ENOUGH RELATIVE TO P2 THAT THE MACHINE THINKS P4
C STILL EQUALS P2, WHICH IS MORE LIKELY IF P2 IS LARGE, THIS COULD RESULT
C IN A DIVIDE FAULT LATER.  TO AVOID THIS, WE REDEFINE P4 AS THE AVERAGE
C OF P1 AND P2 IF NECESSARY.  IF WE STILL DONT HAVE P4 STRICTLY BETWEEN
C P1 AND P2, WE TERMINATE THE SEARCH.
      IF(P4-P2)2704,2702,2702
 2702 P4=(P1+P2)/TWO
      IF(P4-P2)2704,1300,1300
 2704 IF(P4-P1)1300,1300,2800
C HERE WE HAD ABS(P4-P2) .GE. TOL4 AND WE MAKE SURE THAT P1+TOL4
C .LE. P4 .LE. P3-TOL4.
 2710 IF(P4-(P3-TOL4))2740,2740,2720
C HERE P4 .GT. P3-TOL4 AND WE SET P4=P3-TOL4 IF P3-P2 .GE. TOL1/2.0,
C AND OTHERWISE WE SET P4=P2-TOL4.
 2720 IF(P3-P2-TOL1/TWO)2700,2730,2730
 2730 P4=P3-TOL4
      GO TO 2800
 2740 IF(P4-(P1+TOL4))2750,2800,2800
C HERE P4 .LT. P1+TOL4 AND WE SET P4=P1+TOL4 IF P2-P1 .GE. TOL1/2.0
C AND OTHERWISE WE SET P4=P2+TOL4.
 2750 IF(P2-P1-TOL1/TWO)2600,2760,2760
 2760 P4=P1+TOL4
C
C NOW JUMP DOWN TO PUT F(P4) IN F4.
 2800 PVAL=P4
      GO TO 3500
C
 2877 F4=FVAL
C
C NOW WE DROP EITHER P1 OR P3 AND RELABEL THE REMAINING POINTS SO
C THAT F(P2) .LE. F(P1) AND F(P2) .LE. F(P3).
C
C IF NOW THE LEFTMOST OF THE TWO MIDDLE POINTS IS LOWER THAN THE
C RIGHTMOST OF THE TWO MIDDLE POINTS WE DROP P3, AND SET ILF=0
C AND INCREMENT IRT TO INDICATE THE RIGHT END POINT HAS BEEN DROPPED.
C OTHERWISE WE DROP P1, SET IRT=0 AND INCREMENT ILF.  IN ALL CASES
C WE THEN RESHUFFLE THE VALUES INTO P1, P2, P3, F1, F2, F3 AND TRY
C TO DO ANOTHER ITERATION.
      IF(P4-P2)2900,3200,3200
C
C HERE P4 .LT. P2.
 2900 IF(F4-F2)3000,3100,3100
 3000 P3=P2
      F3=F2
      P2=P4
      F2=F4
      ILF=0
      IRT=IRT+1
      GO TO 1200
 3100 P1=P4
      F1=F4
      ILF=ILF+1
      IRT=0
      GO TO 1200
C
C HERE P4 .GT. P2.
 3200 IF(F2-F4)3300,3400,3400
 3300 P3=P4
      F3=F4
      ILF=0
      IRT=IRT+1
      GO TO 1200
 3400 P1=P2
      F1=F2
      P2=P4
      F2=F4
      ILF=ILF+1
      IRT=0
      GO TO 1200
C
C INCREMENT NSRCH SINCE WE ARE ABOUT TO COMPUTE F.
 3500 NSRCH=NSRCH+1
C
C COMPUTE FVAL=F(PVAL).  IF THE COMPUTATION FAILS, SET FVAL=BIG.
C
      FVAL=BIG
C PROJECT X TO GET PARPRJ.
      DO 4000 J=1,NPARM
        PARPRJ(J)=PARAM(J)+PVAL*X(J)
 4000 CONTINUE
C
CC  CALL CORRCT TO RETURN PARPRJ TO FEASIBILITY IF NECESSARY IF ITYPM1
CC  OR ITYPM2 IS POSITIVE.
CC       IF(ITYPM1+ITYPM2)10070,10070,4020
CC  4020 CALL CORRCT(IOPTN,NPARM,NUMGR,FUN,IFUN,PTTBL,IPTB,INDM,
CC      *IWORK(ILC17),UNIT,TOLCON,RCHIN,ERROR,MACT,IACT,
CC      *PROJCT,IPHSE,IWORK,LIWRK,WORK,LWRK,WORK(ILC27),ERR1,WORK(ILC10),
CC      *WORK(ILC29),WORK(ILC08),WORK(ILC48),IWORK(ILC21),PARPRJ,ICORCT,IZ)
CC       IF(ICORCT)10070,10070,10100
10070 CALL ERCMP1(IOPTN,NPARM,NUMGR,FUN,IFUN,PTTBL,IPTB,INDM,
     *PARPRJ,1,IPHSE,IWORK,LIWRK,WORK(ILC08),IWORK(ILC17),IPMAX,
     *ISMAX,ERR1,IZ)
      FVAL=ERR1(NUMGR+1)
C
CC IF NSRCH=1, INDICATING THAT WE ARE COMPUTING F WITH THE INITIAL PROJCT,
CC CALL RCHMOD WITH IRCH=1 TO INCREASE RCHDWN FOR THE NEXT SETU1 OR
CC RKSACT CALL IF NECESSARY.
CC       IF(NSRCH-1)10071,10071,10073
CC 10071 CALL RCHMOD(NUMGR,ERROR,ERR1,IWORK(ILC17),MACT,IACT,
CC      *IPMAX,ISMAX,UNIT,1,RCHDWN,RCHIN)
C WE WILL SAVE THE BEST PARPRJ FOUND IN THIS SEARSL CALL IN PARSER.
10073 IF(ISAVE)10080,10080,10075
10075 IF(FVAL-FVLKP)10085,10100,10100
10080 ISAVE=1
10085 DO 10090 J=1,NPARM
        PARSER(J)=PARPRJ(J)
10090 CONTINUE
      FVLKP=FVAL
C IF IPHSE .LT. 0 AND FVAL .LE. TOLCON WE RETURN WITH THE BEST VALUES
C FOUND SO FAR.
      IF(IPHSE)10093,10100,10100
10093 IF(FVAL-TOLCON)10097,10097,10100
10097 PROJCT=PVAL
      EMIN=FVAL
      RETURN
C
C CARRY THE COMPUTED F VALUE BACK TO THE APPROPRIATE PART OF THE PROGRAM.
10100 GO TO (97,77,187,247,407,687,2877),LLL
      END
C
C
      SUBROUTINE ERCMP1(IOPTN,NPARM,NUMGR,FUN,IFUN,PTTBL,IPTB,
     *INDM,PARAM,ICNUSE,IPHSE,IWORK,LIWRK,CONFUN,ICNTYP,IPMAX,
     *ISMAX,ERROR,IZ)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
C
      DIMENSION FUN(IFUN),PTTBL(IPTB,INDM),PARAM(NPARM),ICNTYP(NUMGR),
     *ERROR(NUMGR+3),CONFUN(NUMGR,NPARM+1),IWORK(LIWRK),IZ(3)
C
C SET PRECISION DEPENDENT CONSTANTS.
      ONE=1.0D0
      ZERO=ONE-ONE
      ILC22=ILOC(22,NPARM,NUMGR)
      IOPTTH=(IOPTN-(IOPTN/100000)*100000)/10000
      IF(IOPTTH)100,100,1700
C
C HERE IOPTTH=0, AND EACH CALL TO FNSET WILL COMPUTE FUNCTION VALUES
C FOR ONLY ONE CONSTRAINT.
  100 DO 1600 I=1,NUMGR
        IPT=I
        IF(ICNUSE)200,200,600
C
C HERE ICNUSE=0 SO WE WILL ACCEPT AND USE THE ICNTYP(I) COMPUTED BY
C FNSET.
C CALL FNSET WITH INDFN=0 TO COMPUTE CONFUN(I,1) AND ICNTYP(I).
  200   CALL FNSET(NPARM,NUMGR,PTTBL,IPTB,INDM,PARAM,IPT,0,
     *  ICNTYP,CONFUN,IZ)
        GO TO 1100
C
C HERE ICNUSE=1 AND THE ICNTYP CARRIED INTO ERCMP1 WILL OVERRIDE THAT
C COMPUTED BY FNSET.  THIS WILL ALSO BE TRUE IN ALL SUBROUTINES OTHER
C THAN CONMAX.  IF ICNTYP(I)=0 WE WILL SET ERROR(I)=0.0 AND WILL NOT
C NEED TO CALL FNSET.
  600   IF(ICNTYP(I))700,1200,700
C
C CALL FNSET WITH INDFN=0 TO COMPUTE CONFUN(I,1).  THE COMPUTED KCNTYP
C WILL NOT BE USED.
  700   CALL FNSET(NPARM,NUMGR,PTTBL,IPTB,INDM,PARAM,IPT,0,
     *  IWORK(ILC22),CONFUN,IZ)
C
C SET ERROR(I)=0.0, OR CONFUN(I,1), OR FUN(I) - CONFUN(I,1) ACCORDING AS
C ICNTYP(I) IS 0, OR -2, -1, 1, OR 2.
 1100   IF(ICNTYP(I))1400,1200,1300
C
 1200   ERROR(I)=ZERO
        GO TO 1600
C
 1300   IF(ICNTYP(I)-1)1400,1400,1500
C
 1400   ERROR(I)=CONFUN(I,1)
        GO TO 1600
C
 1500   ERROR(I)=FUN(I)-CONFUN(I,1)
 1600 CONTINUE
      GO TO 2600
C
C HERE IOPTTH=1 AND A SINGLE CALL TO FNSET WITH INDFN=0 WILL COMPUTE
C CONFUN(.,1) AND (IF ICNUSE=0) ICNTYP(.).
 1700 IF(ICNUSE)1800,1800,1900
C
C HERE IOPTTH=1 AND ICNUSE=0, AND WE SET IPT=0 TO TELL FNSET TO COMPUTE
C ALL CONSTRAINTS (SINCE WE WANT TO BE SURE THAT ALL OF ICNTYP IS
C COMPUTED).  NOTE THAT IF INSTEAD WE HAD IOPTTH=0, THEN IPT WOULD
C BE POSITIVE AT EACH FNSET CALL, TELLING FNSET TO COMPUTE CONSTRAINT
C IPT ONLY.
 1800 IPT=0
      CALL FNSET(NPARM,NUMGR,PTTBL,IPTB,INDM,PARAM,IPT,0,
     *ICNTYP,CONFUN,IZ)
      GO TO 2000
C
C HERE IOPTTH=1 AND ICNUSE=1, AND IF IPHSE IS NEGATIVE WE SET IPT=-1
C TO TELL FNSET THAT ONLY STANDARD CONSTRAINTS NEED TO BE COMPUTED.
C IF IPHSE=0 HERE WE CHECK TO SEE IF ANY ICNTYP(L) IS POSITIVE FOR
C L=1,...,NUMGR, AND IF SO WE SET IPT=0 TO TELL FNSET TO COMPUTE ALL
C CONSTRAINTS, WHILE OTHERWISE WE SET IPT=-1.
 1900 IF(IPHSE)1940,1920,1920
 1920 DO 1930 L=1,NUMGR
        IF(ICNTYP(L))1930,1930,1960
 1930 CONTINUE
 1940 IPT=-1
      GO TO 1980
 1960 IPT=0
 1980 CALL FNSET(NPARM,NUMGR,PTTBL,IPTB,INDM,PARAM,IPT,0,
     *IWORK(ILC22),CONFUN,IZ)
C
C COMPUTE ERROR AS ABOVE.
 2000 DO 2500 I=1,NUMGR
        IF(ICNTYP(I))2300,2100,2200
C
 2100   ERROR(I)=ZERO
        GO TO 2500
C
 2200   IF(ICNTYP(I)-1)2300,2300,2400
C
 2300   ERROR(I)=CONFUN(I,1)
        GO TO 2500
C
 2400   ERROR(I)=FUN(I)-CONFUN(I,1)
 2500 CONTINUE
C
C HAVING FINISHED COMPUTING ERROR(I) AND (IF ICNUSE=0) ICNTYP(I) FOR
C I=1,...,NUMGR WE NOW COMPUTE THE ERROR NORMS.
C WE ALSO COMPUTE THE INDEX IPMAX OF THE CONSTRAINT WHERE THE PRIMARY
C (I.E. TYPE 1 OR TYPE 2) ERROR NORM OCCURS AND THE INDEX ISMAX OF THE
C CONSTRAINT WHERE THE STANDARD (I.E. TYPE -1 OR TYPE -2) ERROR NORM
C OCCURS.
C FIRST INITIALIZE THE INDICATORS AND ERROR NORMS.
 2600 IM1=0
      IM2=0
      IPMAX=0
      ISMAX=0
      ENORM=ZERO
      ENOR2=ZERO
      ENOR3=ZERO
C
      DO 4400 I=1,NUMGR
        EI=ERROR(I)
        IF(ICNTYP(I))3100,4400,2700
C
C HERE ICNTYP(I) .GT. 0.  IF ICNTYP(I)=2 REPLACE EI BY ABS(EI).  IF THIS
C IS THE FIRST I FOUND WITH ICNTYP(I) .GT. 0 WE RESET IPMAX TO I AND PUT
C EI IN ENORM, AND OTHERWISE RESET IPMAX AND PUT EI IN ENORM IF AND ONLY
C IF EI IS BIGGER THAN THE VALUES FOUND SO FAR.
 2700   IF(ICNTYP(I)-1)2770,2770,2730
 2730   EI=ABS(EI)
 2770   IF(IPMAX)2800,2800,2790
 2790   IF(EI-ENORM)4400,4400,2800
 2800   IPMAX=I
        ENORM=EI
        GO TO 4400
 3100   IF(ICNTYP(I)+1)3600,3200,3200
C
C HERE ICNTYP(I)=-1 AND WE DO AS ABOVE EXCEPT WITH IM1 AND ENOR2.
 3200   IF(IM1)3300,3300,3250
 3250   IF(EI-ENOR2)4400,4400,3300
 3300   IM1=I
        ENOR2=EI
        GO TO 4400
C
C HERE ICNTYP(I)=-2 AND WE DO AS ABOVE EXCEPT WITH IM2 AND ENOR3.
 3600   IF(IM2)3700,3700,3650
 3650   IF(EI-ENOR3)4400,4400,3700
 3700   IM2=I
        ENOR3=EI
 4400 CONTINUE
C
C NOW RESET ISMAX IF THERE ARE ANY STANDARD CONSTRAINTS.
      IF(IM1)4500,4500,4700
 4500 IF(IM2)5000,5000,4600
C HERE THERE ARE STANDARD NONLINEAR CONSTRAINTS BUT NO STANDARD LINEAR
C CONSTRAINTS.
 4600 ISMAX=IM2
      GO TO 5000
 4700 IF(IM2)4800,4800,4900
C HERE THERE ARE STANDARD LINEAR CONSTRAINTS BUT NO STANDARD NONLINEAR
C CONSTRAINTS.
 4800 ISMAX=IM1
      GO TO 5000
C HERE THERE ARE BOTH STANDARD LINEAR CONSTRAINTS AND STANDARD NONLINEAR
C CONSTRAINTS.
 4900 IF(ENOR3-ENOR2)4800,4600,4600
C
C SET ERROR(NUMGR+1) THROUGH ERROR(NUMGR+3).
 5000 ERROR(NUMGR+1)=ENORM
      ERROR(NUMGR+2)=ENOR2
      ERROR(NUMGR+3)=ENOR3
      RETURN
      END
C
C
      SUBROUTINE RMRPP(NCASES,ID,V,SUP,CFORM,NGRPS,ISEED,MS,U,ITHGRP,
     +                DATA)
      IMPLICIT REAL*8(A-H,O-Z)
C
C         THE TEST STATISTIC ASSOCIATED WITH MULTI-RESPONSE PERMUTATION
C         PROCEDURES (MRPP) IS CALCULATED IN THIS FORTRAN-77 PROGRAM.
C         THIS TEST IS DESIGNED TO ANALYZE MULTI-RESPONSE DATA AT
C         THE ORDINAL (OR HIGHER) LEVELS AND IS BASED ON THE AVERAGE
C         EUCLIDEAN DISTANCE BETWEEN OBJECT POSITIONS WITHIN A PRIORI
C         DISJOINT GROUPS OF OBJECTS IN A FINITE POPULATION WHERE
C         EACH POSITION IS A POINT IN AN R-DIMENSIONAL SPACE (THUS
C         THE ARGUMENTS OF EACH R-DIMENSIONAL POINT CORRESPOND TO
C         THE R MEASURED RESPONSES OF EACH OBJECT IN THE FINITE POPULATION
C         OF OBJECTS).  THIS PROGRAM ALSO CONTAINS THE TRUNCATED DISTANCE
C         OPTION (THE UPPER TRUNCATION CONSTANT IS TERMED SUP).  THE
C         PRESENT MAXIMUM VALUES OF G, N AND R IN THIS PROGRAM ARE
C         RESPECTIVELY 25, 50 AND 7.
C
C         PROGRAM MODIFIED 1/22/2002
C
C       EITHER OF THE FOUR FOLLOWING WEIGHTING FORMS MAY BE CHOSEN.
C            CFORM = 1:  C(I) = n(I)/sum(n(I))
C            CFORM = 2:  C(I) = (n(I)-1)/sum(n(I)-1)
C            CFORM = 3:  C(I) = 1/sum(1)
C            CFORM = 4:  C(I) = n(I)*(n(I)-1)/sum(n(I)*(n(I)-1))
C       CFORM IS PASSED AS THE FOURTH PARAMETER ON THE SECOND RECORD
C       IN THE DATA FILE.  WEIGHTS FOR EACH GROUP ARE CALCULATED IN
C       SUBROUTINE DIST, AND STORED IN ARRAY C(I).
C
      DIMENSION  U(17),ITHGRP(20),XI(20),DATA(250,16)
      INTEGER  CFORM
C
      ONE = 1.0D0
  100 FORMAT(A)
      L = 1
      M = ITHGRP(L)
      DO 160 I = 1,NCASES
  140    IF(I.LE.M) GO TO 150
         L = L+1
         IF(L.LE.NGRPS) THEN
            M = M+ITHGRP(L)
         ELSE
            M = NCASES
         END IF
         GO TO 140
  150    DATA(I,ID+1) = ONE*L
  160 CONTINUE
      CALL DIST(NCASES,ID,V,SUP,CFORM,NGRPS,MS,U,ITHGRP,DATA,XI,
     +          DBAR,PL,PU)
      WRITE(2,1100) 'RMRPP ANALYSES FOR REGRESSION RESIDUAL DATA'
 1100 FORMAT(/,T16,A,/)
      WRITE(2,1200) 'INPUT HAS ', NCASES,' OBSERVATIONS'
 1200 FORMAT(T10,A,I5,A)
      WRITE(2,1200) 'THERE WERE', ID, ' DIMENSION(S)'
      WRITE(2,1300) 'IN: ', NGRPS, ' GROUPS OF SIZES ',
     +              (ITHGRP(I),I = 1,NGRPS)
 1300 FORMAT(T10,A,I5,A,10I5)
      GO TO (1410,1420,1430,1440) CFORM
 1410 WRITE(2,1450) 'C(I) = n(I)/sum(n(I))'
      GO TO 1500
 1420 WRITE(2,1450) 'C(I) = (n(I)-1)/sum(n(I)-1)'
      GO TO 1500
 1430 WRITE(2,1450) 'C(I) = 1/sum(1)'
      GO TO 1500
 1440 WRITE(2,1450) 'C(I) = n(I)*(n(I)-1)/sum(n(I)*(n(I)-1))'
 1450 FORMAT(T10,A)
 1500 WRITE(2,100) ' '
      DO 1700 I = 1,NGRPS
         WRITE(2,1600) 'GROUP NUMBER ', I, ' OF SIZE ', ITHGRP(I),
     +                 ' HAS AN AVERAGE DISTANCE = ',XI(I)
 1600    FORMAT(T10,A,I2,A,I5,A,G12.6)
 1700 CONTINUE
      WRITE(2,100) ' '
 1750 FORMAT(T10,A,I9)
      WRITE(2,1750) 'RANDOM NUMBER GENERATOR SEED =',ISEED
      WRITE(2,1750) 'NUMBER OF SIMULATIONS =',MS
 1800 FORMAT(T10,A,G16.8)
      WRITE(2,1800) 'THE DISTANCE EXPONENT =', V
      WRITE(2,1800) 'THE UPPER BOUND VALUE =', SUP
      WRITE(2,1800) 'THE OBSERVED DELTA IS =', DBAR
      WRITE(2,1800) 'LOWER TAIL P-VALUE OF OBSERVED DELTA =', PL
      WRITE(2,1800) 'UPPER TAIL P-VALUE OF OBSERVED DELTA =', PU
      RETURN
      END
C
C
      SUBROUTINE DIST(NCASES,ID,V,SUP,CFORM,NGRPS,MS,U,ITHGRP,DATA,XI1,
     +   DBAR,PL,PU)
      IMPLICIT REAL*8(A-H,O-Z)
C
C         SUBROUTINE DIST CALCULATES THE DISTANCES BETWEEN THE DATA
C         POINTS, PLUS THE PARAMETERS WHICH ARE DIRECTLY DEPENDENT
C         ON THE DISTANCES.
C
      DIMENSION  U(17),C(20),DATA(250,16),DEL(250,250),ITHGRP(20),
     +           XI1(20),XI(20)
      INTEGER  CFORM
C
      ZERO = 0.0D0
      ONE = 1.0D0
      DBAR = ZERO
      DO 10 I = 1,NGRPS
         XI1(I) = ZERO
   10 CONTINUE
      DO 40 I = 1,NCASES
         DO 30 J = 1,NCASES
            DEL(I,J) = ZERO
            DO 20 K = 1,ID
               DEL(I,J) = DEL(I,J)+(DATA(I,K)-DATA(J,K))**2
   20       CONTINUE
            DEL(I,J) = DEL(I,J)**(V/2)
            IF(DEL(I,J).GT.SUP) DEL(I,J) = SUP
            IS = IDNINT(DATA(I,ID+1))
            JS = IDNINT(DATA(J,ID+1))
            IF(IS.LE.NGRPS.AND.IS.EQ.JS) XI1(IS) = XI1(IS)+DEL(I,J)
   30    CONTINUE
   40 CONTINUE
      GO TO (1410,1430,1450,1470) CFORM
 1410 FK = ZERO
      DO 1415 I = 1,NGRPS
         FK = FK+ITHGRP(I)
 1415 CONTINUE
      DO 1420 I = 1,NGRPS
         C(I) = ONE*ITHGRP(I)/FK
 1420 CONTINUE
      GO TO 1490
 1430 FK = ZERO
      DO 1435 I = 1,NGRPS
         FK = FK+ITHGRP(I)
 1435 CONTINUE
      DO 1440 I = 1,NGRPS
         C(I) = ONE*(ITHGRP(I)-1)/(FK-NGRPS)
 1440 CONTINUE
      GO TO 1490
 1450 DO 1460 I = 1,NGRPS
         C(I) = ONE/NGRPS
 1460 CONTINUE
      GO TO 1490
 1470 W = ZERO
      DO 1475 I = 1,NGRPS
         W = W+ONE*ITHGRP(I)*(ITHGRP(I)-1)
 1475 CONTINUE
      DO 1480 I = 1,NGRPS
         C(I) = ONE*ITHGRP(I)*(ITHGRP(I)-1)/W
 1480 CONTINUE
 1490 DO 1500 I = 1,NGRPS
         XI1(I) = XI1(I)/(ITHGRP(I)*(ITHGRP(I)-1))
         DBAR = DBAR+C(I)*XI1(I)
         DL = DBAR*(ONE+1.0D-12)
         DU = DBAR*(ONE-1.0D-12)
 1500 CONTINUE
      ML = 0
      MU = 0
      DO 3600 IW = 1,MS
         CALL SAMPWOR(NCASES,NCASES,ID,U,DATA)
         L = 1
         MA = ITHGRP(L)
         DO 2006 I = 1,NCASES
 2004    IF(I.LE.MA) GO TO 2005
            L = L+1
            IF(L.LE.NGRPS) THEN
               MA = MA+ITHGRP(L)
            ELSE
               MA = NCASES
            END IF
            GO TO 2004
 2005       DATA(I,ID+1) = ONE*L
 2006    CONTINUE
         DZ = ZERO
         DO 2010 I = 1,NGRPS
            XI(I) = ZERO
 2010    CONTINUE
         DO 2040 I = 1,NCASES
            DO 2030 J = 1,NCASES
               DEL(I,J) = ZERO
               DO 2020 K = 1,ID
                  DEL(I,J) = DEL(I,J)+(DATA(I,K)-DATA(J,K))**2
 2020          CONTINUE
               DEL(I,J) = DEL(I,J)**(V/2)
               IF(DEL(I,J).GT.SUP) DEL(I,J) = SUP
               IS = IDNINT(DATA(I,ID+1))
               JS = IDNINT(DATA(J,ID+1))
               IF(IS.LE.NGRPS.AND.IS.EQ.JS) XI(IS) = XI(IS)+DEL(I,J)
 2030       CONTINUE
 2040    CONTINUE
         DO 3500 I = 1,NGRPS
            XI(I) = XI(I)/(ITHGRP(I)*(ITHGRP(I)-1))
            DZ = DZ+C(I)*XI(I)
 3500    CONTINUE
         IF(DZ.LT.DL) ML = ML+1
         IF(DZ.GT.DU) MU = MU+1
 3600 CONTINUE
      PL = ONE*ML/MS
      PU = ONE*MU/MS
      RETURN
      END
C
C
      SUBROUTINE SAMPWOR(M,N,ID,U,DATA)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  U(17),BIN(16),DATA(250,16)
C
C     M: SIZE OF POPULATION
C     N: SIZE OF SAMPLE DRAWN WITHOUT REPLACEMENT (1 </= N </= M)
C     DATA: REAL INPUT WHICH CONTAINS DATA(1,*),...,DATA(M,*) POPULATION VALUES
C     WITHOUT REPLACEMENT SAMPLE CONTAINED IN DATA(1,*),...,DATA(N,*)
C
C     UNI(U) IS UNIFORM RANDOM NUMBER GENERATOR ON (0,1)
C
      DO 20 I = 1,N
         J = INT(I+(M-I+1)*UNI(U))
         DO 10 K = 1,ID
            BIN(K) = DATA(J,K)
            DATA(J,K) = DATA(I,K)
            DATA(I,K) = BIN(K)
   10    CONTINUE
   20 CONTINUE
      DO 30 I = 1,N
         DATA(I,ID+1) = 0.0D0
   30 CONTINUE
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION UNI(U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION U(17)
      PARAMETER(CSAVE = 2.1602869033813D-2, CD = 0.45623308420181D0,
     +    CM = 0.99999982118607D0)
      SAVE I,J,C
      DATA I,J,C/17,5,CSAVE/
C
      UNI = U(I)-U(J)
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      U(I) = UNI
      I = I-1
      IF(I.EQ.0) I = 17
      J = J-1
      IF(J.EQ.0) J = 17
      C = C-CD
      IF(C.LT.0.0D0) C = C+CM
      UNI = UNI-C
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      RETURN
      END
