      PROGRAM RKAP2
      IMPLICIT REAL*8(A-H,O-Z)
C
C        PROGRAM MODIFIED 3/25/2008
C
      CHARACTER  FOUT*40
      DIMENSION  U(17),MM1(20),MM2(20),L(20,20),W(20,20)
C
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS:'
      READ(*,1) FOUT
    1 FORMAT(A)
      WRITE(*,*) 'ENTER RANDOM # SEED & # OF SIMULATIONS:'
      READ(*,*) ISEED,MS
      WRITE(*,*) 'ENTER COMMON SIZE OF THE TWO DIMENSIONS:'
      READ(*,*) N1
      N2 = N1
      DO 2 I = 1,N1
         WRITE(*,4) 'ENTER FREQUENCIES OF ROW ',I
         READ(*,*) (L(I,J),J = 1,N2)
         WRITE(*,4) 'ENTER WEIGHTS OF ROW ',I
         READ(*,*) (W(I,J),J = 1,N2)
    2 CONTINUE
    4 FORMAT(T2,A,I2)
C
      K = 24
      I1 = MOD(IABS(ISEED),177)+1
      J1 = MOD(IABS(ISEED),167)+1
      K1 = MOD(IABS(ISEED),157)+1
      L1 = MOD(IABS(ISEED),147)+1
      DO 8 II = 1,17
         S = 0.0D0
         T = 0.5D0
         DO 7 JJ = 1,K
            M1 = MOD(MOD(I1*J1,179)*K1,179)
            I1 = J1
            J1 = K1
            K1 = M1
            L1 = MOD(53*L1+1,169)
            IF(MOD(L1*M1,64).GE.32) S = S+T
            T = T/2
    7    CONTINUE
         U(II) = S
    8 CONTINUE
C
      IT = 0
      PSTART = 0.0D0
      DO 12 I = 1,N1
         MM1(I) = 0
         DO 11 J = 1,N2
            MM1(I) = MM1(I)+L(I,J)
   11    CONTINUE
         IT = IT+MM1(I)
         PSTART = PSTART+FAC(MM1(I))
   12 CONTINUE
      DO 15 J = 1,N2
         MM2(J) = 0
         DO 14 I = 1,N1
            MM2(J) = MM2(J)+L(I,J)
   14    CONTINUE
         PSTART = PSTART+FAC(MM2(J))
   15 CONTINUE
      PSTART = PSTART-FAC(IT)
C
      CELLFAC = 0.0D0
      ZO = 0.0D0
      ZE = 0.0D0
      DO 27 I = 1,N1
         DO 26 J = 1,N2
            CELLFAC = CELLFAC+FAC(L(I,J))
            ZO = ZO+W(I,J)*L(I,J)
            ZE = ZE+W(I,J)*MM1(I)*MM2(J)
   26    CONTINUE
   27 CONTINUE
      FEP = DEXP(PSTART-CELLFAC)
      ZOT = 1.0D0-ZO*IT/ZE
      IF(ZOT.GT.0.0D0) THEN
         ZOL = ZOT*(1.0D0+1.0D-10)
         ZOU = ZOT*(1.0D0-1.0D-10)
         GO TO 30
      END IF
      IF(ZOT.LT.0.0D0) THEN
         ZOL = ZOT*(1.0D0-1.0D-10)
         ZOU = ZOT*(1.0D0+1.0D-10)
         GO TO 30
      END IF
      IF(ZOT.EQ.0.0D0) THEN
         ZOL = 1.0D-11
         ZOU = -1.0D-11
         GO TO 30
      END IF
C
   30 ZO2 = DABS(ZOT)-1.0D-11
      IZL = 0
      IZU = 0
      IZ2 = 0
      W2 = 0.0D0
      W3 = 0.0D0
C
      DO 45 IS = 1,MS
         CALL XCONT2(IT,N1,N2,X,ZE,U,MM1,MM2,W)
         IF(X.LT.ZOL) IZL = IZL+1
         IF(X.GT.ZOU) IZU = IZU+1
         IF(DABS(X).GT.ZO2) IZ2 = IZ2+1
         W2 = W2+X**2
         W3 = W3+X**3
   45 CONTINUE
C
      PZL = 1.0D0*IZL/MS
      PZU = 1.0D0*IZU/MS
      PZ2 = 1.0D0*IZ2/MS
      EW = 0.0D0
      W2 = W2/MS
      W3 = (W3/MS)/(DSQRT(W2))**3
C
      OPEN(6,FILE=FOUT,STATUS='NEW')
      WRITE(6,48) 'TWO-WAY CONTINGENCY TABLE ANALYSES OF SIZE ',
     +          N1,',',N2,' FOR ARRAYS 1, & 2'
      WRITE(6,49) ISEED, ' = RANDOM NUMBER GENERATOR SEED'
      WRITE(6,49) MS, ' = NUMBER OF RANDOM TABLES GENERATED'
      WRITE(6,50) FEP, ' = PROBABILITY OF OBSERVED 2-WAY TABLE'
      WRITE(6,50) ZOT, ' = OBSERVED 2-WAY KAPPA TEST STATISTIC'
      WRITE(6,50) EW, ' = EXPECTED 2-WAY KAPPA TEST STATISTIC'
      WRITE(6,50) W2, ' = SAMPLE 2-WAY KAPPA TEST STATISTIC VARIANCE'
      WRITE(6,50) W3, ' = SAMPLE 2-WAY KAPPA TEST STATISTIC SKEWNESS'
      WRITE(6,50) PZL, ' = SIMULATED 2-WAY KAPPA LOWER TAIL P-VALUE'
      WRITE(6,50) PZU, ' = SIMULATED 2-WAY KAPPA UPPER TAIL P-VALUE'
      WRITE(6,50) PZ2, ' = SIMULATED 2-WAY KAPPA TWO-SIDED P-VALUE'
   48 FORMAT(T2,A,I2,A,I2,A,/)
   49 FORMAT(T5,I10,A)
   50 FORMAT(T5,G15.8,A)
      CLOSE(6)
      END
C
C
      SUBROUTINE XCONT2(NT,N1,N2,X,ZE,U,MM1,MM2,W)
      IMPLICIT REAL*8(A-H,O-Z)
C
C    GENERATES RANDOM TWO-WAY TABLE WITH FIXED MARGINAL TOTALS
C
      DIMENSION  U(17),L1(20),L2(20),MM1(20),MM2(20),P1(20),P2(20),
     +           W1(20),W2(20),MC(20,20),W(20,20)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      LT = NT
      DO 1 I = 1,N1
         L1(I) = MM1(I)
    1 CONTINUE
      DO 2 I = 1,N2
         L2(I) = MM2(I)
    2 CONTINUE
      DO 9 I = 1,N1
         DO 8 J = 1,N2
            MC(I,J) = 0
    8    CONTINUE
    9 CONTINUE
C
      DO 100 K = 1,NT
C
         DO 20 I = 1,N1
            P1(I) = ONE*L1(I)/LT
   20    CONTINUE
         W1(1) = P1(1)
         DO 25 I = 2,N1-1
            W1(I) = W1(I-1)+P1(I)
   25    CONTINUE
         W1(N1) = ONE
C
         DO 30 I = 1,N2
            P2(I) = ONE*L2(I)/LT
   30    CONTINUE
         W2(1) = P2(1)
         DO 35 I = 2,N2-1
            W2(I) = W2(I-1)+P2(I)
   35    CONTINUE
         W2(N2) = ONE
C
         Z = UNI(U)
         DO 50 I = 1,N1
            IF(Z.LE.W1(I)) THEN
               L1(I) = L1(I)-1
               I1 = I
               GO TO 55
            END IF
   50    CONTINUE
C
   55    Z = UNI(U)
         DO 60 I = 1,N2
            IF(Z.LE.W2(I)) THEN
               L2(I) = L2(I)-1
               I2 = I
               GO TO 75
            END IF
   60    CONTINUE
C
   75    LT = LT-1
         MC(I1,I2) = MC(I1,I2)+1
  100 CONTINUE
C
      X = ZERO
      DO 220 I = 1,N1
        DO 219 J = 1,N2
          X = X+W(I,J)*MC(I,J)
  219   CONTINUE
  220 CONTINUE
      X = ONE-X*NT/ZE
      RETURN
      END
C  ...........................................................................
      DOUBLE PRECISION FUNCTION UNI(U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION U(17)
      PARAMETER(CSAVE = 2.1602869033813D-2, CD = 0.45623308420181D0,
     +    CM = 0.99999982118607D0)
      SAVE I,J,C
      DATA I,J,C/17,5,CSAVE/
C
      UNI = U(I)-U(J)
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      U(I) = UNI
      I = I-1
      IF(I.EQ.0) I = 17
      J = J-1
      IF(J.EQ.0) J = 17
      C = C-CD
      IF(C.LT.0.0D0) C = C+CM
      UNI = UNI-C
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      RETURN
      END
C  ...........................................................................
      DOUBLE PRECISION FUNCTION FAC(I)
C  FIND LOG(I!)
      DOUBLE PRECISION  W,PREV(5000)
      INTEGER  I,J,MAX
      DATA  MAX/1/
C  INITIALIZE LOG(0!) = LOG(1) = 0
      FAC = 0.0D0
      PREV(1) = 0.0D0
      IF(I.LE.1) RETURN
C  CHECK TO SEE IF CALCULATION HAS ALREADY BEEN DONE.
      IF(I.LE.MAX) THEN
         FAC = PREV(I)
         RETURN
      ENDIF
      FAC = PREV(MAX)
      DO 10 J = MAX+1,I
         W = 1.0D0*J
         FAC = FAC+DLOG(W)
         PREV(J) = FAC
   10 CONTINUE
      MAX = I
      RETURN
      END
