      PROGRAM RPTMP
      IMPLICIT REAL*8(A-H,O-Z)
C
C         PERMUTATION TEST FOR MATCHED PAIRS (RPTMP) YIELDS AN APPROXIMATE
C         P-VALUE (POWER OF RANKS TEST IS INCLUDED AS A SPECIAL CASE).
C         AN OPTION OF THIS PROGRAM IS THE ONE-SAMPLE TEST.
C         THIS PROGRAM IS CAPABLE OF MULTIPLE RUNS.
C         NOTE: LC IS IN INPUT DATA SO THAT THE PTMP AND RPTMP INPUT DATA
C               SETS ARE IDENTICAL (LC IS NOT USED IN THE RPTMP PROGRAM).
C         PROGRAM MODIFIED 11/19/99
C
      DIMENSION  U(17),D(300,2),X(100),Y(100),R(100)
      CHARACTER  FIN*40,FOUT*40,HEAD*80
      INTEGER  OLDN
C
      ZERO = 0.0D0
      HALF = 0.5D0
      ONE = 1.0D0
      PREC = 1.0D-12
      WRITE(*,*) 'ENTER: FILE NAME OF INPUT DATA'
      READ(*,1) FIN
    1 FORMAT(A)
      WRITE(*,*) 'ENTER: FILE NAME FOR OUTPUT RESULTS'
      READ(*,1) FOUT
      WRITE(*,*) 'ENTER RANDOM # SEED & # OF SIMULATIONS:'
      READ(*,*) ISEED,MS
      K = 24
      I1 = MOD(IABS(ISEED),177)+1
      J1 = MOD(IABS(ISEED),167)+1
      K1 = MOD(IABS(ISEED),157)+1
      L1 = MOD(IABS(ISEED),147)+1
      DO 4 II = 1,17
         S = ZERO
         T = HALF
         DO 3 JJ = 1,K
            M1 = MOD(MOD(I1*J1,179)*K1,179)
            I1 = J1
            J1 = K1
            K1 = M1
            L1 = MOD(53*L1+1,169)
            IF(MOD(L1*M1,64).GE.32) S = S+T
            T = T/2
    3    CONTINUE
         U(II) = S
    4 CONTINUE
      OPEN(1,FILE=FIN)
      OPEN(2,FILE=FOUT,STATUS='NEW')
    5 READ(1,1,END=7) HEAD
      GO TO 10
    7 GO TO 200
   10 READ(1,*) V,OLDN,LC,KM,ZM,LR,H
      IF(KM.EQ.2) GO TO 13
      READ(1,*) (D(I,1),I=1,OLDN)
      DO 12 I = 1,OLDN
         D(I,1) = D(I,1)-ZM
         D(I,2) = ZERO-D(I,1)
   12 CONTINUE
      GO TO 14
   13 READ(1,*) ((D(I,J),J = 1,2),I = 1,OLDN)
   14 N = 0
      DO 15 I = 1,OLDN
         DIFF = D(I,1)-D(I,2)
         IF(DIFF.NE.ZERO) THEN
            N = N+1
            X(N) = DIFF
         END IF
   15 CONTINUE
      IF(N.LT.3) THEN
         WRITE(*,*) 'N LESS THAN THREE'
         GO TO 300
      END IF
      IF(LR.NE.1) GO TO 25
      DO 17 I = 1,N
         Y(I) = DABS(X(I))
   17 CONTINUE
      A1 = ZERO
      A2 = ZERO
      A3 = ONE*N-0.1D0
      B1 = ZERO
      B2 = 1.0D30
   18 IF(A2.GT.A3) GO TO 22
      DO 19 I = 1,N
         IF(Y(I).GT.B1.AND.Y(I).LT.B2) B2 = Y(I)*(ONE+PREC)
   19 CONTINUE
      DO 20 I = 1,N
         W = DABS(ONE-Y(I)/B2)
         IF(W.LT.1.0D-11) A1 = A1+1
   20 CONTINUE
      A4 = A2+(A1+1)/2
      DO 21 I = 1,N
         W = DABS(ONE-Y(I)/B2)
         IF(W.LT.1.0D-11) R(I) = A4
   21 CONTINUE
      A2 = A2+A1
      A1 = ZERO
      B1 = B2
      B2 = 1.0D30
      GO TO 18
   22 DO 23 I = 1,N
         X(I) = (X(I)/Y(I))*R(I)**H
   23 CONTINUE
   25 SUM = ZERO
      DO 35 I = 1,N-1
         DO 30 J = I+1,N
            SUM = SUM+(DABS(X(I)-X(J)))**V
   30    CONTINUE
   35 CONTINUE
      MP = 0
      SUM = SUM*(ONE+PREC)
      DO 60 IS = 1,MS
         DO 40 I = 1,N
            IF(UNI(U).LT.HALF) X(I) = ZERO-X(I)
   40    CONTINUE
         SX = ZERO
         DO 50 I = 1,N-1
            DO 45 J = I+1,N
               SX = SX+(DABS(X(I)-X(J)))**V
   45       CONTINUE
   50    CONTINUE
         IF(SX.LT.SUM) MP = MP+1
   60 CONTINUE
      PROB = ONE*MP/MS
      FN = ONE*N
      DELTA1 = SUM*2/(FN*(FN-1))
   93 WRITE(2,1) HEAD
      WRITE(2,95) 'RESULTS OF RPTMP ANALYSIS'
   95 FORMAT(T24,A,/)
      IF(KM.EQ.1) THEN
         WRITE(2,97) 'RPTMP IS A ONE-SAMPLE TEST'
         WRITE(2,110) 'THE HYPOTHESIZED CENTER VALUE =', ZM
      ELSE
         WRITE(2,97) 'RPTMP IS A MATCHED-PAIRS TEST'
      END IF
   97 FORMAT(T15,A)
      WRITE(2,1) ' '
      WRITE(2,100) 'RANDOM NUMBER GENERATOR SEED =',ISEED
      WRITE(2,100) 'NUMBER OF SIMULATIONS =',MS
  100 FORMAT(T10,A,I9)
      WRITE(2,110) 'OBSERVED DELTA =', DELTA1
      WRITE(2,110) 'DISTANCE EXPONENT =', V
      IF(LR.NE.1) GO TO 105
      WRITE(2,110) 'EXPONENT FOR POWER OF RANKS TEST =', H
  105 WRITE(2,97) 'THE FOLLOWING SIMULATED P-VALUE IS APPROXIMATE:'
      WRITE(2,110) 'P-VALUE OF A SMALLER OR EQUAL DELTA =', PROB
  110 FORMAT(T10,A,G20.8)
      WRITE(2,1) ' '
      WRITE(2,120) 'NUMBER OF VALUES OR PAIRS =', OLDN
      WRITE(2,120) 'NUMBER OF NON-ZERO VALUES OR DIFFERENCES =', N
  120 FORMAT(T10,A,I4)
      WRITE(2,130)
  130 FORMAT('********************************************************')
      GO TO 5
  200 CLOSE(1)
      CLOSE(2)
  300 END
C
C
      DOUBLE PRECISION FUNCTION UNI(U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  U(17)
      PARAMETER(CSAVE = 2.1602869033813D-2, CD = 0.45623308420181D0,
     +    CM = 0.99999982118607D0)
      SAVE I,J,C
      DATA I,J,C/17,5,CSAVE/
C
      UNI = U(I)-U(J)
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      U(I) = UNI
      I = I-1
      IF(I.EQ.0) I = 17
      J = J-1
      IF(J.EQ.0) J = 17
      C = C-CD
      IF(C.LT.0.0D0) C = C+CM
      UNI = UNI-C
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      RETURN
      END
