      PROGRAM HOT2
      IMPLICIT REAL*8(A-H,O-Z)
C
C         THIS PROGRAM CALCULATES HOTELLINGS TWO-SAMPLE T-SQUARED
C         STATISTICS P-VALUE.  THE PRESENT MAXIMUM VALUES OF N
C         AND R ARE RESPECTIVELY 300 AND 20.
C
C         PROGRAM MODIFIED 9/3/97
C
      CHARACTER  HEAD*70,FIN*40,FOUT*40
      DIMENSION  DATA(300,21),ITHGRP(10)
C
      ONE = 1.0D0
      ZERO = 0.0D0
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA'
      READ(*,100) FIN
  100 FORMAT(A)
      OPEN(3,FILE=FIN)
      NGRPS = 2
      READ(3,100) HEAD
      READ(3,*) NCASES,ID,(ITHGRP(I),I = 1,NGRPS)
      L = 1
      M = ITHGRP(L)
      DO 160 I = 1,NCASES
         READ(3,*,END=170) (DATA(I,J),J = 1,ID)
  140    IF(I.LE.M) GO TO 150
         L = L+1
         IF(L.LE.NGRPS) THEN
            M = M+ITHGRP(L)
         ELSE
            M = NCASES
         END IF
         GO TO 140
  150    DATA(I,ID+1) = ONE*L
  160 CONTINUE
      CLOSE(3)
      GO TO 1000
  170 WRITE(*,175) 'ERROR:  END-OF FILE ENCOUNTERED'
  175 FORMAT(/,T3,A)
      STOP
 1000 WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS'
      READ(*,100) FOUT
      CALL DIST(NCASES,ID,NGRPS,ITHGRP,DATA,PROB,TSQUARE,ADJTSQ,DN,DD)
      OPEN(6,FILE=FOUT,STATUS='NEW')
      WRITE(6,100) HEAD
      HEAD = 'TWO-SAMPLE HOTELLING T-SQUARED TEST'
      WRITE(6,1100) HEAD
 1100 FORMAT(/,T23,A,/)
      WRITE(6,1200) 'INPUT HAS ', NCASES,' OBSERVATIONS'
 1200 FORMAT(T10,A,I3,A)
      WRITE(6,1200) 'THERE WERE', ID, ' DIMENSION(S)'
      WRITE(6,1300) 'IN: ', NGRPS, ' GROUPS OF SIZES ',
     +              (ITHGRP(I),I = 1,NGRPS)
 1300 FORMAT(T10,A,I5,A,10I5)
      WRITE(6,1800) 'OBSERVED TSQUARE VALUE IS = ',TSQUARE
 1800 FORMAT(T10,A,G16.8)
      WRITE(6,1800) 'ADJUSTED TSQUARE VALUE IS = ', ADJTSQ
      WRITE(6,1800) 'NUMERATOR DEGREES OF FREEDOM = ',DN
      WRITE(6,1800) 'DENOMINATOR DEGREES OF FREEDOM = ',DD
      WRITE(6,1850) 'P-VALUE OF A LARGER OR EQUAL STATISTIC = ', PROB
 1850 FORMAT(/,T10,A,G16.8)
      END
C
C
      SUBROUTINE DIST(NCASES,ID,NGRPS,ITHGRP,DATA,PROB,TSQ,ADJT,DN,DD)
      IMPLICIT REAL*8(A-H,O-Z)
C
C         SUBROUTINE DIST CALCULATES THE DISTANCES BETWEEN THE DATA
C         POINTS, PLUS THE PARAMETERS WHICH ARE DIRECTLY DEPENDENT
C         ON THE DISTANCES.
C
      DIMENSION  DATA(300,21),ITHGRP(10),KP(20),KR(20),KC(20),
     +   X(20,2),Z(2),Y1(20,20),Y2(20,20),YC(20,20)
C
      ND = 20
      ZERO = 0.0D0
      ONE = 1.0D0
      IF(NGRPS.EQ.2) THEN
      DO 260 I = 1,ID
         X(I,1) = ZERO
         X(I,2) = ZERO
         DO 240 J = 1,ITHGRP(1)
            X(I,1) = X(I,1)+DATA(J,I)
  240    CONTINUE
         DO 250 J = ITHGRP(1)+1,NCASES
            X(I,2) = X(I,2)+DATA(J,I)
  250    CONTINUE
         X(I,1) = X(I,1)/ITHGRP(1)
         X(I,2) = X(I,2)/ITHGRP(2)
         Z(I) = X(I,1)-X(I,2)
  260 CONTINUE
      END IF
      DO 580 I = 1,ID
         DO 570 J = 1,ID
            Y1(I,J) = ZERO
            Y2(I,J) = ZERO
            DO 550 K = 1,ITHGRP(1)
               Y1(I,J) = Y1(I,J)+(DATA(K,I)-X(I,1))*(DATA(K,J)-X(J,1))
  550       CONTINUE
            DO 560 K = ITHGRP(1)+1,NCASES
               Y2(I,J) = Y2(I,J)+(DATA(K,I)-X(I,2))*(DATA(K,J)-X(J,2))
  560       CONTINUE
            YC(I,J) = Y1(I,J)+Y2(I,J)
            YC(J,I) = YC(I,J)
  570    CONTINUE
  580 CONTINUE
      CALL INVERT(ID,YC,KP,KR,KC,ND)
      TSQ = ZERO
      DO 600 I = 1,ID
         DO 590 J = 1,ID
            TSQ = TSQ+Z(I)*YC(I,J)*Z(J)
  590    CONTINUE
  600 CONTINUE
      ADJT = TSQ*(NCASES-ID-1)*ITHGRP(1)*ITHGRP(2)/NCASES/ID
      DN = ONE*ID
      DD = ONE*(NCASES-ID-1)
      CALL FVALUE(ADJT,DN,DD,PROB)
      RETURN
      END
C
C
      SUBROUTINE INVERT(N,W,KP,KR,KC,ND)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  KP(N),KR(N),KC(N),W(ND,N)
C
      ZERO = 0.0D0
      DO 5 I = 1,N
         KP(I) = 0
    5 CONTINUE
      DO 45 I = 1,N
         T = ZERO
         DO 20 J = 1,N
            IF(KP(J).NE.1) THEN
               DO 15 K = 1,N
                  IF(KP(K)-1) 10,15,60
   10             IF(T.LT.DABS(W(J,K))) THEN
                     IR = J
                     IC = K
                     T = DABS(W(J,K))
                  END IF
   15          CONTINUE
            END IF
   20    CONTINUE
         KP(IC) = KP(IC)+1
         IF(IR.NE.IC) THEN
            DO 25 L = 1,N
               T = W(IR,L)
               W(IR,L) = W(IC,L)
               W(IC,L) = T
   25       CONTINUE
         END IF
         KR(I) = IR
         KC(I) = IC
         T = W(IC,IC)
         W(IC,IC) = 1.0D0
         DO 30 L = 1,N
            W(IC,L) = W(IC,L)/T
   30    CONTINUE
         DO 40 M = 1,N
            IF(M.NE.IC) THEN
               T = W(M,IC)
               W(M,IC) = ZERO
               DO 35 L = 1,N
                  W(M,L) = W(M,L)-W(IC,L)*T
   35          CONTINUE
            END IF
   40    CONTINUE
   45 CONTINUE
      DO 55 I = 1,N
         J = N-I+1
         IF(KR(J).NE.KC(J)) THEN
            K = KR(J)
            L = KC(J)
            DO 50 M = 1,N
               T = W(M,K)
               W(M,K) = W(M,L)
               W(M,L) = T
   50       CONTINUE
         END IF
   55 CONTINUE
   60 RETURN
      END
C
C
      SUBROUTINE FVALUE(ADJTSQ,DN,DD,PTSQ)
      IMPLICIT REAL*8(A-H,O-Z)
C
      A = DN/2
      B = DD/2
      Y = A*ADJTSQ/(A*ADJTSQ+B)
      PTSQ = 1.0D0-BETAIN(Y,A,B)
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION BETAIN(X,A,B)
C
      DOUBLE PRECISION  X,A,B,ONE,TOL,AB,CX,XX,AA,BB,TERM,AI,RX,TEMP,
     +       DLNBTA
      LOGICAL  INDEX
C
      ONE = 1.0D0
      TOL = 0.1D-7
      BETAIN = X
      AB = A+B
      CX = ONE-X
      IF (A.GE.AB*X) GO TO 10
      XX = CX
      CX = X
      AA = B
      BB = A
      INDEX = .TRUE.
      GO TO 20
   10 XX = X
      AA = A
      BB = B
      INDEX = .FALSE.
   20 TERM = ONE
      AI = ONE
      BETAIN = ONE
      NS = IDINT(BB+CX*AB)
      RX = XX/CX
   30 TEMP = BB-AI
      IF(NS.EQ.0) RX = XX
   40 TERM = TERM*TEMP*RX/(AA+AI)
      BETAIN = BETAIN+TERM
      TEMP = DABS(TERM)
      IF(TEMP.LE.TOL.AND.TEMP.LE.TOL*BETAIN) GO TO 50
      AI = AI+1
      NS = NS-1
      IF(NS.GE.0) GO TO 30
      TEMP = AB
      AB = AB+1
      GO TO 40
   50 BETAIN = BETAIN*DEXP(AA*DLOG(XX)+(BB-1)*DLOG(CX)-
     +         DLNBTA(AA,BB))/AA
      IF(INDEX) BETAIN = ONE-BETAIN
      END
C
C
      DOUBLE PRECISION FUNCTION DLNBTA(A,B)
C
      DOUBLE PRECISION  A,B,DLNGAM
C
      DLNBTA = DLNGAM(A)+DLNGAM(B)-DLNGAM(A+B)
      END
C
C
      DOUBLE PRECISION FUNCTION DLNGAM(X)
C
      DOUBLE PRECISION  X,ONE,Z,D,PI,F
C
      ONE  = 1.0D0
      Z  = X-1
      D  = ONE
      PI = DATAN(ONE)*4
      F  = Z+10
      DO 10 J = 1,9
         D = D*(Z+J)
   10 CONTINUE
      DLNGAM = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2
     +         -DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +         +ONE/(F**5*1260)-ONE/(F**7*1680)
     +         +ONE/(F**9*1188)
      END
