      PROGRAM KSIM
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  U(17)
      CHARACTER  FOUT*40
C
C   SAMPLE SIZE N MUST BE LESS THAN 9001.
C
      ZERO = 0.0D0
      ONE = 1.0D0
      WRITE(*,*) 'ENTER FILE NAME OF OUTPUT RESULTS:'
      READ(*,1000) FOUT
 1000 FORMAT(A)
      WRITE(*,*) 'ENTER (1) OBSERVED KOLMOGOROV STATISTIC, (2) SAMPLE'
      WRITE(*,*) 'SIZE, (3) NUMBER OF SIMULATIONS, AND (4) RANDOM'
      WRITE(*,*) 'NUMBER GENERATOR SEED (A POSITIVE INTEGER):'
      READ(*,*) DA,N,LS,ISEED
      FN = ONE*N
      H = FN+ONE
      K = 24
      I1 = MOD(IABS(ISEED),177)+1
      J1 = MOD(IABS(ISEED),167)+1
      K1 = MOD(IABS(ISEED),157)+1
      L1 = MOD(IABS(ISEED),147)+1
      DO 1230 II = 1,17
        S = ZERO
        T = 0.5D0
        DO 1220 JJ = 1,K
          M1 = MOD(MOD(I1*J1,179)*K1,179)
          I1 = J1
          J1 = K1
          K1 = M1
          L1 = MOD(53*L1+1,169)
          IF(MOD(L1*M1,64).GE.32) S = S+T
          T = T/2
 1220   CONTINUE
        U(II) = S
 1230 CONTINUE
      COUNT = ZERO
      DO 1500 I = 1,LS
         CALL KOLM(N,DN,U)
         IF(DN.GE.DA) COUNT = COUNT+ONE
 1500 CONTINUE
      PVAL = COUNT/LS
      OPEN(7,FILE=FOUT,STATUS='NEW')
      WRITE(7,1900) '*** KOLMOGOROV TEST ***'
 1900 FORMAT(T15,A)
      WRITE(7,2000) 'OBSERVED VALUE OF KOLMOGOROV TEST = ',DA
 2000 FORMAT(T5,A,G15.8)
      WRITE(7,2000) 'ESTIMATED KOLMOGOROV TEST P-VALUE = ',PVAL
      WRITE(7,2100) 'NUMBER OF INDEPENDENT VARIABLES = ',N
 2100 FORMAT(T5,A,I9)
      WRITE(7,2100) 'NUMBER OF BOOTSTRAP REPLICATIONS = ',LS
      WRITE(7,2100) 'RANDOM NUMBER GENERATOR SEED = ',ISEED
      CLOSE(7)
      END
C
C
      SUBROUTINE KOLM(N,DN,U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  P(9000),X1(9000),X2(9000),Y(9000),U(17)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      FN = ONE*N
      DO 10 I = 1,N
         P(I) = UNI(U)
   10 CONTINUE
      CALL ORDER(N,P)
C   CREATE SPECIFIC TYPE OF ALTERNATIVE UNDER NULL OR ALTERNATIVE HYPOTHESIS
      DO 20 I = 1,N
         Y(I) = P(I)
   20 CONTINUE
C   CALCULATE KOLMOGOROV STATISTIC: DN
      DO 30 I = 1,N
         X1(I) = DABS(Y(I)-ONE*I/FN)
         X2(I) = DABS(Y(I)-ONE*(I-1)/FN)
   30 CONTINUE
      H1 = -ONE
      H2 = -ONE
      DO 40 I = 1,N
         H1 = DMAX1(H1,X1(I))
         H2 = DMAX1(H2,X2(I))
   40 CONTINUE
      DN  = DMAX1(H1,H2)
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION UNI(U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION U(17)
      PARAMETER(CSAVE = 2.1602869033813D-2, CD = 0.45623308420181D0,
     +    CM = 0.99999982118607D0)
      SAVE I,J,C
      DATA I,J,C/17,5,CSAVE/
C
      UNI = U(I)-U(J)
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      U(I) = UNI
      I = I-1
      IF(I.EQ.0) I = 17
      J = J-1
      IF(J.EQ.0) J = 17
C
      C = C-CD
      IF(C.LT.0.0D0) C = C+CM
C
      UNI = UNI-C
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      RETURN
      END
C
C
      SUBROUTINE ORDER(N,P)
      IMPLICIT REAL*8(A-H,O-Z)
C
C  N UNIVARIATE VALUES ARE ORDERED FROM SMALLEST TO LARGEST
C
      DIMENSION  P(9000)
C
      J = N
      K = J/2+1
   10 K = K-1
      W = P(K)
      GO TO 30
   20 W = P(J)
      P(J) = P(1)
      J = J-1
   30 II = K
   40 L = 2*II
      IF(L-J) 50,60,70
   50 IF(P(L+1).GE.P(L)) L = L+1
   60 IF(W.GE.P(L)) GO TO 70
      P(II) = P(L)
      II = L
      GO TO 40
   70 P(II) = W
      IF(K.GT.1) GO TO 10
      IF(J.GE.2) GO TO 20
      RETURN
      END

