      PROGRAM PT3
C
      DOUBLE PRECISION  GAM,PROB,PRT,PLT,Z
C
      WRITE(*,*) 'ENTER OBSERVED Z AND SKEWNESS VALUE (GAM):'
      READ(*,*) Z,GAM
      CALL PVALUE(Z,GAM,PROB)
      PRT = PROB
      WRITE(*,10) 'UPPER ONE-SIDED P-VALUE OF Z = ',PRT
   10 FORMAT(T5,A,G16.8E3)
      PLT = 1.0D0-PROB
      WRITE(*,10) 'LOWER ONE-SIDED P-VALUE OF Z = ',PLT
      END
C
C
      SUBROUTINE PVALUE(Z,GAM,PROB)
C
C        SUBROUTINE PVALUE CALCULATES THE PROBABILITY OF A VALUE OF
C        Z BEING GREATER THAN OR EQUAL TO THE OBSERVED VALUE OF Z.
C
      DOUBLE PRECISION  GAM,PROB,ZERO,ONE,PI,A,B,C,D,E,F,G,H,R,
     +   U,V,W,X,Y,Z,E1,E2,E3,E4,E5,G1,G2,G3,H0,H1,H2,H3,H4
      INTEGER  I
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      IF(DABS(GAM).LT.0.01D0) GO TO 50
      R = ONE*2/DABS(GAM)
      D = R*R
      DO 10 I = 1,9
         D = D*(R*R+I)
   10 CONTINUE
      F = R*R+10
      U = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)-
     +    ONE/(F*F*F*360)
      G1 = 0.0375D0
      G2 = 0.075D0
      G3 = 0.0125D0
      H1 = ZERO
      H2 = ZERO
      A  = R*R-1
      B  = R*R*(DLOG(R)-1)-U
      W  = -1.99D0/GAM
      IF(GAM.LT.ZERO) GO TO 30
      IF(Z.LT.W) THEN
         PROB = ONE
         RETURN
      END IF
      X = Z
      Y = Z+15
      DO 20 I = 1,199
         G = A*DLOG(R+X+G1*(I*2-1))-R*(X+G1*(I*2-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R+X+G2*I)-R*(X+G2*I)+B
         H2 = H2+E(G)
   20 CONTINUE
      G = A*DLOG(R+X)-R*X+B
      H0 = E(G)
      G = A*DLOG(R+Y)-R*Y+B
      H3 = E(G)
      G = A*DLOG(R+X+G1*399)-R*(X+G1*399)+B
      H4 = E(G)
      PROB = G3*(H0+(H1+H4)*4+H2*2+H3)
      RETURN
   30 IF(Z.GT.W) THEN
         PROB = ZERO
         RETURN
      END IF
      X = Z-15
      Y = Z
      DO 40 I = 1,199
         G = A*DLOG(R-X-G1*(I*2-1))+R*(X+G1*(I*2-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R-X-G2*I)+R*(X+G2*I)+B
         H2 = H2+E(G)
   40 CONTINUE
      G = A*DLOG(R-X)+R*X+B
      H0 = E(G)
      G = A*DLOG(R-Y)+R*Y+B
      H3 = E(G)
      G = A*DLOG(R-X-G1*399)+R*(X+G1*399)+B
      H4 = E(G)
      PROB = ONE-G3*(H0+(H1+H4)*4+H2*2+H3)
      RETURN
   50 PROB = ZERO
      G = -Z*Z/2
      IF(G.LT.-709.1D0) GO TO 70
      A = 4.2D0
      V = DABS(Z)
      IF(V.GT.A) GO TO 60
      E1 =  0.31938153D0
      E2 = -0.356563782D0
      E3 =  1.781477937D0
      E4 = -1.821255978D0
      E5 =  1.330274429D0
      H  =  0.2316419D0
      W  =  ONE/(H*V+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*E(G)/DSQRT(PI*2)
      GO TO 70
   60 B = 2.2D0
      C = 4.9D0
      PROB = E(G)*(ONE/V-ONE/V**3+B/V**C)/DSQRT(PI*2)
   70 IF(Z.LT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION E(G)
C
      DOUBLE PRECISION G
C
      E = 0.0D0
      IF(G.GE.-709.1D0) E = DEXP(G)
      RETURN
      END
