      PROGRAM SRGT
      IMPLICIT REAL*8(A-H,O-Z)
C
C  THIS IS A RESAMPLING G-TREATMENT RIDIT ANALYSES PROGRAM (1 < G < 11)
C  YIELDING UPPER TAIL P VALUES.  FREQUENCIES FOR THE K DISCRETE CELLS
C  OF EACH SAMPLE (K < 51) MUST BE ENTERED AS INPUT DATA IN ADDITION
C  TO THE VALUES G AND K.  ALSO A POSITIVE INTEGER SEED AND THE NUMBER
C  OF SIMULATIONS ARE ALSO BE ENTERED.
C
C         PROGRAM MODIFIED 9/10/2007
C
      CHARACTER  FIN*40,FOUT*40
      DIMENSION  U(17),LT(50),N(10),RT(50),V(50),X2(10),
     +           L(50,10),R(50,10),X1(10,10)
C
C  IF G > 10 AND/OR K > 50, REPLACE 10 AND 50 ABOVE WITH G AND/OR K.
C
      WRITE(*,*) ' *** RESAMPLING G-TREATMENT RIDIT ANALYSES *** '
      ZERO = 0.0D0
      ONE = 1.0D0
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA:'
      READ(*,1) FIN
    1 FORMAT(A)
      WRITE(*,*) 'ENTER FILE NAME OF OUTPUT DATA:'
      READ(*,1) FOUT
      OPEN(3,FILE=FIN)
      OPEN(5,FILE=FOUT,STATUS='NEW')
      READ(3,*) IK,IG
      DO 2 I = 1,IK
        READ(3,*) (L(I,J),J=1,IG)
    2 CONTINUE
      V(1) = 1.0D0/DBLE(IK)
      DO 3 I = 2,IK-1
        V(I) = V(I-1)+V(1)
    3 CONTINUE
      V(IK) = ONE
      WRITE(*,*) 'ENTER RANDOM # SEED & # OF SIMULATIONS:'
      READ(*,*) ISEED,MS
      NT = 0
      DO 5 J = 1,IG
        N(J) = ZERO
        DO 4 I = 1,IK
          N(J) = N(J)+L(I,J)
          R(I,J) = ZERO
    4   CONTINUE
        NT = NT+N(J)
    5 CONTINUE
      DO 7 I = 1,IK
        LT(I) = ZERO
        DO 6 J = 1,IG
          LT(I) = LT(I)+L(I,J)
    6   CONTINUE
    7 CONTINUE
C
      DO 19 J = 1,IG
        R(1,J) = ONE*L(1,J)/(2*N(J))
        DO 18 I = 2,IK
          R(I,J) = ONE*L(I,J)/(2*N(J))
          DO 17 II = 1,I-1
            R(I,J) = R(I,J)+ONE*L(II,J)/N(J)
   17     CONTINUE
   18   CONTINUE
   19 CONTINUE
C
      RT(1) = ONE*LT(1)/(2*NT)
      DO 29 I = 2,IK
        RT(I) = ONE*LT(I)/(2*NT)
        DO 28 II = 1,I-1
          RT(I) = RT(I)+ONE*LT(II)/NT
   28   CONTINUE
   29 CONTINUE
C
      DO 37 J1 = 1,IG
        DO 36 J2 = 1,IG
          X1(J1,J2) = ZERO
          DO 35 I = 1,IK
            X1(J1,J2) = X1(J1,J2)+R(I,J1)*L(I,J2)
   35     CONTINUE
          X1(J1,J2) = X1(J1,J2)/N(J2)
   36   CONTINUE
   37 CONTINUE
C
      DO 39 J = 1,IG
        X2(J) = ZERO
        DO 38 I = 1,IK
          X2(J) = X2(J)+RT(I)*L(I,J)/N(J)
   38   CONTINUE
   39 CONTINUE
C
      T1O = ZERO
      T2O = ZERO
      DO 42 J1 = 1,IG-1
        DO 41 J2 = J1+1,IG
          T1O = T1O+DABS(X1(J1,J2)-X1(J2,J1))
          T2O = T2O+DABS(X2(J1)-X2(J2))
   41   CONTINUE
   42 CONTINUE
      T1OU = T1O*(ONE-1.0D-12)
      T2OU = T2O*(ONE-1.0D-12)
C
      KK = 24
      I1 = MOD(IABS(ISEED),177)+1
      J1 = MOD(IABS(ISEED),167)+1
      K1 = MOD(IABS(ISEED),157)+1
      L1 = MOD(IABS(ISEED),147)+1
      DO 104 II = 1,17
         S = 0.0D0
         T = 0.5D0
         DO 102 JJ = 1,KK
            M1 = MOD(MOD(I1*J1,179)*K1,179)
            I1 = J1
            J1 = K1
            K1 = M1
            L1 = MOD(53*L1+1,169)
            IF(MOD(L1*M1,64).GE.32) S = S+T
            T = T/2
  102    CONTINUE
         U(II) = S
  104 CONTINUE
C
      L1 = 0
      L2 = 0
      DO 250 IW = 1,MS
         DO 200 J = 1,IG
            DO 190 I = 1,IK
               L(I,J) = 0
  190       CONTINUE
  200    CONTINUE
         DO 215 J = 1,IG
            DO 210 I = 1,N(J)
               W = UNI(U)
               DO 205 II= 1,IK
                  IF(W.LE.V(II)) THEN
                     L(II,J) = L(II,J)+1
                     GO TO 210
                  END IF
  205          CONTINUE
  210       CONTINUE
  215    CONTINUE
C
         DO 237 J1 = 1,IG
           DO 236 J2 = 1,IG
             X1(J1,J2) = ZERO
             DO 235 I = 1,IK
               X1(J1,J2) = X1(J1,J2)+R(I,J1)*L(I,J2)
  235        CONTINUE
             X1(J1,J2) = X1(J1,J2)/N(J2)
  236      CONTINUE
  237    CONTINUE
C
         DO 239 J = 1,IG
           X2(J) = ZERO
           DO 238 I = 1,IK
             X2(J) = X2(J)+RT(I)*L(I,J)/N(J)
  238      CONTINUE
  239    CONTINUE
C
         T1 = ZERO
         T2 = ZERO
         DO 242 J1 = 1,IG-1
           DO 241 J2 = J1+1,IG
             T1 = T1+DABS(X1(J1,J2)-X1(J2,J1))
             T2 = T2+DABS(X2(J1)-X2(J2))
  241      CONTINUE
  242    CONTINUE
         IF(T1.GT.T1OU) L1 = L1+1
         IF(T2.GT.T2OU) L2 = L2+1
  250 CONTINUE
      P1 = ONE*L1/MS
      P2 = ONE*L2/MS
C
      WRITE(5,310) 'RESAMPLING G-TREATMENT RIDIT ANALYSES ',
     +             'WITH',IK,' CELLS AND',IG,' TREATMENTS '
      WRITE(5,330) 'RANDOM NUMBER GENERATOR SEED = ',ISEED
      WRITE(5,330) 'TOTAL NUMBER OF SIMULATIONS = ',MS
      WRITE(5,320) T1O, ' = OBSERVED VALUE OF STATISTIC 1'
      WRITE(5,320) T2O, ' = OBSERVED VALUE OF STATISTIC 2'
      WRITE(5,330) 'NUMBER OF UPPER TAIL VALUES FOR STATISTIC 1 = ',L1
      WRITE(5,330) 'NUMBER OF UPPER TAIL VALUES FOR STATISTIC 2 = ',L2
      WRITE(5,320) P1, ' = RESAMPLING P-VALUE FOR STATISTIC 1'
      WRITE(5,320) P2, ' = RESAMPLING P-VALUE FOR STATISTIC 2'
  310 FORMAT(/,T2,A,A,I3,A,I3,A)
  320 FORMAT(T5,D16.9,A)
  330 FORMAT(T5,A,I9)
      END
C.......................................................................
      DOUBLE PRECISION FUNCTION UNI(U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION U(17)
      PARAMETER(CSAVE = 2.1602869033813D-2, CD = 0.45623308420181D0,
     +    CM = 0.99999982118607D0)
      SAVE I,J,C
      DATA I,J,C/17,5,CSAVE/
C
      UNI = U(I)-U(J)
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      U(I) = UNI
      I = I-1
      IF(I.EQ.0) I = 17
      J = J-1
      IF(J.EQ.0) J = 17
      C = C-CD
      IF(C.LT.0.0D0) C = C+CM
      UNI = UNI-C
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      RETURN
      END
