      PROGRAM F6X7
      IMPLICIT REAL*8(A-H,O-Z)
C
C     PROGRAM F6X7 IS A DRIVER PROGRAM, CALLING A SPECIFIC SUBROUTINE
C     TO COMPUTE FISHER'S EXACT, EXACT CHI-SQUARE, EXACT ZELTERMAN,
C     AND EXACT LOG-LIKELIHOOD RATIO TEST P-VALUES FOR 6 X 7
C     CROSS-CLASSIFICATION TABLES.
C
      CHARACTER  FOUT*40
      DIMENSION  N(6,7)
C
C     COMPUTE FISHER'S EXACT TEST FOR 6 X 7 TABLES
C
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS'
      READ(*,1) FOUT
    1 FORMAT(A)
      WRITE(*,2) 'FISHER''S EXACT TEST FOR SPARSE 6 X 7 TABLES'
    2 FORMAT(/,T2,A,/)
      WRITE(*,3) 'ENTER N11, N12, N13, N14, N15, N16 & N17'
    3 FORMAT(T2,A)
      READ(*,*)  N(1,1),N(1,2),N(1,3),N(1,4),N(1,5),N(1,6),N(1,7)
      WRITE(*,3) 'ENTER N21, N22, N23, N24, N25, N26 & N27'
      READ(*,*)  N(2,1),N(2,2),N(2,3),N(2,4),N(2,5),N(2,6),N(2,7)
      WRITE(*,3) 'ENTER N31, N32, N33, N34, N35, N36 & N37'
      READ(*,*)  N(3,1),N(3,2),N(3,3),N(3,4),N(3,5),N(3,6),N(3,7)
      WRITE(*,3) 'ENTER N41, N42, N43, N44, N45, N46 & N47'
      READ(*,*)  N(4,1),N(4,2),N(4,3),N(4,4),N(4,5),N(4,6),N(4,7)
      WRITE(*,3) 'ENTER N51, N52, N53, N54, N55, N56 & N57'
      READ(*,*)  N(5,1),N(5,2),N(5,3),N(5,4),N(5,5),N(5,6),N(5,7)
      WRITE(*,3) 'ENTER N61, N62, N63, N64, N65, N66 & N67'
      READ(*,*)  N(6,1),N(6,2),N(6,3),N(6,4),N(6,5),N(6,6),N(6,7)
      CALL FE6X7(N,PT,CST,CZT,ZLT,PFE,PCS,PZS,PLS,CTAB,
     +  CFE,CCS,CZS,CLS,CHECK)
      OPEN(6,FILE=FOUT,STATUS='NEW')
      WRITE(6,5)
    5 FORMAT(T15,'FISHER''S EXACT TEST FOR 6 X 7 TABLES',/)
      WRITE(6,6) '1ST ROW OF 6 X 7 TABLE: ',N(1,1),N(1,2),N(1,3),
     +  N(1,4),N(1,5),N(1,6),N(1,7)
    6 FORMAT(T5,A,7I4)
      WRITE(6,6) '2ND ROW OF 6 X 7 TABLE: ',N(2,1),N(2,2),N(2,3),
     +  N(2,4),N(2,5),N(2,6),N(2,7)
      WRITE(6,6) '3RD ROW OF 6 X 7 TABLE: ',N(3,1),N(3,2),N(3,3),
     +  N(3,4),N(3,5),N(3,6),N(3,7)
      WRITE(6,6) '4TH ROW OF 6 X 7 TABLE: ',N(4,1),N(4,2),N(4,3),
     +  N(4,4),N(4,5),N(4,6),N(4,7)
      WRITE(6,6) '5TH ROW OF 6 X 7 TABLE: ',N(5,1),N(5,2),N(5,3),
     +  N(5,4),N(5,5),N(5,6),N(5,7)
      WRITE(6,6) '6TH ROW OF 6 X 7 TABLE: ',N(6,1),N(6,2),N(6,3),
     +  N(6,4),N(6,5),N(6,6),N(6,7)
      WRITE(6,7) '# OF TABLES CONSISTENT WITH MARGINAL TOTALS = ',CTAB
    7 FORMAT(T5,A,D20.13)
      WRITE(6,7) '# OF TABLES YIELDING FISHER''S EXACT P-VALUE = ',CFE
      WRITE(6,7) 'P(OBSERVED TABLE) = ',PT
      WRITE(6,7) 'FISHER''S EXACT 6 X 7 TABLE P-VALUE = ',PFE
      WRITE(6,7) '# OF TABLES YIELDING EXACT CHI-SQUARED P-VALUE = ',CCS
      IF(CST.LT.0.0D0) CST = 0.0D0
      WRITE(6,7) 'OBSERVED CHI-SQUARED STATISTIC = ',CST
      WRITE(6,7) 'EXACT CHI-SQUARED 6 X 7 TABLE P-VALUE = ',PCS
      WRITE(6,7) '# OF TABLES YIELDING EXACT ZELTERMAN P-VALUE = ',CZS
      IF(CZT.LT.0.0D0) CZT = 0.0D0
      WRITE(6,7) 'OBSERVED ZELTERMAN STATISTIC = ',CZT
      WRITE(6,7) 'EXACT ZELTERMAN 6 X 7 TABLE P-VALUE = ',PZS
      WRITE(6,7) '# OF TABLES YIELDING EXACT LOG LR P-VALUE = ',CLS
      IF(ZLT.LT.0.0D0) ZLT = 0.0D0
      WRITE(6,7) 'OBSERVED LOG-LR STATISTIC = ',ZLT
      WRITE(6,7) 'EXACT LOG LR 6 X 7 TABLE P-VALUE = ',PLS
      WRITE(6,7) 'SUM OF ALL CONFIGURATION PROBABILITIES  = ',CHECK
      END
C
C
      SUBROUTINE FE6X7(L,PT,CST,CZT,ZLT,PFE,PCS,PZS,PLS,CTAB,
     +   CFE,CCS,CZS,CLS,CHECK)
      IMPLICIT REAL*8(A-H,O-Z)
C
C  A FISHER'S EXACT TEST FOR TESTING THE MUTUAL INDEPENDENCE OF
C  CLASSIFICATIONS IN A 6 X 7 CONTINGENCY TABLE.
C
C     DESCRIPTION OF VARIABLES IN CALL LIST:
C        L     -- INPUT,  ARRAY CONTAINING THE CELL FREQUENCIES
C        PFE   -- OUTPUT, FISHER'S EXACT PROBABILITY VALUE (P-VALUE)
C        PT    -- OUTPUT, POINT PROBABILITY OF OBSERVED TABLE
C        CTAB  -- OUTPUT, # OF TABLES CONSISTENT WITH MARGINAL TOTALS
C        CFE   -- OUTPUT, # OF TABLES COMPRISING FISHER'S EXACT P-VALUE
C     USAGE:
C        SUBROUTINE FE6X7 COMPUTES THE FISHER EXACT PROBABILITY
C        TEST FOR 6 X 7 CROSS-CLASSIFICATION TABLES
C
      DIMENSION K(6,7),L(6,7),IR(6),IC(7)
C
C  OBTAIN THE ROW AND COLUMN MARGINAL TOTALS AND THE GRAND TOTAL.
C  FIND THE COMMON PART OF EACH TABLES EXACT PROBABILITY VALUE.
C
      ZERO = 0.0D0
      ONE = 1.0D0
      IT = 0
      PSTART = ZERO
      DO 2 I = 1,6
         IR(I) = 0
         DO 1 J = 1,7
            IR(I) = IR(I)+L(I,J)
    1    CONTINUE
         IT = IT+IR(I)
         PSTART = PSTART+FAC(IR(I))
    2 CONTINUE
      DO 4 J = 1,7
         IC(J) = 0
         DO 3 I = 1,6
            IC(J) = IC(J)+L(I,J)
    3    CONTINUE
         PSTART = PSTART+FAC(IC(J))
    4 CONTINUE
      PSTART = PSTART-FAC(IT)
      CZ = RZ(IT)
      DO 5 I = 1,6
         CZ = CZ-RZ(IR(I))
    5 CONTINUE
      DO 6 I = 1,7
         CZ = CZ-RZ(IC(I))
    6 CONTINUE
C  DETERMINE THE PROBABILITY OF THE OBSERVED TABLE.
      THISP = (PSTART-CELLFAC(L))*(1.0D0-1.0D-12)
      CST = CS(L,IR,IC,IT)*(1.0D0-1.0D-12)
      IF(CST.LT.1.0D-11) CST = -1.0D-11
      CZT = DS(L,IR,IC)*(1.0D0-1.0D-12)
      IF(CZT.LT.1.0D-11) CZT = -1.0D-11
      ZLT = ZL(L,CZ)*(1.0D0-1.0D-12)
      IF(ZLT.LT.1.0D-11) ZLT = -1.0D-11
C  INITIALIZATION OF VARIOUS VALUES FOR SUBSEQUENT SUMMATIONS.
      CTAB = ZERO
      CFE = ZERO
      CCS = ZERO
      CZS = ZERO
      CLS = ZERO
      PFE = ZERO
      PCS = ZERO
      PZS = ZERO
      PLS = ZERO
      CHECK = ZERO
C  30 MAJOR LOOPS DETERMINE THE VALID TABLES FROM ALL VALUES OF 30 SPECIFIED
C  CELLS (THE 12 REMAINING CELLS ARE OBTAINED FROM THE 30 SPECIFIED CELLS).
      M11 = MIN0(IR(1),IC(1))
      L11 = MAX0(IR(1)+IC(1)-IT,0)
      DO 50 I11 = L11,M11
       K(1,1) = I11
      M21 = MIN0(IR(2),IC(1)-I11)
      L21 = MAX0(IR(2)+IC(1)-I11-IT+IR(1),0)
      DO 49 I21 = L21,M21
       K(2,1) = I21
      M31 = MIN0(IR(3),IC(1)-I11-I21)
      L31 = MAX0(IR(3)+IC(1)-I11-I21-IT+IR(1)+IR(2),0)
      DO 48 I31 = L31,M31
       K(3,1) = I31
      M41 = MIN0(IR(4),IC(1)-I11-I21-I31)
      L41 = MAX0(IR(4)+IC(1)-I11-I21-I31-IT+IR(1)+IR(2)+IR(3),0)
      DO 47 I41 = L41,M41
       K(4,1) = I41
      M51 = MIN0(IR(5),IC(1)-I11-I21-I31-I41)
      L51 = MAX0(IR(5)+IC(1)-I11-I21-I31-I41-IT
     +      +IR(1)+IR(2)+IR(3)+IR(4),0)
      DO 46 I51 = L51,M51
       K(5,1) = I51
       K(6,1) = IC(1)-I11-I21-I31-I41-I51
C
      M12 = MIN0(IR(1)-I11,IC(2))
      L12 = MAX0(IR(1)-I11+IC(2)-IT+IC(1),0)
      DO 45 I12 = L12,M12
       K(1,2) = I12
      M22 = MIN0(IR(2)-I21,IC(2)-I12)
      L22 = MAX0(IR(2)-I21+IC(2)-I12-IT+IR(1)+IC(1)-I11,0)
      DO 44 I22 = L22,M22
       K(2,2) = I22
      M32 = MIN0(IR(3)-I31,IC(2)-I12-I22)
      L32 = MAX0(IR(3)-I31+IC(2)-I12-I22-IT+IR(1)+IR(2)+IC(1)-I11-I21,0)
      DO 43 I32 = L32,M32
       K(3,2) = I32
      M42 = MIN0(IR(4)-I41,IC(2)-I12-I22-I32)
      L42 = MAX0(IR(4)-I41+IC(2)-I12-I22-I32-IT+IR(1)+IR(2)+IR(3)
     +      +IC(1)-I11-I21-I31,0)
      DO 42 I42 = L42,M42
       K(4,2) = I42
      M52 = MIN0(IR(5)-I51,IC(2)-I12-I22-I32-I42)
      L52 = MAX0(IR(5)-I51+IC(2)-I12-I22-I32-I42-IT
     +      +IR(1)+IR(2)+IR(3)+IR(4)+IC(1)-I11-I21-I31-I41,0)
      DO 41 I52 = L52,M52
       K(5,2) = I52
       K(6,2) = IC(2)-I12-I22-I32-I42-I52
C
      M13 = MIN0(IR(1)-I11-I12,IC(3))
      L13 = MAX0(IR(1)-I11-I12+IC(3)-IT+IC(1)+IC(2),0)
      DO 40 I13 = L13,M13
       K(1,3) = I13
      M23 = MIN0(IR(2)-I21-I22,IC(3)-I13)
      L23 = MAX0(IR(2)-I21-I22+IC(3)-I13-IT+IR(1)+IC(1)+IC(2)-I11-I12,0)
      DO 39 I23 = L23,M23
       K(2,3) = I23
      M33 = MIN0(IR(3)-I31-I32,IC(3)-I13-I23)
      L33 = MAX0(IR(3)-I31-I32+IC(3)-I13-I23-IT+IR(1)+IR(2)
     +      +IC(1)+IC(2)-I11-I12-I21-I22,0)
      DO 38 I33 = L33,M33
       K(3,3) = I33
      M43 = MIN0(IR(4)-I41-I42,IC(3)-I13-I23-I33)
      L43 = MAX0(IR(4)-I41-I42+IC(3)-I13-I23-I33-IT+IR(1)+IR(2)+IR(3)
     +      +IC(1)+IC(2)-I11-I12-I21-I22-I31-I32,0)
      DO 37 I43 = L43,M43
       K(4,3) = I43
      M53 = MIN0(IR(5)-I51-I52,IC(3)-I13-I23-I33-I43)
      L53 = MAX0(IR(5)-I51-I52+IC(3)-I13-I23-I33-I43-IT
     +      +IR(1)+IR(2)+IR(3)+IR(4)+IC(1)+IC(2)
     +      -I11-I12-I21-I22-I31-I32-I41-I42,0)
      DO 36 I53 = L53,M53
       K(5,3) = I53
       K(6,3) = IC(3)-I13-I23-I33-I43-I53
C
      M14 = MIN0(IR(1)-I11-I12-I13,IC(4))
      L14 = MAX0(IR(1)-I11-I12-I13+IC(4)-IT+IC(1)+IC(2)+IC(3),0)
      DO 35 I14 = L14,M14
       K(1,4) = I14
      M24 = MIN0(IR(2)-I21-I22-I23,IC(4)-I14)
      L24 = MAX0(IR(2)-I21-I22-I23+IC(4)-I14-IT+IR(1)
     +      +IC(1)+IC(2)+IC(3)-I11-I12-I13,0)
      DO 34 I24 = L24,M24
       K(2,4) = I24
      M34 = MIN0(IR(3)-I31-I32-I33,IC(4)-I14-I24)
      L34 = MAX0(IR(3)-I31-I32-I33+IC(4)-I14-I24-IT+IR(1)+IR(2)
     +      +IC(1)+IC(2)+IC(3)-I11-I12-I13-I21-I22-I23,0)
      DO 33 I34 = L34,M34
       K(3,4) = I34
      M44 = MIN0(IR(4)-I41-I42-I43,IC(4)-I14-I24-I34)
      L44 = MAX0(IR(4)-I41-I42-I43+IC(4)-I14-I24-I34-IT+IR(1)+IR(2)
     +      +IR(3)+IC(1)+IC(2)+IC(3)-I11-I12-I13-I21-I22-I23
     +      -I31-I32-I33,0)
      DO 32 I44 = L44,M44
       K(4,4) = I44
      M54 = MIN0(IR(5)-I51-I52-I53,IC(4)-I14-I24-I34-I44)
      L54 = MAX0(IR(5)-I51-I52-I53+IC(4)-I14-I24-I34-I44-IT
     +      +IR(1)+IR(2)+IR(3)+IR(4)+IC(1)+IC(2)+IC(3)
     +      -I11-I12-I13-I21-I22-I23-I31-I32-I33-I41-I42-I43,0)
      DO 31 I54 = L54,M54
       K(5,4) = I54
       K(6,4) = IC(4)-I14-I24-I34-I44-I54
C
      M15 = MIN0(IR(1)-I11-I12-I13-I14,IC(5))
      L15 = MAX0(IR(1)-I11-I12-I13-I14+IC(5)-IT
     +      +IC(1)+IC(2)+IC(3)+IC(4),0)
      DO 30 I15 = L15,M15
       K(1,5) = I15
      M25 = MIN0(IR(2)-I21-I22-I23-I24,IC(5)-I15)
      L25 = MAX0(IR(2)-I21-I22-I23-I24+IC(5)-I15-IT+IR(1)
     +      +IC(1)+IC(2)+IC(3)+IC(4)-I11-I12-I13-I14,0)
      DO 29 I25 = L25,M25
       K(2,5) = I25
      M35 = MIN0(IR(3)-I31-I32-I33-I34,IC(5)-I15-I25)
      L35 = MAX0(IR(3)-I31-I32-I33-I34+IC(5)-I15-I25-IT+IR(1)+IR(2)
     +      +IC(1)+IC(2)+IC(3)+IC(4)-I11-I12-I13-I14-I21-I22-I23-I24,0)
      DO 28 I35 = L35,M35
       K(3,5) = I35
      M45 = MIN0(IR(4)-I41-I42-I43-I44,IC(5)-I15-I25-I35)
      L45 = MAX0(IR(4)-I41-I42-I43-I44+IC(5)-I15-I25-I35-IT+IR(1)+IR(2)
     +      +IR(3)+IC(1)+IC(2)+IC(3)+IC(4)-I11-I12-I13-I14
     +      -I21-I22-I23-I24-I31-I32-I33-I34,0)
      DO 27 I45 = L45,M45
       K(4,5) = I45
      M55 = MIN0(IR(5)-I51-I52-I53-I54,IC(5)-I15-I25-I35-I45)
      L55 = MAX0(IR(5)-I51-I52-I53-I54+IC(5)-I15-I25-I35-I45-IT
     +      +IR(1)+IR(2)+IR(3)+IR(4)+IC(1)+IC(2)+IC(3)+IC(4)
     +      -I11-I12-I13-I14-I21-I22-I23-I24-I31-I32-I33-I34
     +      -I41-I42-I43-I44,0)
      DO 26 I55 = L55,M55
       K(5,5) = I55
       K(6,5) = IC(5)-I15-I25-I35-I45-I55
C
      M16 = MIN0(IR(1)-I11-I12-I13-I14-I15,IC(6))
      L16 = MAX0(IR(1)-I11-I12-I13-I14-I15+IC(6)-IT
     +      +IC(1)+IC(2)+IC(3)+IC(4)+IC(5),0)
      DO 25 I16 = L16,M16
       K(1,6) = I16
      M26 = MIN0(IR(2)-I21-I22-I23-I24-I25,IC(6)-I16)
      L26 = MAX0(IR(2)-I21-I22-I23-I24-I25+IC(6)-I16-IT+IR(1)
     +      +IC(1)+IC(2)+IC(3)+IC(4)+IC(5)-I11-I12-I13-I14-I15,0)
      DO 24 I26 = L26,M26
       K(2,6) = I26
      M36 = MIN0(IR(3)-I31-I32-I33-I34-I35,IC(6)-I16-I26)
      L36 = MAX0(IR(3)-I31-I32-I33-I34-I35+IC(6)-I16-I26-IT
     +      +IR(1)+IR(2)+IC(1)+IC(2)+IC(3)+IC(4)+IC(5)
     +      -I11-I12-I13-I14-I15-I21-I22-I23-I24-I25,0)
      DO 23 I36 = L36,M36
       K(3,6) = I36
      M46 = MIN0(IR(4)-I41-I42-I43-I44-I45,IC(6)-I16-I26-I36)
      L46 = MAX0(IR(4)-I41-I42-I43-I44-I45+IC(6)-I16-I26-I36-IT
     +      +IR(1)+IR(2)+IR(3)+IC(1)+IC(2)+IC(3)+IC(4)+IC(5)
     +      -I11-I12-I13-I14-I15-I21-I22-I23-I24-I25
     +      -I31-I32-I33-I34-I35,0)
      DO 22 I46 = L46,M46
       K(4,6) = I46
      M56 = MIN0(IR(5)-I51-I52-I53-I54-I55,IC(6)-I16-I26-I36-I46)
      L56 = MAX0(IR(5)-I51-I52-I53-I54-I55+IC(6)-I16-I26-I36-I46-IT
     +      +IR(1)+IR(2)+IR(3)+IR(4)+IC(1)+IC(2)+IC(3)+IC(4)+IC(5)
     +      -I11-I12-I13-I14-I15-I21-I22-I23-I24-I25
     +      -I31-I32-I33-I34-I35-I41-I42-I43-I44-I45,0)
      DO 21 I56 = L56,M56
       K(5,6) = I56
       K(6,6) = IC(6)-I16-I26-I36-I46-I56
C
       K(1,7) = IR(1)-I11-I12-I13-I14-I15-I16
       K(2,7) = IR(2)-I21-I22-I23-I24-I25-I26
       K(3,7) = IR(3)-I31-I32-I33-I34-I35-I36
       K(4,7) = IR(4)-I41-I42-I43-I44-I45-I46
       K(5,7) = IR(5)-I51-I52-I53-I54-I55-I56
       K(6,7) = IR(6)-K(6,1)-K(6,2)-K(6,3)-K(6,4)-K(6,5)-K(6,6)
C
       CTAB = CTAB+ONE
       CP = PSTART-CELLFAC(K)
       EXCP = DEXP(CP)
       CHECK = CHECK+EXCP
       IF(CP.LT.THISP) THEN
        CFE = CFE+ONE
        PFE = PFE+EXCP
       ENDIF
       Z = CS(K,IR,IC,IT)
       IF(Z.GT.CST) THEN
        CCS = CCS+ONE
        PCS = PCS+EXCP
       ENDIF
       Y = DS(K,IR,IC)
       IF(Y.GT.CZT) THEN
        CZS = CZS+ONE
        PZS = PZS+EXCP
       ENDIF
       W = ZL(K,CZ)
       IF(W.GT.ZLT) THEN
        CLS = CLS+ONE
        PLS = PLS+EXCP
       ENDIF
   21 CONTINUE
   22 CONTINUE
   23 CONTINUE
   24 CONTINUE
   25 CONTINUE
   26 CONTINUE
   27 CONTINUE
   28 CONTINUE
   29 CONTINUE
   30 CONTINUE
   31 CONTINUE
   32 CONTINUE
   33 CONTINUE
   34 CONTINUE
   35 CONTINUE
   36 CONTINUE
   37 CONTINUE
   38 CONTINUE
   39 CONTINUE
   40 CONTINUE
   41 CONTINUE
   42 CONTINUE
   43 CONTINUE
   44 CONTINUE
   45 CONTINUE
   46 CONTINUE
   47 CONTINUE
   48 CONTINUE
   49 CONTINUE
   50 CONTINUE
      PT = DEXP(THISP)
      RETURN
      END
C...........................................................................
      DOUBLE PRECISION FUNCTION RZ(I)
C  FIND I(LOG(I))
      DOUBLE PRECISION  X
      X = 1.0D0*I
      IF(X.GT.1.5D0) THEN
         RZ = X*DLOG(X)
      ELSE
         RZ = 0.0D0
      ENDIF
      RETURN
      END
C...........................................................................
      DOUBLE PRECISION FUNCTION FAC(I)
C  FIND LOG(I!)
      DOUBLE PRECISION  W,PREV(2500)
      INTEGER  I,J,MAX
      DATA  MAX/1/
C  INITIALIZE LOG(0!) = LOG(1) = 0
      FAC = 0.0D0
      PREV(1) = 0.0D0
      IF(I.LE.1) RETURN
C  CHECK TO SEE IF CALCULATION HAS ALREADY BEEN DONE.
      IF(I.LE.MAX) THEN
         FAC = PREV(I)
         RETURN
      ENDIF
      FAC = PREV(MAX)
      DO 10 J = MAX+1,I
         W = 1.0D0*J
         FAC = FAC+DLOG(W)
         PREV(J) = FAC
   10 CONTINUE
      MAX = I
      RETURN
      END
C...........................................................................
      DOUBLE PRECISION FUNCTION CELLFAC(N)
C  OBTAIN SUM OF LOG FACTORIALS FOR 42 CELLS.
      DOUBLE PRECISION  FAC
      INTEGER  I,J,N(6,7)
      CELLFAC = 0.0D0
      DO 20 I = 1,6
         DO 10 J = 1,7
               CELLFAC = CELLFAC+FAC(N(I,J))
   10    CONTINUE
   20 CONTINUE
      RETURN
      END
C...........................................................................
      DOUBLE PRECISION FUNCTION CS(N,IR,IC,IT)
C  OBTAIN CHI-SQUARED STATISTIC
      DOUBLE PRECISION  ZERO,ONE
      INTEGER  N(6,7),IR(6),IC(7),IT,I,J
      ZERO = 0.0D0
      ONE = 1.0D0
      CS = ZERO
      DO 20 I = 1,6
         DO 10 J = 1,7
            CS = CS+(ONE*N(I,J))**2/IR(I)/IC(J)
   10    CONTINUE
   20 CONTINUE
      CS = (CS-ONE)*IT
      RETURN
      END
C...........................................................................
      DOUBLE PRECISION FUNCTION DS(N,IR,IC)
C  OBTAIN ZELTERMAN STATISTIC
      DOUBLE PRECISION  ZERO,ONE
      INTEGER  N(6,7),IR(6),IC(7),I,J
      ZERO = 0.0D0
      ONE = 1.0D0
      DS = ZERO
      DO 20 I = 1,6
         DO 10 J = 1,7
            DS = DS+ONE*N(I,J)*(N(I,J)-1)/IR(I)/IC(J)
   10    CONTINUE
   20 CONTINUE
      RETURN
      END
C...........................................................................
      DOUBLE PRECISION FUNCTION ZL(N,CZ)
C  OBTAIN LOG LIKELIHOOD RATIO STATISTIC
      DOUBLE PRECISION  ZERO,CZ,RZ
      INTEGER  N(6,7),I,J
      ZERO = 0.0D0
      ZL = ZERO
      DO 20 I = 1,6
         DO 10 J = 1,7
            ZL = ZL+RZ(N(I,J))
   10    CONTINUE
   20 CONTINUE
      ZL = (ZL+CZ)*2
      RETURN
      END
