      PROGRAM ZRCM
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER  FOUT*40
      DIMENSION  MCELL(10000)
C
      WRITE(*,*) 'ENTER FILE NAME OF OUTPUT RESULTS'
      READ(*,1) FOUT
    1 FORMAT(A)
      WRITE(*,*) 'ENTER (0,1) FOR (MRPPRC,GKTAU) R BY C TABLE ANALYSES'
      READ(*,*) L
      WRITE(*,*) 'ENTER  NROW, NCOL'
      READ(*,*) NROW,NCOL
      DO 5 I = 1,NROW
         WRITE(*,*) 'ENTER ROW',I
         READ(*,*)  (MCELL(NROW*(J-1)+I),J = 1,NCOL)
    5 CONTINUE
      CALL GKAB(NROW,NCOL,TOT,MCELL,DELA,DELB,EDELA,EDELB,VARA,VARB,
     +          ZA,ZB,TA,TB,GAM1A,GAM1B,PROBA,PROBB,L)
      ZERO = 0.0D0
      ONE = 1.0D0
      M = (NROW-1)*(NCOL-1)
      RHOA = ONE-DELA/EDELA
      RHOB = ONE-DELB/EDELB
      OPEN(6,FILE=FOUT,STATUS='NEW')
      IF(L.EQ.1) THEN
         WRITE(6,10) 'GOODMAN-KRUSKAL CONTINGENCY TABLE ANALYSES'
     +               ,' WITH ',NROW,' ROWS AND ',NCOL,' COLUMNS'
      ELSE
         WRITE(6,15) 'MRPP CONTINGENCY TABLE ANALYSES WITH ',
     +                NROW,' ROWS AND ',NCOL,' COLUMNS'
      END IF
      WRITE(6,20) DELA, ' = OBSERVED VALUE OF DELTA-A'
      WRITE(6,20) EDELA, ' = EXPECTED VALUE OF DELTA-A'
      WRITE(6,20) VARA, ' = VARIANCE OF DELTA-A'
      WRITE(6,20) RHOA, ' = GENERALIZED AGREEMENT MEASURE RHO-A'
      IF(L.EQ.1) THEN
         WRITE(6,20) TA, ' = ESTIMATED VALUE OF TAU-A'
         ATA = TA*(TOT-1)*(NROW-1)
         IF(ATA.GT.ZERO) THEN
            CALL CHISQ(ATA,M,PATA)
         ELSE
            PATA = ONE
         END IF
         WRITE(6,20) ATA, ' = ADJUSTED ESTIMATED VALUE OF TAU-A'
         WRITE(6,20) PATA, ' = ASYMPTOTIC P-VALUE OF OBSERVED DELTA-A'
      END IF
      WRITE(6,20) ZA, ' = OBSERVED STANDARDIZED DELTA-A'
      WRITE(6,20) GAM1A, ' = SKEWNESS OF DELTA-A'
      WRITE(6,25) PROBA, ' = P-VALUE OF OBSERVED DELTA-A'
      WRITE(6,20) DELB, ' = OBSERVED VALUE OF DELTA-B'
      WRITE(6,20) EDELB, ' = EXPECTED VALUE OF DELTA-B'
      WRITE(6,20) VARB, ' = VARIANCE OF DELTA-B'
      WRITE(6,20) RHOB, ' = GENERALIZED AGREEMENT MEASURE RHO-B'
      IF(L.EQ.1) THEN
         WRITE(6,20) TB, ' = ESTIMATED VALUE OF TAU-B'
         ATB = TB*(TOT-1)*(NCOL-1)
         IF(ATB.GT.ZERO) THEN
            CALL CHISQ(ATB,M,PATB)
         ELSE
            PATB = ONE
         END IF
         WRITE(6,20) ATB, ' = ADJUSTED ESTIMATED VALUE OF TAU-B'
         WRITE(6,20) PATB, ' = ASYMPTOTIC P-VALUE OF OBSERVED DELTA-B'
      END IF
      WRITE(6,20) ZB, ' = OBSERVED STANDARDIZED DELTA-B'
      WRITE(6,20) GAM1B, ' = SKEWNESS OF DELTA-B'
      WRITE(6,20) PROBB, ' = P-VALUE OF OBSERVED DELTA-B'
   10 FORMAT(7(/),T2,A,A,I3,A,I3,A,/)
   15 FORMAT(7(/),T2,A,I3,A,I3,A,/)
   20 FORMAT(T5,G15.8,A)
   25 FORMAT(T5,G15.8,A,/)
      END
C
C
      SUBROUTINE GKAB(NROW,NCOL,TOT,MCELL,DELB,DELA,EDELB,EDELA,
     +     VARB,VARA,ZB,ZA,TB,TA,GAM1B,GAM1A,PROBB,PROBA,L)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  MCELL(NROW,NCOL),ROW(100),COL(100),CA(100),CB(100)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      DO 10 I = 1,NROW
       ROW(I) = ZERO
   10 CONTINUE
      DO 20 J = 1,NCOL
       COL(J) = ZERO
   20 CONTINUE
      DO 40 I = 1,NROW
       DO 30 J = 1,NCOL
        ROW(I) = ROW(I)+ONE*MCELL(I,J)
        COL(J) = COL(J)+ONE*MCELL(I,J)
   30  CONTINUE
   40 CONTINUE
      TOT = ZERO
      DO 50 I = 1,NROW
       TOT = TOT+ROW(I)
   50 CONTINUE
      IF(TOT.LT.5.5D0) STOP 'TOTAL NUMBER OF CASES < 6'
      DO 60 I = 1,NROW
       IF(L.EQ.1) THEN
        CA(I) = (ROW(I)-1)/(TOT-NROW)
       ELSE
        CA(I) = ROW(I)/TOT
       END IF
   60 CONTINUE
      DO 70 I = 1,NCOL
       IF(L.EQ.1) THEN
        CB(I) = (COL(I)-1)/(TOT-NCOL)
       ELSE
        CB(I) = COL(I)/TOT
       END IF
   70 CONTINUE
      DELA = ZERO
      DELB = ZERO
      DO 90 I = 1,NROW
       DO 80 J = 1,NCOL
        DELA = DELA+((ROW(I)-MCELL(I,J))*MCELL(I,J)/(ROW(I)*(ROW(I)-1)))
     +          *CA(I)
        DELB = DELB+((COL(J)-MCELL(I,J))*MCELL(I,J)/(COL(J)*(COL(J)-1)))
     +          *CB(J)
   80  CONTINUE
   90 CONTINUE
      C1 = ZERO
      C2 = ZERO
      C3 = ZERO
      R1 = ZERO
      R2 = ZERO
      R3 = ZERO
      DO 100 J = 1,NCOL
       C1 = C1+COL(J)*(TOT-COL(J))
       C2 = C2+COL(J)*(TOT-COL(J))**2
       C3 = C3+COL(J)*(TOT-COL(J))**3
  100 CONTINUE
      DO 110 I = 1,NROW
       R1 = R1+ROW(I)*(TOT-ROW(I))
       R2 = R2+ROW(I)*(TOT-ROW(I))**2
       R3 = R3+ROW(I)*(TOT-ROW(I))**3
  110 CONTINUE
      TA = ONE-DELA*TOT*(TOT-NROW)/C1
      TB = ONE-DELB*TOT*(TOT-NCOL)/R1
      CALL MRPP(TOT,NROW,ROW,CA,C1,C2,C3,DELA,EDELA,VARA,ZA,
     +     GAM1A,PROBA)
      CALL MRPP(TOT,NCOL,COL,CB,R1,R2,R3,DELB,EDELB,VARB,ZB,
     +     GAM1B,PROBB)
      RETURN
      END
C
C
      SUBROUTINE MRPP(TOTAL,NGRPS,GRP,C,E1,E2,E3,DBAR,D1,VAR,T,
     +     GAM1,PROB)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  GRP(NGRPS),C(NGRPS),Q(6),R(100,6),S(11)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      Q(1) = TOTAL
      DO 2280 I = 2,6
         Q(I) = Q(I-1)*(TOTAL-I+1)
 2280 CONTINUE
      D1 = E1/Q(2)
      D2 = D1
      D3 = (E2-E1)/Q(3)
      D4 = ((E1+2)*E1-E2*4)/Q(4)
      D5 = D1
      D6 = D3
      D7 = (E2*2-TOTAL*E1)/Q(3)
      D8 = D4
      D9 = (E3-(TOTAL+4)*E2+(E1+TOTAL+1)*E1)/Q(4)
      D10 = (E3-E2*3+E1*2)/Q(4)
      D11 = ((E1+TOTAL*4+14)*E2-E3*6-(E1*5+TOTAL*2+4)*E1)/Q(5)
      D12 = (E3*40+((E1+30)*E1+TOTAL*8+16)*E1
     +      -(E1*12+TOTAL*24+64)*E2)/Q(6)
      DO 2300 I = 1,NGRPS
         R(I,1) = GRP(I)
         DO 2290 J = 2,6
            R(I,J) = R(I,J-1)*(GRP(I)-J+1)
 2290    CONTINUE
 2300 CONTINUE
      DO 2310 I = 1,11
         S(I) = ZERO
 2310 CONTINUE
      DO 2340 I = 1,NGRPS
         S(4) = S(4)+C(I)**2/R(I,2)
         S(5) = S(5)+C(I)**2/R(I,1)
         S(6) = S(6)+C(I)**3/R(I,2)**2
         S(7) = S(7)+C(I)**3*R(I,3)/R(I,2)**3
         S(8) = S(8)+C(I)**2*((ONE-C(I))/R(I,2)+C(I)*R(I,4)/R(I,2)**3)
         S(9) = S(9)+C(I)**3*R(I,4)/R(I,2)**3
         S(10) = S(10)+C(I)**2*((ONE-C(I))*R(I,3)/R(I,2)**2+
     1           C(I)*R(I,5)/R(I,2)**3)
         S(11) = S(11)+C(I)*((ONE-C(I))*(ONE-C(I)*2)+C(I)*(ONE-C(I))*
     1           R(I,4)*3/R(I,2)**2+C(I)**2*R(I,6)/R(I,2)**3)
 2340 CONTINUE
      VAR = (S(4)-ONE/Q(2))*(D2-D3*2+D4)*2+(S(5)-ONE/Q(1))*(D3-D4)*4
      STDEV = DSQRT(VAR)
      T = (DBAR-D1)/STDEV
      EDELT3 = S(6)*D5*4+S(7)*(D6*3+D7)*8+S(8)*D8*6+
     1         S(9)*(D9*3+D10)*8+S(10)*D11*12+S(11)*D12
      CUM3 = EDELT3-D1*VAR*3-D1**3
      GAM1 = CUM3/STDEV**3
      CALL PVALUE(T,GAM1,PROB)
      RETURN
      END
C
C
      SUBROUTINE PVALUE(T,GAM,PROB)
C
C         SUBROUTINE PVALUE CALCULATES THE PROBABILITY THAT A VALUE OF
C         T IS LESS THAN OR EQUAL TO THE OBSERVED VALUE OF T.
C
      DOUBLE PRECISION  T,GAM,PROB,ZERO,ONE,PI,A,B,C,D,E,F,G,H,R,
     +   U,W,X,Y,E1,E2,E3,E4,E5,G1,G2,G3,H0,H1,H1N,H2,H3
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      IF(DABS(GAM).LT.0.01D0) GO TO 50
      R = ONE*2/DABS(GAM)
      D = R*R
      F = R*R+10
      DO 10 I = 1,9
         D = D*(R*R+I)
   10 CONTINUE
      U = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)
     +        -ONE/(F*F*F*360)
      A = R*R-1
      B = R*R*(DLOG(R)-1)-U
      G1 = 0.0375D0
      G2 = 0.075D0
      G3 = 0.0125D0
      H1 = ZERO
      H2 = ZERO
      W = -1.99D0/GAM
      IF(GAM.LT.ZERO) GO TO 30
      IF(T.LT.W) THEN
         PROB = ZERO
         RETURN
      END IF
      X = T
      Y = T+15
      DO 20 I = 1,199
         G = A*DLOG(R+X+G1*(2*I-1))-R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R+X+G2*I)-R*(X+G2*I)+B
         H2 = H2+E(G)
   20 CONTINUE
      G = A*DLOG(R+X+G1*399)-R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R+X)-R*X+B
      H0 = E(G)
      G = A*DLOG(R+Y)-R*Y+B
      H3 = E(G)
      PROB = ONE-G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   30 IF(T.GT.W) THEN
         PROB = ONE
         RETURN
      END IF
      X = T-15
      Y = T
      DO 40 I = 1,199
         G = A*DLOG(R-X-G1*(2*I-1))+R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R-X-G2*I)+R*(X+G2*I)+B
         H2 = H2+E(G)
   40 CONTINUE
      G = A*DLOG(R-X-G1*399)+R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R-X)+R*X+B
      H0 = E(G)
      G = A*DLOG(R-Y)+R*Y+B
      H3 = E(G)
      PROB = G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   50 PROB = ZERO
      G = -T*T/2
      IF(G.LT.-738.0D0) GO TO 70
      A = 4.2D0
      U = DABS(T)
      IF(U.GT.A) GO TO 60
      E1 = 0.31938153D0
      E2 = -0.356563782D0
      E3 = 1.781477937D0
      E4 = -1.821255978D0
      E5 = 1.330274429D0
      H = 0.2316419D0
      W = ONE/(H*U+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*E(G)/DSQRT(PI*2)
      GO TO 70
   60 B = 2.2D0
      C = 4.9D0
      PROB = E(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   70 IF(T.GT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION E(G)
C
      DOUBLE PRECISION G
C
      E = 0.0D0
      IF(G.GE.-738.0D0) E = DEXP(G)
      RETURN
      END
C
C
      SUBROUTINE CHISQ(T,N,P)
      DOUBLE PRECISION T,ZERO,ONE,V,X,P,PI,PX,A,B,E1,E2,E3,E4,E5,H,W
      ZERO = 0.0D0
      ONE = 1.0D0
      IF(T.LE.ZERO) THEN
         P = ONE
         GO TO 60
      END IF
      IF(N.EQ.1) THEN
         X = DSQRT(T)
         CALL PVN(X,PX)
         P = PX*2
         GO TO 60
      END IF
      V = ONE*N
      IF(V/2-N/2.GT.0.1D0) GO TO 30
      P = DEXP(-T/2)
      IF(N.LT.3) GO TO 60
      K = (N-2)/2
      B = ONE
      DO 20 J = 1,K
         L = J
         A = ONE
         DO 10 I = 1,L
            A = A*T/(2*I)
   10    CONTINUE
         B = B+A
   20 CONTINUE
      P = P*B
      GO TO 60
   30 PI = DATAN(ONE)*4
      E1 = 0.31938153D0
      E2 = -0.356563782D0
      E3 = 1.781477937D0
      E4 = -1.821255978D0
      E5 = 1.330274429D0
      H = 0.2316419D0
      W = ONE/(H*DSQRT(T)+1)
      P = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*DEXP(-T/2)/DSQRT(PI/2)
      IF(N.LT.2) GO TO 60
      K = (N-1)/2
      B = ZERO
      DO 50 J = 1,K
         L = J
         A = ONE
         DO 40 I = 1,L
            A = A*T/(2*I-1)
   40    CONTINUE
         B = B+A
   50 CONTINUE
      P = P+B*DEXP(-T/2)/DSQRT(PI*T/2)
   60 RETURN
      END
C
C
      SUBROUTINE PVN(Z,PROB)
C
C        SUBROUTINE PVALUE CALCULATES THE PROBABILITY OF A VALUE OF
C        Z BEING GREATER THAN OR EQUAL TO THE OBSERVED VALUE OF Z.
C
      DOUBLE PRECISION  Z,PROB,ZERO,ONE,PI,G,A,B,C,EE,H,
     +   U,W,E1,E2,E3,E4,E5
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      PROB = ZERO
      G = -Z*Z/2
      IF(G.LT.-709.1D0) GO TO 20
      A = 4.2D0
      U = DABS(Z)
      IF(U.GT.A) GO TO 10
      E1 =  0.31938153D0
      E2 = -0.356563782D0
      E3 =  1.781477937D0
      E4 = -1.821255978D0
      E5 =  1.330274429D0
      H  =  0.2316419D0
      W  =  ONE/(H*DABS(Z)+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*EE(G)/DSQRT(PI*2)
      GO TO 20
   10 B = 2.2D0
      C = 4.9D0
      PROB = EE(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   20 IF(Z.LT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION EE(G)
C
      DOUBLE PRECISION G
C
      EE = 0.0D0
      IF(G.GE.-709.1D0) EE = DEXP(G)
      RETURN
      END
